//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <sys/stat.h>
//#include <vcl.h>

#include "table.h"

#define MAX_VALUE_LENGTH 256 //l̍ő咷
#define MAX_INTSTR_LENGTH 32 //int̕\̍ő咷
//---------------------------------------------------------------------------
//eLXgt@C̓ǂݏoB 0As-1
__fastcall TStringTable::LoadFromFile(char *file)
{
    int handle;

    handle = open(file,O_RDONLY);
    if(handle == -1)
        return -1;
    BufferMax = read(handle,Buffer,BufferSize);
    if(BufferMax == BufferSize)
        return -1;
    Buffer[BufferMax] = '\0';
    close(handle);
    GetIndex();
    return 0;
}
//---------------------------------------------------------------------------
//eLXgt@Cւ̏oB 0As-1
__fastcall TStringTable::SaveToFile(char *file)
{
    int handle,i,len;
    char c = '\n';

    handle = open(file,O_RDWR|O_CREAT|O_TRUNC,S_IWRITE);
    if(handle == -1)
        return -1;

    for(i=0;i<LineMax;i++){
        len = strlen(Lines[i]);
        write(handle,Lines[i],len); //k^[~l[^͏Ȃ
        write(handle,&c,1);
    }
    close(handle);
    return 0;
}
//---------------------------------------------------------------------------
//es̃CfbNX𓾂BʏLoadFromFilěɂsB
//sƃobt@̉s͑Săk^[~l[^ɒuA
//es̒̈ʒuLines|C^w悤ɂȂB
//iLines[0]͕KBuffer̍ŏwj
//I 0A|C^Ȃꍇ -1
__fastcall TStringTable::GetIndex(void)
{
    char *p;
    int i;

    Lines[0] = Buffer;
    LineMax = 1;
    p = Buffer;
    for(i=0;i<BufferMax;i++){
        if(*p == '\n'){
            *p = '\0';
            p++;
            Lines[LineMax] = p;
            LineMax++;
            if(LineMax == LineSize)
                return -1;
        }
        else
            p++;
    }
    return 0;
}
//---------------------------------------------------------------------------
//̍ŌɈsǉB
//Buffer܂͍s|C^ȂΉ -1
__fastcall TStringTable::Append(char *str)
{
    int len;

    len = strlen(str)+1;
    if(BufferMax+len > BufferSize)
        return -1;
    if(LineMax >= LineSize)
        return -1;
    Lines[LineMax] = &Buffer[BufferMax];
    strcpy(Lines[LineMax], str);
    LineMax++;
    BufferMax += len;
    return 0;
}
//---------------------------------------------------------------------------
//eLXgt@CǂݍŃJeS[̃CfbNX𓾂B
__fastcall TDataTable::LoadFromFile(char *file)
{
    if(access(file,0) == 0){
	    StrList->LoadFromFile(file);
        GetCatIndex();
        return 0;
    }
    else
        return -1;
}
//---------------------------------------------------------------------------
//eLXgt@CɃe[u̓eށB
__fastcall TDataTable::SaveToFile(char *file)
{
	StrList->SaveToFile(file);
    return 0;
}
//---------------------------------------------------------------------------
//JeS̃CfbNX𓾂B
//I 0ACfbNXi[z񂪑Ȃ-1
__fastcall TDataTable::GetCatIndex(void)
{
    char *p;
    int i,len;

    CtMax = 0;
    for(i=0;i<StrList->LineMax;i++){
        p = StrList->Lines[i];
        if(p[0] == '['){
            if(CtMax == CATEGORY_MAX)
                return -1;
            strcpy(CtNames[CtMax], &p[1]);
            len = strlen(CtNames[CtMax]);
            CtNames[CtMax][len-1] = '\0';  //Ō']'͎
            CtLocate[CtMax] = i;
            CtMax++;
        }
    }

/*
    char *p;
    int i,j;

    Lines[0] = Buffer;
    LineMax = 1;
    CtMax = 0;
    p = Buffer;
    for(i=0;i<TABLE_BUFFER;i++){
        if(*p == '\n'){
            *p = '\0';
            p++;
            Lines[LineMax] = p;
            LineMax++;
            if(*p == '['){ //JeSȂL^Ă
                p++;
                j = 0;
                while(*p != '\n')
                    CtNames[CtMax][j++] = *(p++);
                CtNames[CtMax][j-2] = '\0';  //Ō']'͎
                CtMax++;
                //̎_*p͉s̈ʒuȂ̂łЂƂ߂
                p--;
            }
        }
        p++;
    }
*/
    return 0;
}
//---------------------------------------------------------------------------
//e[uɐVJeSݒ肷B
//JeS𕶎񃊃Xg̖ɕtB
//JeSݒ肳Ă鎞AL[̓JeSł̂݉B
__fastcall TDataTable::SetCategory(const char *category)
{
    char str[256];
    sprintf(str,"[%s]",category);
    StrList->Append(str);

    return 0;
}
//---------------------------------------------------------------------------
//w肵JeSw肵ʒuȍ~TB
//߂l̓JeS΂̃CfbNXA -1
//JeSɂ͂CurrentCategoryXVB
__fastcall TDataTable::SearchCategory(const char *category,int index)
{
    int i;

    for(i=index;i<CtMax;i++)
        if(!strcmp(CtNames[i], category)){
            CurrentCategory = i;
            return CtLocate[i];
        }
    return -1;
}
//---------------------------------------------------------------------------
//ǂݏõJeSw肷B
//YJeS΍ŏ̃JeSw肳ꂽ̂ƂB
//߂l̓JeS 0A -1
__fastcall TDataTable::GetCategory(const char *category)
{
    int i;

    i = SearchCategory(category,0);
    if(i != -1){
        CurrentIndex = i;
        return 0;
    }
    else{
        CurrentIndex = 0;
        return -1;
    }
}
//---------------------------------------------------------------------------
//GetCategory()ƈႤ_́Ã݂JeSʒuJeSTƁB
//JeS̃JeSƂʒutłB
//JeSCurrentIndexɂ̒l 0ԂB
//ȂCurrentIndexXV -1ԂB
__fastcall TDataTable::GetSubCategory(const char *category)
{
    int i;

    i = SearchCategory(category,CurrentCategory);
    if(i != -1){
        CurrentIndex = i;
        return 0;
    }
    else
        return -1;
}
//---------------------------------------------------------------------------
/*
//݂̃JeSB
//JeS̏I𕶎񃊃Xg̖ɕtB
__fastcall TDataTable::EndCategory(void)
{
    char str[256];
    int index;

    index = CtCount-1;
    if(index < 0)
        return -1;
    //JeSXg̖̕iŌSetCategory()JeS̖Oj
    //oA폜B
    sprintf(str,"[/%s]", &CtList[CtIndex[index]]);
    StrList->Append(str);
    CtCount--;

    return 0;
}*/
//---------------------------------------------------------------------------
//e[uɐVL[ƒl̃Zbgi[
//ɓL[Ă͓
__fastcall TDataTable::Put(const char *key,const char *value)
{
    char str[MAX_VALUE_LENGTH];

    sprintf(str,"%s=%s",key,value);
    StrList->Append(str);
    return 0;
}
//---------------------------------------------------------------------------
//PutintŁBboolintɃLXgČĂяo΂B
__fastcall TDataTable::Put(const char *key,const int value)
{
    char str[MAX_INTSTR_LENGTH];

    sprintf(str,"%d",value);
    return Put(key,str);
}
//---------------------------------------------------------------------------
//e[uAL[Ƀ}bvꂽloB 0
//lȂ΁A -1
__fastcall TDataTable::Get(const char *key,char *value)
{
    char *line;
    int index,i;

    index = FindKey(key);
    line = StrList->Lines[index];
    if(index != -1){
        i = 0;
        while(line[i] != '=')
            i++;
        strcpy(value,&line[i+1]);
        return 0;
    }
    else
        return -1;
}
//---------------------------------------------------------------------------
//GetintŁB𐔒lɒ
__fastcall TDataTable::Get(const char *key,int *value)
{
    char str[MAX_VALUE_LENGTH];

    if(Get(key,str) != -1){
        *value = atoi(str);
        return 0;
    }
    else
        return -1;
}
//---------------------------------------------------------------------------
//GetboolŁBbooleanlɒ
__fastcall TDataTable::Get(const char *key,bool *value)
{
    char str[MAX_VALUE_LENGTH];
    int i;

    if(Get(key,str) != -1){
        i = atoi(str);
        *value = (i!=0);
        return 0;
    }
    else
        return -1;
}
//---------------------------------------------------------------------------
//intz܂Ƃ߂ĂЂƂ̃L[Ɋ蓖ĂBcountvaluȇ傫B
// 0Bl񂪒Ȃ肷ꍇAs -1
__fastcall TDataTable::PutValues(const char *key,int value[],int count)
{
    char str[MAX_VALUE_LENGTH]="",s[MAX_INTSTR_LENGTH];
    int i,len=0;

    for(i=0;i<count;i++){
        // sprintf()̓G[EOFԂA͍lĂȂB
        len += sprintf(s,"%d,",value[i]);
        if(len >= MAX_VALUE_LENGTH) //̒ȂΎs
            return -1;
        strcat(str,s);
    }
    if(len > 0)
        str[len-1] = '\0'; //Ō̃J}
    return Put(key,str);
}
//---------------------------------------------------------------------------
//intzЂƂ̃L[ǂݍށBcountvaluȇ傫B
//߂l͓ǂݍ񂾒l̐Bs -1
__fastcall TDataTable::GetValues(const char *key,int value[],int count)
{
    char str[MAX_VALUE_LENGTH],s[MAX_INTSTR_LENGTH];
    int i,j,index=0,oldindex=0;

    if(Get(key,str) == -1)
        return -1;
    if(str[0] == '\0')  //󕶎Ȃǂݍ񂾒l̐ 0Ƃ
        return 0;
    for(i=0;i<count;i++){
        while(str[index] != ','){    //J}T
            if(str[index] == '\0'){  //ȂΏI
                count = i+1; //ǂݍ߂L
                break;
            }
            index++;
        }

        //񂪒Ύs
        if(index-oldindex+1 >= MAX_INTSTR_LENGTH-1)
            return -1;
        for(j=oldindex; j<index; j++) //lo
            s[j-oldindex] = str[j];
        s[j-oldindex] = '\0';
        value[i] = atoi(s);
        index++;                    //J}̎̕Ɉړ
        oldindex = index;
    }
    return count;
}
//---------------------------------------------------------------------------
//̕ށBcount ͕̐B
__fastcall TDataTable::PutStrings(const char *key,char *value[],int count)
{
    char str[MAX_VALUE_LENGTH],s[MAX_VALUE_LENGTH];
    int i,len=0;

    for(i=0;i<count;i++){
        len += sprintf(s,"%s,",value[i]);
        if(len >= MAX_VALUE_LENGTH) //̒ȂΎs
            return -1;
        strcat(str,s);
    }
    if(len > 0)
        str[len-1] = '\0'; //Ō̃J}
    return Put(key,str);
}
//---------------------------------------------------------------------------
//̕ǂݍށB
//count ͓ǂݍޕ̍ő吔B
//len ͕̍ő咷ik^[~l[^܂ށjB
__fastcall TDataTable::GetStrings(const char *key,char *value[],int count,int len)
{
    char str[MAX_VALUE_LENGTH];
    int i,index=0,oldindex=0;

    if(Get(key,str) == -1)
        return -1;

    if(str[0] == '\0')  //󕶎Ȃǂݍ񂾒l̐ 0Ƃ
        return 0;
    for(i=0;i<count;i++){
        while(str[index] != ','){    //J}T
            if(str[index] == '\0'){  //ȂΏI
                count = i+1; //ǂݍ߂L
                break;
            }
            index++;
        }

        //񂪒Ύs
        if(index-oldindex+1 >= len-1)
            return -1;
        //Rs[
        str[index] = '\0';
        strcpy(value[i],&str[oldindex]);
        index++;                    //J}̎̕Ɉړ
        oldindex = index;
    }
    return count;
}
//---------------------------------------------------------------------------
//QintЂƂ̃L[Ɋ蓖ĂBzg܂łȂl̃Zbgp
// 0 AsȂ -1
__fastcall TDataTable::PutTwoValues(const char *key,int v1,int v2)
{
    char str[MAX_VALUE_LENGTH];

    sprintf(str,"%d,%d",v1,v2);
    return Put(key,str);
}
//---------------------------------------------------------------------------
//PutTwoValuesŊi[loB 0 AsȂ -1
__fastcall TDataTable::GetTwoValues(const char *key,int *v1,int *v2)
{
    char str[MAX_VALUE_LENGTH];

    if(Get(key,str) == -1)
        return -1;
    if(sscanf(str,"%d,%d",v1,v2) != 2)
        return -1;
    return 0;
}
//---------------------------------------------------------------------------
//ЂƂ̃L[Recti[B 0 AsȂ -1
__fastcall TDataTable::PutRect(const char *key,TRect r)
{
    char str[MAX_VALUE_LENGTH];

    sprintf(str,"%d,%d,%d,%d", r.Left, r.Top, r.Right, r.Bottom);
    return Put(key,str);
}
//---------------------------------------------------------------------------
//PutRectŊi[loB 0 AsȂ -1
__fastcall TDataTable::GetRect(const char *key,TRect *r)
{
    char str[MAX_VALUE_LENGTH];
    int x1,y1,x2,y2;

    if(Get(key,str) == -1)
        return -1;
    if(sscanf(str,"%d,%d,%d,%d", &x1, &y1, &x2, &y2) != 4)
        return -1;
    r->Left = x1;
    r->Top = y1;
    r->Right = x2;
    r->Bottom = y2;
    return 0;
}
//---------------------------------------------------------------------------
//w肳ꂽL[TÃCfbNXԂBȂ -1
//GetCategory()Ŏw肳ĂJeSTB
__fastcall TDataTable::FindKey(const char *key)
{
    char *line;
    int len,i;

    len = strlen(key);

    for(i=CurrentIndex+1; i<StrList->LineMax; i++){
        line = StrList->Lines[i];
        if(!strncmp(line,key,len))
            return i;
        if(line[0] == '[') //JeS̏IĩJeSj
            break;
    }
    return -1;
}
//---------------------------------------------------------------------------
__fastcall TDataTable::GetEntryCategory(char **cat,int len)
{
    int i;

    if(len < CtMax)
        return -1;
    for(i=0;i<CtMax;i++)
        cat[i] = CtNames[i];
    return CtMax;
}
//---------------------------------------------------------------------------
// ̃L[ƒl̃yAoB
// ߂l̓yA0, -1
__fastcall TDataTable::GetNext(char *key,char *value)
{
    char *line;

    if(CurrentIndex >= StrList->LineMax)
        return -1;
    CurrentIndex++;
    line = StrList->Lines[CurrentIndex];
    if(line[0] == '[') //JeS̏IĩJeSj
        return -1;

    int i=0;
    while(line[i] != '='){
        key[i] = line[i];
        i++;
    }
    key[i] = '\0';
    strcpy(value,&line[i+1]);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TDataTable::GetNext(char *key,int *value)
{
    char str[256];

    if(GetNext(key,str) == -1)
        return -1;
    sscanf(str,"%d",value);
    return 0;
}
//---------------------------------------------------------------------------
TLabelTable::TLabelTable(int nodesize,int nodecount)
{
    int i,size;
    size = nodesize*nodecount;
    Buffer = (char *)malloc(size);
    Labels = (char **)malloc(sizeof(char *)*nodecount);
    for(i=0;i<nodecount;i++)
        Labels[i] = Buffer + i*nodesize;
    Max = nodecount;
    Clear();
}
//---------------------------------------------------------------------------
TLabelTable::~TLabelTable()
{
    free(Buffer);
    free(Labels);
}
//---------------------------------------------------------------------------
void TLabelTable::Clear(void)
{
    Count = 0;
}
//---------------------------------------------------------------------------
//xƒl̑gݍ킹o^
int TLabelTable::Add(char *label)
{
    if(Count >= Max)
        return -1;
    strcpy(Labels[Count],label);
    return Count++;
}
//---------------------------------------------------------------------------
//xɊ֘AÂꂽlԂ
int TLabelTable::Get(char *label)
{
    int i;

    for(i=0;i<Count;i++)
        if(!strcmp(Labels[i],label))
            return i;
    return -1;
}
//---------------------------------------------------------------------------

