//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "editgnd.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_Ground *Form_Ground;
//---------------------------------------------------------------------------
__fastcall TForm_Ground::TForm_Ground(TComponent* Owner)
    : TForm(Owner)
{
    GroundNum = -1;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Ground::ChangeEdit_GroundNum(TObject *Sender)
{
    int i;

    //GfBbge荞
    if(GroundNum >= 0){
        if(GroundNum<BUILDINGMAX)
            for(i=0;i<3;i++)
                CopyGroundState(i*BUILDINGMAX+GroundNum);
        else
            CopyGroundState(BUILDINGMAX*2+GroundNum);
    }

    GroundNum = Edit_GroundNum->Text.ToIntDef(0);
    if(GroundNum < 0)
        GroundNum = 0;
    if(GroundNum > GROUNDMAX-1)
        GroundNum = GROUNDMAX-1;
    DrawGround(GroundNum);
}
//---------------------------------------------------------------------------
__fastcall TForm_Ground::DrawGround(int Num)
{
    if(Num >= BUILDINGMAX)
        Num += BUILDINGMAX*2;
    GBWImagep->ImageList_MapN->Draw(Image_Ground->Canvas,0,0,Num);
    Image_Ground->Refresh();
    Edit_GroundName->Text = BaseDatap->MapInfo[Num].Name;
    Edit_GroundShield->Text = BaseDatap->MapInfo[Num].Shield;

    return 0;
}
//---------------------------------------------------------------------------
//\ĂeBaseDataɃRs[
__fastcall TForm_Ground::CopyGroundState(int n)
{
    strcpy(BaseDatap->MapInfo[n].Name, Edit_GroundName->Text.c_str());
    BaseDatap->MapInfo[n].Shield = Edit_GroundShield->Text.ToIntDef(0);
    return 0;
}
//---------------------------------------------------------------------------

