//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#include <wincrypt.h>
#pragma hdrstop

#include "gbw1.h"
#include "version.h"
#include "../common/table.h"
#include "unitlist.h"
#include "seisan.h"
#include "status.h"
#include "option.h"
#include "purpose.h"
#include "gbwstart.h"
#include "gbwend.h"

#define VERSION "1.461"

#define DEMAND_NONE     0 //^C}[CxgŎsR}h
#define DEMAND_OPEN     1
#define DEMAND_SAVE     2
#define DEMAND_LOAD     3
#define DEMAND_REMOTE   4
#define DEMAND_LOADMAIL 5

//EO̕`搧A(x,y)ʒuEOǂ𒲂ׂ鎮
#define OutsideVisible(x,y) (ApplyShade && Map->Shade[x][y])

#define DEBUG_SHADE (Debug_Shade && Situation->Phase)

HHOOK TForm1::hHook;
bool TForm1::RButtonDowned;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cgauges"
#pragma resource "*.dfm"
TForm1 *Form1;
TForm_seisan *Form_seisanp;
TForm_Status *Form_Statusp;
TForm_UnitList *Form_UnitListp;

//---------------------------------------------------------------------------
static void PrintLog(char *file,char *line)
{
    FILE *fp;

    fp = fopen(file,"a");
    if(!fp)
        return;
    fprintf(fp,"%s\n",line);
    fclose(fp);
}
//---------------------------------------------------------------------------
//EBhEbZ[WtbN֐B
//ςӖȂ̂Win32 SDKwv̊ێʂB
LRESULT CALLBACK TForm1::GetMsgProc(int nCode,WPARAM wParam,LPARAM lParam)
{
    if(nCode < 0){
        //bZ[W̃vZXɃpXȂ΂ȂB
        return CallNextHookEx(hHook,nCode,wParam,lParam);
    }
    else if(nCode != HC_ACTION){
        //̎ nCode == HC_NOREMOVE ł͂B
        //vZXPeekMessage()ɂăbZ[W擾ȂǂāA
        //bZ[WL[烁bZ[W菜Ȃ̏ɂȂB
        //̊֐̖߂l0ȊOȂ炱̃bZ[WĂƂӖɂȂB
        return 0;
    }

    MSG *msg = (MSG *)lParam;

    if(msg->message == WM_RBUTTONDOWN){
        RButtonDowned = true;
        return 1;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    int i;

    //wv̊ێʂB
    hHook = SetWindowsHookEx(
        WH_GETMESSAGE,
        (HOOKPROC)GetMsgProc, //֐|C^BDLL̊֐w肷邱ƂB
        0,                    //AvP[VCX^XnhB
        GetCurrentThreadId()  //XbhhcB
        );

    NowRunning=true;
    if(!GetCurrentDirectory(sizeof BasePath,BasePath))
        BasePath[0] = '\0';
    DrawedStatusUnit=-1;

    Option.Initialize();
    Option.Load();

    Form_seisanp=new TForm_seisan(this);

    Form_Statusp=new TForm_Status(this);

    Form_UnitListp=new TForm_UnitList(this);
    Form_UnitListp->Form1p=Form1;

    Map=new MapData();
    Form_Statusp->Mapp=Map;

    GBWImage=new GBWImageData();
    Form_seisanp->GBWImageDatap=GBWImage;
    Form_UnitListp->GBWImageDatap=GBWImage;

    FieldScreen1=new FieldScreen(Option.EconomyMode);
    FieldScreen1->DefineImageList(GBWImage,0);
    SetEconomyMode(Option.EconomyMode);
    Form_seisanp->FieldScreenp=FieldScreen1;

    BaseData1=new BaseData();
    Form_seisanp->BaseDatap=BaseData1;
    Form_UnitListp->BaseDatap=BaseData1;
    Form_Statusp->BaseDatap=BaseData1;

    for(i=0;i<2;i++){
        SideStatus1[i]=new SideStatus(i);
        SideStatus1[i]->CalcIncome(Map,BaseData1);
        Form_Statusp->SideStatusp[i]=SideStatus1[i];
        FieldScreen1->SideStatusp[i]=SideStatus1[i];

        Purposes1[i]=new GamePurposes();
        Form_Statusp->Purposesp[i]=Purposes1[i];
    }
    Situation=new GameSituation();
    MailPlayerList = new TMailPlayerList(BasePath,&Option.MailUser);
    Form_Mail = new TForm_Mail(this);
    Form_Mail->MailPlayerList = MailPlayerList;

//    BaseData1->DataLoad(UNITFILE);
    BaseData1->ReadStandard();
    MapSizeSet();
    ImageLoad();
    FieldScreen1->DrawMap(Map,false);
    ScreenReviseAll();

    FieldScreen1->ZOCMode=Option.ZOCMode;
    ApplyShade = false;
    Debug_Shade = false;
    Debug_Check = false;
    MoneyOperation(0,0);
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1(void)
{
    UnhookWindowsHookEx(hHook);

    delete Form_seisanp;
    delete Form_Statusp;
    delete Form_UnitListp;
    delete Map;
    delete GBWImage;
    delete FieldScreen1;
    delete BaseData1;
    delete SideStatus1[0];
    delete SideStatus1[1];
    delete Purposes1[0];
    delete Purposes1[1];
    delete Situation;
    delete MailPlayerList;
    delete Form_Mail;
    NowRunning=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Show(TObject *Sender)
{
    Option.Load();
    Option.GetWindowState(&Option.WindowState_gbw, this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Close(TObject *Sender, TCloseAction &Action)
{
    Option.SetWindowState(&Option.WindowState_gbw, this);
    Option.Save();
    System.NowDemand=DEMAND_NONE;
    System.StopDemand=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Resize(TObject *Sender)
{
    ScrollBox1->Width=ClientWidth-RIGHTSPACE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch(Key){
    case VK_LEFT:
        ScrollBox1->HorzScrollBar->Position -= FieldScreen1->GraphDegree;
        break;
    case VK_UP:
        ScrollBox1->VertScrollBar->Position -= FieldScreen1->GraphDegree;
        break;
    case VK_RIGHT:
        ScrollBox1->HorzScrollBar->Position += FieldScreen1->GraphDegree;
        break;
    case VK_DOWN:
        ScrollBox1->VertScrollBar->Position += FieldScreen1->GraphDegree;
        break;
    case VK_F8:  // f.8
        ShowMessage("BR}hFُ팟o[hɓ܂B");
        Debug_Check = true;
        break;
    case VK_F9: // vf.9
        ShowMessage("BR}hFGfobO[hɓ܂B");
        Debug_Shade = true;
        break;
    case VK_F10: // f.10
        // IɉʑŜXVB
        UpdateShade();
        DrawAll();
        ScreenReviseAll();
        break;
    case VK_F11: // f11(vf.1)
        Situation->CPUMode[0] = !Situation->CPUMode[0];
        break;
    case VK_F12: // f12(vf.2)
        Situation->CPUMode[1] = !Situation->CPUMode[1];
        break;
    }
    if(Shift * (TShiftState()<<ssCtrl) != TShiftState()){
        switch(Key){
        case 'E':
        case 'e':
            if(PhaseEnd->Enabled)
                PhaseEndClick(Sender);
            break;
        case 'J':
        case 'j':
            if(Status->Enabled)
                StatusClick(Sender);
            break;
        case 'L':
        case 'l':
            if(MILoad->Enabled)
                MILoadClick(Sender);
            break;
        case 'N':
        case 'n':
            if(MIOpen->Enabled)
                MIOpenClick(Sender);
            break;
        case 'M':
        case 'm':
            if(More->Enabled)
                MoreClick(Sender);
            break;
        case 'S':
        case 's':
            if(MISave->Enabled)
                MISaveClick(Sender);
            break;
        case 'U':
        case 'u':
            if(UnitList->Enabled)
                UnitListClick(Sender);
            break;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnImage1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    int zx,zy;

    if(!System.Controlable) //EFCgĂ鎞
        return;
    if(System.CPUControl) //CPU삵ĂŒ
        return;
    if(Timer1->Enabled) //CPUɐ؂ւ̂҂Ă鎞
        return;
    if(Option.ShowRange){
        ClearUnitRange();
        PopupMenu1->AutoPopup=false;
        return;
    }
    System.MouseX = X;
    System.MouseY = Y;

    FieldScreen1->XY_PhyToMap(Map,X,Y,&zx,&zy);
    switch(Button){
    case (TMouseButton)mbLeft:
        MouseLeftDown(zx,zy);
        break;
    case (TMouseButton)mbRight:
        if(!System.PhaseEndable)
            PopupMenu1->AutoPopup=false;
        else
            if(!PopupMenu1->AutoPopup)
                PopupMenu1->AutoPopup=true;
        MouseRightDown(zx,zy);
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnImage1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    int zx,zy;

    //E{^tONAꏊ炢vȂB
    //PopupMenuł͂̃Cxg͋NȂ͂Ȃ͂B
    RButtonDowned = false;
    FieldScreen1->XY_PhyToMap(Map,X,Y,&zx,&zy);
    if(System.RadiusCursor > 0){
        EraseAttackRadius();
        if(Map->RangePoint[zx][zy]){
            if(System.SuperMissile)
                DrawAttackRadius(System.TargetX,System.TargetY,System.RadiusCursor);
            else
                DrawAttackRadius(zx,zy,System.RadiusCursor);
        }
    }
    MapChipStatusPut(zx,zy);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIOpenClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_OPEN;
            return;
        }
    if(OpenDialog1->Execute())
        LoadMap(OpenDialog1->FileName.c_str(), false);
    else
        if(System.CPUControl)
            Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MISaveClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_SAVE;
            return;
        }
    if(!System.PhaseEndable){
        ShowMessage("Z[uł܂BĉB\n");
        return;
    }
    if(SaveNameDialog())
        SaveGame(System.SaveFile);
    if(System.CPUControl)
        Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MILoadClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_LOAD;
            return;
        }
    if(LoadNameDialog())
        LoadGame(System.SaveFile);
    else
        if(System.CPUControl)
            Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MINewRemoteClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_REMOTE;
            return;
        }
    if(OpenDialog1->Execute())
        LoadMap(OpenDialog1->FileName.c_str(), true);
    else
        if(System.CPUControl)
            Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MILoadMailClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_LOADMAIL;
            return;
        }
    Form_Mail->ShowLoadGame();
    if(Form_Mail->Result)
        LoadGame(Form_Mail->StartFileName);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIExitClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
//󋵕\
void __fastcall TForm1::StatusClick(TObject *Sender)
{
    char str[30];

    sprintf(str,"%3d^[",Situation->Turn);
    Form_Statusp->LabelTurn->Caption=str;

    sprintf(str,"jbgF%3d",Situation->UnitMax);
    Form_Statusp->Label_UnitMax->Caption=str;

    Form_Statusp->PutStatus(GBWImage,Situation->CPUMode);
    Form_Statusp->ShowModal();
}
//---------------------------------------------------------------------------
//쌟
void __fastcall TForm1::MoreClick(TObject *Sender)
{
    if(NowLookup >= SideStatus1[Situation->Phase]->UnitCount)
        NowLookup = 0;
    else
        NowLookup++;
    NowLookup *= NowLookup>0;

    NowLookup = SideStatus1[Situation->Phase]->SearchNoActioned(NowLookup);
    if(NowLookup != -1)
        ShowLookup(NowLookup);
    else
        ShowMessage("s\ȃjbg͌܂ł");
}
//---------------------------------------------------------------------------
//tFCYI
void __fastcall TForm1::PhaseEndClick(TObject *Sender)
{
    char path[MAX_PATH],address[256];

    if(!System.PhaseEndable || Option.ShowRange){
        ShowMessage("tFCYIł܂BĉB\n");
        return;
    }
    strcpy(address, SideStatus1[!Situation->Phase]->MailAddress);
    if(address[0] != '\0'){
        if(MessageDlg("tFCYIă[𑗐M܂H\nMQ[͒~AVKQ[[hsKv܂B", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)!=mrYes)
            return;
        //tFCYIāAꎞt@CɃZ[uB
        PhaseEndExec(true);
        MailPlayerList->GetFolderPath("tmp.sav",path);
        SaveGame(path);
        Form_Mail->ShowSendMail(Map->Name, address);
        GameOperationEnabled(false);
    }
    else{
        if(MessageDlg("tFCYI܂B", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)==mrYes)
            PhaseEndExec(false);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VersionClick(TObject *Sender)
{
    char str[100];

    sprintf(str,"ǒn헪@Ver.%s\nŐVo[W\n%s",VERSION,WEBSITE);
    ShowMessage(str);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OptionAClick(TObject *Sender)
{
    TForm_Option *Form_Optionp=new TForm_Option(this);

    Form_Optionp->HideMail();
    Form_Optionp->TrackBar_DamageWaitFix->Position=Option.DamageWaitFix;
    Form_Optionp->TrackBar_LookUpWaitFix->Position=Option.LookUpWaitFix;
    Form_Optionp->TrackBar_CPUWaitFix->Position=Option.CPUWaitFix;
    Form_Optionp->CheckBox_CPUScroll->Checked = Option.CPUScroll;
    Form_Optionp->CheckBox_Sound->Checked     = Option.CPUSound;
    Form_Optionp->CheckBox_CPUNoGrp->Checked  = Option.CPUNoGrp;
    Form_Optionp->CheckBox_UnitListNoModal->Checked = Option.UnitListNoModal;
    Form_Optionp->CheckBox_DamageFix->Checked = Option.DamageFix;
    Form_Optionp->CheckBox_ZOCMode->Checked   = Option.ZOCMode;
    Form_Optionp->CheckBox_Economy->Checked   = Option.EconomyMode;
    Form_Optionp->CheckBox_IgnoreLife->Checked = Option.IgnoreLife;
    Form_Optionp->Edit_Name->Text       = Option.MailUser.Name;
    Form_Optionp->Edit_Mail->Text       = Option.MailUser.Address;
    Form_Optionp->Edit_Reply->Text      = Option.MailUser.ReplyAddress;
    Form_Optionp->Edit_POPServer->Text  = Option.MailUser.POPServer;
    Form_Optionp->Edit_POPUser->Text    = Option.MailUser.POPUser;
    Form_Optionp->Edit_POPPass->Text    = Option.MailUser.POPPass;
    Form_Optionp->Edit_SMTPServer->Text = Option.MailUser.SMTPServer;
    Form_Optionp->Edit_SMTPUser->Text   = Option.MailUser.SMTPUser;
    Form_Optionp->CheckBox_SaveMessage->Checked = Option.MailUser.SaveMessage;
    Form_Optionp->ShowModal();

    if(Form_Optionp->Result){
        Option.DamageWaitFix = Form_Optionp->TrackBar_DamageWaitFix->Position;
        Option.LookUpWaitFix = Form_Optionp->TrackBar_LookUpWaitFix->Position;
        Option.CPUWaitFix    = Form_Optionp->TrackBar_CPUWaitFix->Position;
        Option.CPUScroll = Form_Optionp->CheckBox_CPUScroll->Checked;
        Option.CPUSound  = Form_Optionp->CheckBox_Sound->Checked;
        Option.CPUNoGrp  = Form_Optionp->CheckBox_CPUNoGrp->Checked;
        Option.UnitListNoModal = Form_Optionp->CheckBox_UnitListNoModal->Checked;
        Option.DamageFix = Form_Optionp->CheckBox_DamageFix->Checked;
        Option.ZOCMode   = Form_Optionp->CheckBox_ZOCMode->Checked;
        Option.EconomyMode = Form_Optionp->CheckBox_Economy->Checked;
        Option.IgnoreLife = Form_Optionp->CheckBox_IgnoreLife->Checked;
        strcpy(Option.MailUser.Name, Form_Optionp->Edit_Name->Text.c_str());
        strcpy(Option.MailUser.Address, Form_Optionp->Edit_Mail->Text.c_str());
        if(Form_Optionp->Edit_Reply->Text.IsEmpty())
            strcpy(Option.MailUser.ReplyAddress, Option.MailUser.Address);
        else
            strcpy(Option.MailUser.ReplyAddress, Form_Optionp->Edit_Reply->Text.c_str());
        strcpy(Option.MailUser.POPServer, Form_Optionp->Edit_POPServer->Text.c_str());
        strcpy(Option.MailUser.POPUser,   Form_Optionp->Edit_POPUser->Text.c_str());
        strcpy(Option.MailUser.POPPass,   Form_Optionp->Edit_POPPass->Text.c_str());
        strcpy(Option.MailUser.SMTPServer, Form_Optionp->Edit_SMTPServer->Text.c_str());
        strcpy(Option.MailUser.SMTPUser,   Form_Optionp->Edit_SMTPUser->Text.c_str());
        Option.MailUser.SaveMessage = Form_Optionp->CheckBox_SaveMessage->Checked;
        FieldScreen1->ZOCMode=Option.ZOCMode;
        Option.Save();
        if(!Option.UnitListNoModal && Form_UnitListp->Visible)
            Form_UnitListp->Close();
    }
    delete Form_Optionp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShowHelpClick(TObject *Sender)
{
    Application->HelpJump("");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GraphNormalClick(TObject *Sender)
{
    UnitStatus *Unitp;

    if(!System.PhaseEndable){
        ShowMessage("쒆͐؂ւł܂B\n");
        SpeedButton_GraphNormal->Down=GraphNormal->Checked;
        SpeedButton_GraphSmall->Down=GraphSmall->Checked;
        return;
    }
    FieldScreen1->DefineImageList(GBWImage,0);
    MapSizeSet();
    DrawAll();
    if(Option.ShowRange){ //˒\Ȃ`悵
        Unitp=&SideStatus1[Option.SelectedSide]->Unit[Option.SelectedUnit];
        FieldScreen1->RangePut(Map,CURSOR_ATTACK,NULL,-1,false,false);
        FieldScreen1->CursorPutZ(Unitp->X,Unitp->Y,CURSOR_LOOKUP);
    }
    ScreenReviseAll();
    GraphNormal->Checked=true;
    GraphSmall->Checked=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GraphSmallClick(TObject *Sender)
{
    UnitStatus *Unitp;

    if(!System.PhaseEndable){
        ShowMessage("쒆͐؂ւł܂B\n");
        SpeedButton_GraphNormal->Down=GraphNormal->Checked;
        SpeedButton_GraphSmall->Down=GraphSmall->Checked;
        return;
    }
    FieldScreen1->DefineImageList(GBWImage,1);
    MapSizeSet();
    DrawAll();
    if(Option.ShowRange){ //˒\Ȃ`悵
        Unitp=&SideStatus1[Option.SelectedSide]->Unit[Option.SelectedUnit];
        FieldScreen1->RangePut(Map,CURSOR_ATTACK,NULL,-1,false,false);
        FieldScreen1->CursorPutZ(Unitp->X,Unitp->Y,CURSOR_LOOKUP);
    }
    ScreenReviseAll();
    GraphNormal->Checked=false;
    GraphSmall->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuGraphNormalClick(TObject *Sender)
{
    SpeedButton_GraphNormal->Click();
    SpeedButton_GraphNormal->Down=GraphNormal->Checked;
    SpeedButton_GraphSmall->Down=GraphSmall->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuGraphSmallClick(TObject *Sender)
{
    SpeedButton_GraphSmall->Click();
    SpeedButton_GraphNormal->Down=GraphNormal->Checked;
    SpeedButton_GraphSmall->Down=GraphSmall->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_LoadingMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    UnitStatus *unitp;
    int i,j,index,num;

    if(System.MovingUnit!=-1)
        num=System.MovingUnit;
    if(System.HoldUnit!=-1)
        num=System.HoldUnit;
    if(num==-1){
        //ShowMessage("ړĨjbg𑀍쒆ɉĉB");
        return;
    }
    unitp = &SideStatus1[Situation->Phase]->Unit[num];
    if(System.SelectedLoading == -1){
        i = Y/36;
        if(i >= unitp->Load)
            return;
        System.SelectedLoading = i;
    }
    else{
        i = Y/36;
        if(i >= unitp->Load)
            return;
        j = System.SelectedLoading;
        index = unitp->LoadingUnit[j];
        unitp->LoadingUnit[j] = unitp->LoadingUnit[i];
        unitp->LoadingUnit[i] = index;
        System.SelectedLoading = -1;
    }
    LoadStatusPut(Situation->Phase,num);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Panel1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    int n=-1;

    if(System.MovingUnit!=-1)
        n=System.MovingUnit;
    if(System.HoldUnit!=-1)
        n=System.HoldUnit;
    if(n==-1 || n==DrawedStatusUnit)
        return;
    UnitStatusPut(Situation->Phase,n);
    DrawedStatusUnit=n;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UnitListClick(TObject *Sender)
{
    Form_UnitListp->Side=Situation->Phase;
    Form_UnitListp->SideStatusp=SideStatus1[Situation->Phase];
    Form_UnitListp->MakeList();
    Form_UnitListp->NoModal=Option.UnitListNoModal;
    if(Option.UnitListNoModal)
        Form_UnitListp->Show();
    else
        Form_UnitListp->ShowModal();
    if(!Option.UnitListNoModal && Form_UnitListp->Result)
        ShowLookup(Form_UnitListp->UnitIndex);
}
//---------------------------------------------------------------------------
//botJn
void __fastcall TForm1::OnTimer1(TObject *Sender)
{
    if(!Timer1->Enabled)
        return; //^C}[Cxg܂Ă܂HÔ߁B
    if(Application->Active && !Form1->Active)
        return; //̃tH[ɃtH[JXΑ҂
    Timer1->Enabled=false;
    ComputerControl();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::KillUnitClick(TObject *Sender)
{
    int zx,zy;

    UnitXY(Situation->Phase,Option.SelectedUnit,&zx,&zy);
    FieldScreen1->CursorPutZ(zx,zy,CURSOR_LOOKUP);
    ScreenReviseBlock(zx,zy);
    if(MessageDlg("w肳ꂽjbg܂B", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)==mrYes)
        DisposalUnit(Situation->Phase,Option.SelectedUnit);
    else{
        FieldScreen1->UnitPutAuto(Map,SideStatus1[Situation->Phase],zx,zy,false);
        ScreenReviseBlock(zx,zy);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShowRangeClick(TObject *Sender)
{
    ShowUnitRange(Option.SelectedSide,Option.SelectedUnit);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ClickMenuItem_Gun0(TObject *Sender)
{
    ReceiveGunMenu(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ClickMenuItem_Gun1(TObject *Sender)
{
    ReceiveGunMenu(1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ClickMenuItem_DownUnit(TObject *Sender)
{
    ReceiveGunMenu(2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ClickMenuItem_NoAction(TObject *Sender)
{
    ReceiveGunMenu(3);
}
//---------------------------------------------------------------------------
__fastcall TForm1::ImageLoad(void)
{
    GBWImage->Load(GetDeviceCaps(Canvas->Handle,BITSPIXEL));
    return 0;
}
//---------------------------------------------------------------------------
//FieldScreeñrbg}bvImage1ɓ]
__fastcall TForm1::ScreenReviseAll(void)
{
    int w,h;

    if(!NowRunning)
        return 0;
    if(EconomyMode){
        Image1->Repaint();
        return 0;
    }
    w=Image1->Width;
    h=Image1->Height;
    if(FieldScreen1->RectX1+w > FieldScreen1->Bitmap->Width){
        Image1->Canvas->Brush->Color=clBlack;
        Image1->Canvas->FillRect(Rect(FieldScreen1->Bitmap->Width-FieldScreen1->RectX1,0,w,h));
    }
    if(FieldScreen1->RectY1+h > FieldScreen1->Bitmap->Height){
        Image1->Canvas->Brush->Color=clBlack;
        Image1->Canvas->FillRect(Rect(0,FieldScreen1->Bitmap->Height-FieldScreen1->RectY1,w,h));
    }
    Image1->Canvas->CopyRect(Rect(0,0,w,h),FieldScreen1->Bitmap->Canvas,Rect(FieldScreen1->RectX1,FieldScreen1->RectY1,FieldScreen1->RectX1+w,FieldScreen1->RectY1+h));
    return 0;
}
//---------------------------------------------------------------------------
//}bv摜̈ꕔXV
__fastcall TForm1::ScreenRevise(int x1,int y1,int x2,int y2)
{
    ScreenRevise(Rect(x1,y1,x2,y2));
    return 0;
}
//---------------------------------------------------------------------------
//}bv摜̈ꕔXViRectŁj
__fastcall TForm1::ScreenRevise(TRect Rect1)
{
    if(System.NoDraw) //\ʏ`悪Ȃ
        return 0;
    if(EconomyMode)
        Image1->Repaint();
//        Image1->Refresh();
    else
        Image1->Canvas->CopyRect(Rect1,FieldScreen1->Bitmap->Canvas,Rect1);
    return 0;
}
//---------------------------------------------------------------------------
//}bv摜PubNXVi_WŎwj
__fastcall TForm1::ScreenReviseBlock(int zx,int zy)
{
    int x,y;

    FieldScreen1->XY_MapToPhy(zx,zy,&x,&y);
    ScreenRevise(Rect(x,y,x+FieldScreen1->GraphDegree,y+FieldScreen1->GraphDegree));
    return 0;
}
//---------------------------------------------------------------------------
//}bvt@CǂŃQ[JnB
__fastcall TForm1::LoadMap(char *file, bool bRemote)
{
    TForm_Start *Form_Startp;
    TDataTable *table;
    char str[100],key[100],c;
    int handle,i,j,uType,uGraph,zx,zy,Money[2]={0,0};

    System.CPUControl=false;
    Map->Initialize();

    //o[W̃t@Cǂ𔻕
    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,&c,1);
    close(handle);
    if(c != '[')
        LoadMapBinary(file); //oCit@Cꍇ
    else{
        table = new TDataTable();
        table->LoadFromFile(file); //eLXgt@Cꍇ

        for(i=0;i<2;i++)
            SideStatus1[i]->Initialize();
        Map->ReadTextCompact(table); //MapDataNX̓eo

        //ǂ
        for(i=0;i<2;i++){
            sprintf(key,"%s%d",KEY_BEGINMONEY,i);
            table->Get(key,&Money[i]);
        }

        //jbgzu
        for(i=0;i<2;i++){
            sprintf(key,"%s%d",CTG_UNITS,i);
            table->GetCategory(key);
            for(j=0; j<UNITMAX; j++){ //jbg̋Lqǂݍ
                sprintf(key,"%s%d",KEY_UNITTYPE,j);
                if(table->Get(key,&uType) == -1) //LqΏI
                    break;
                sprintf(key,"%s%d",KEY_UNITXY,j);
                table->GetTwoValues(key,&zx,&zy);
                uGraph = i*UNITTYPEMAX+uType;
                SideStatus1[i]->AddUnit(BaseData1,zx,zy,uGraph);
                SideStatus1[i]->Unit[j].Actioned=false;
                if(Map->Data[zx][zy].Side == -1){
                    Map->Data[zx][zy].Side=(char)i;
                    Map->Data[zx][zy].Unit=(char)j;
                }
                else{
                    SideStatus1[i]->LoadUnit(Map->Data[zx][zy].Unit,j);
                }
            }
        }
        delete table;
    }

    System.Initialize();
    Situation->Initialize();
    if(bRemote){
        Form_Mail->ShowStartGame();
        strcpy(SideStatus1[0]->MailAddress, Option.MailUser.ReplyAddress);
        strcpy(SideStatus1[0]->PlayerName, Option.MailUser.Name);
        strcpy(SideStatus1[1]->MailAddress, Form_Mail->SelectedPlayer->Address);
        strcpy(SideStatus1[1]->PlayerName, Form_Mail->SelectedPlayer->Name);
    }
    Form_Startp = new TForm_Start(this);
    Form_Startp->BaseDatap = BaseData1;
    for(i=0;i<2;i++)
        Form_Startp->Purposesp[i] = Purposes1[i];
    Form_Startp->RadioGroup_Blue->Caption = "vC[";
    Form_Startp->RadioGroup_Red->Caption  = "ԃvC[";
    Form_Startp->Button_Purpose1->Enabled = (bool)Purposes1[0]->Enabled();
    Form_Startp->Button_Purpose2->Enabled = (bool)Purposes1[1]->Enabled();
    Form_Startp->Edit_Path->Text = Map->UnitDataFile;
    if(bRemote){
        Form_Startp->RadioGroup_Blue->Items->SetText("\n");
        Form_Startp->RadioGroup_Red->Items->SetText("\n");
        Form_Startp->RadioGroup_Blue->Enabled = false;
        Form_Startp->RadioGroup_Red->Enabled = false;
    }
    Form_Startp->ShowModal();
    if(!bRemote){
        Situation->CPUMode[0] = (Form_Startp->RadioGroup_Blue->ItemIndex==1);
        Situation->CPUMode[1] = (Form_Startp->RadioGroup_Red->ItemIndex==1);
    }
    else
        Situation->CPUMode[1] = false;
    Situation->UnitMax = 40+Form_Startp->RadioGroup_UnitMax->ItemIndex*10;
        //RadioGroup_UnitMaxItems4010݂łƂB
    strcpy(Map->UnitDataFile, Form_Startp->Edit_Path->Text.c_str());
        //gjbgt@CRs[
    for(i=0;i<2;i++)
        SideStatus1[i]->LimitView = Form_Startp->CheckBox_Tekisaku->Checked;
    delete Form_Startp;

    if(BaseData1->ReadUser(Map->UnitDataFile)!=-1)
        GBWImage->LoadUserExtend(BaseData1->UserBitmapFile,BaseData1->Sides,BaseData1->UnitGrpGet);

    for(i=0;i<2;i++){ //zujbg̔REe𖞃^ɂB
        SideStatus1[i]->Money = 1000000;
        SideStatus1[i]->SupplySetUnit(BaseData1);
        SideStatus1[i]->Money = Money[i];
    }

    MapSizeSet();

    for(i=0;i<2;i++)
        SideStatus1[i]->CalcIncome(Map,BaseData1);
    PhaseStart();
    if(SideStatus1[Situation->Phase]->LimitView)
        FieldScreen1->FindVisibleAll(Map,BaseData1,SideStatus1[Situation->Phase]);
    else
        Map->InitVisible(1);

    DrawAll();
    ScreenReviseAll();
    CheckCreatable(true);   //Y\n_̃`FbN

    sprintf(str,"ǒn헪@%s",Map->Name);
    Form1->Caption=str;
    if(Option.UnitListNoModal && Form_UnitListp->Visible)
        Form_UnitListp->MakeList();

    GameOperationEnabled(true);
    if(Situation->CPUMode[Situation->Phase]){
        PhaseEndEnabled(false);
        MoreEnabled(false);
        Timer1->Enabled=true;
    }
    else{
        PhaseEndEnabled(true);
        MoreEnabled(true);
        Timer1->Enabled=false;
    }
    return 0;
}
//---------------------------------------------------------------------------
//oCĩ}bvt@CǂށB
//ߋւ̌݊̂߂ɌÂR[hcĂ邾Ȃ̂
//ł邾ύXȂƁB
__fastcall TForm1::LoadMapBinary(char *file)
{
    VersionControl Version1;
    char str[100];
    bool SetUnit=false,SetPurposes,UnitExtend=false,BeginMoney=false;
    short s;
    int handle,h,i,j,k,Graph,x,y,zx,zy,v1,v2,Money[2]={0,0};

    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,str,(sizeof MAPVERHEAD)-1);
    str[(sizeof MAPVERHEAD)-1]='\0';
    if(strcmp(str,MAPVERHEAD)){
        ShowMessage("ǒn헪̃}bvł͂܂B\n");
        close(handle);
        return -1;
    }
    read(handle,str,VERSIONLENGTH+1);
    v1=Version1.StrToValue(str);
    v2=Version1.StrToValue(MAPVERSION);
    if(v1>v2){
        ShowMessage("}bv`̃o[WႢ܂B\n");
        close(handle);
        return -1;
    }
    Map->Initialize();
    for(i=0;i<2;i++)
        SideStatus1[i]->Initialize();
    read(handle,Map->Name,sizeof Map->Name);
    read(handle,&Map->Width,sizeof Map->Width);
    read(handle,&Map->Height,sizeof Map->Height);
    if(v1<102){
        for(y=0;y<MAPHEIGHT_OLD;y++)
            for(x=0;x<MAPWIDTH_OLD;x++)
                read(handle,&Map->Data[x][y].Graph,1);
    }
    else
        for(y=0;y<Map->Height;y++)
            for(x=0;x<Map->Width;x++)
                read(handle,&Map->Data[x][y].Graph,1);

    i=read(handle,&SetUnit,sizeof SetUnit);
    if(i && (int)SetUnit==1)  //jbgzu
        for(i=0;i<2;i++){
            read(handle,&s,sizeof s);
            k=s;  //UnitCount
            if(v1<102) //ڍׂgbwedit1.cppMapLoad()Q
                h=UNITMAX_OLD;
            else
                h=k;
            for(j=0;j<h;j++){
                read(handle,&s,sizeof s);
                Graph=i*UNITTYPEMAX+s;
                read(handle,&s,sizeof s);
                zx=s;
                read(handle,&s,sizeof s);
                zy=s;
                if(j<k){
                    SideStatus1[i]->AddUnit(BaseData1,zx,zy,Graph);
                    SideStatus1[i]->Unit[j].Actioned=false;
                    if(Map->Data[zx][zy].Side == -1){
                        Map->Data[zx][zy].Side=(char)i;
                        Map->Data[zx][zy].Unit=(char)j;
                    }
                    else{
                        SideStatus1[i]->LoadUnit(Map->Data[zx][zy].Unit,j);
                    }
                }
            }
        }

    i=read(handle,&SetPurposes,sizeof SetPurposes);
    if(i && SetPurposes)  //BڕW
        for(i=0;i<2;i++)
            Purposes1[i]->Read(handle);
    else
        for(i=0;i<2;i++)
            Purposes1[i]->Initialize();

    i=read(handle,&UnitExtend,sizeof UnitExtend);
    if(i && UnitExtend) //jbgf[^t@C
        read(handle,Map->UnitDataFile,sizeof Map->UnitDataFile);

    i=read(handle,&BeginMoney,sizeof BeginMoney);
    if(i && BeginMoney){ //
        read(handle,&Money[0],sizeof(int));
        read(handle,&Money[1],sizeof(int));
    }

    close(handle);

    if(v1<v2)
        Map->VersionConvert(v1);

    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SaveNameDialog(void)
{
    bool r;

    SaveDialog2->FileName=System.SaveFile;
    r=SaveDialog2->Execute();
    if(r)
        strcpy(System.SaveFile,SaveDialog2->FileName.c_str());
    return r;
}
//---------------------------------------------------------------------------
__fastcall TForm1::LoadNameDialog(void)
{
    bool r;

    OpenDialog2->FileName=System.SaveFile;
    r=OpenDialog2->Execute();
    if(r)
        strcpy(System.SaveFile,OpenDialog2->FileName.c_str());
    return r;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SaveGame(char *file)
{
/*
    int i,handle;

    handle=open(file,O_BINARY|O_RDWR|O_TRUNC|O_CREAT,S_IWRITE);
    if(handle==-1)
        return -1;
    write(handle,SAVEVERHEAD,(sizeof SAVEVERHEAD)-1);
    write(handle,SAVEVERSION,sizeof SAVEVERSION);
    Map->Write(handle);
    SideStatus1[0]->Write(handle);
    SideStatus1[1]->Write(handle);
    Situation->Write(handle);
    write(handle,Option.CPUMode,sizeof Option.CPUMode); //슄蓖Ă̏Ԓǉ(Save Type 1.03-)
    for(i=0;i<2;i++)
        Purposes1[i]->Write(handle); //BڕWǉ
                              //B󋵋L^
    close(handle);
*/
    TDataTable *table = new TDataTable();
    char ctg[50];
    int i;

    table->SetCategory(CTG_SAVEPROPERTY);
    table->Put(KEY_SAVEVERSION, SAVEVERNUMBER);

    table->SetCategory(CTG_SITUATION);
    Situation->WriteText(table);

    table->SetCategory(CTG_MAPDATA);
    Map->WriteText(table);

    for(i=0;i<2;i++){
        sprintf(ctg,"%s%d",CTG_SIDESTATUS,i);
        table->SetCategory(ctg);
        SideStatus1[i]->WriteText(table);
    }

    table->SaveToFile(file);
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
//Z[uf[^ǂݍŃQ[ĊJ
__fastcall TForm1::LoadGame(char *file)
{
    TDataTable *table;
    bool needPlace=false;
    int handle,i;
    char str[100],c;

    System.CPUControl=false;
    handle = open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,&c,1);
    close(handle);
    if(c != '['){   //eLXgt@CłȂꍇ
        if(LoadGameBinary(file) == -1)
            return -1;
    }
    else{
        Map->Initialize();
        table = new TDataTable();
        table->LoadFromFile(file);

        table->GetCategory(CTG_SITUATION);
        Situation->ReadText(table);

        table->GetSubCategory(CTG_MAPDATA);
        Map->ReadText(table);

        for(i=0;i<2;i++){
            sprintf(str,"%s%d",CTG_SIDESTATUS,i);
            table->GetSubCategory(str);
            SideStatus1[i]->ReadText(table);
        }
        needPlace = true;  //jbg̃}bvւ̔zuKv
        delete table;
    }

    if(BaseData1->ReadUser(Map->UnitDataFile)!=-1)
        GBWImage->LoadUserExtend(BaseData1->UserBitmapFile,BaseData1->Sides,BaseData1->UnitGrpGet);

    if(needPlace)
        PlaceUnits();
    MapSizeSet();
    //ES߂
    if(SideStatus1[Situation->Phase]->LimitView)
        FieldScreen1->FindVisibleAll(Map,BaseData1,SideStatus1[Situation->Phase]);
    else
        Map->InitVisible(1);

    DrawAll();
    ScreenReviseAll();
    CheckCreatable(false);   //Y\n_̃`FbN
    MoneyOperation(Situation->Phase,0);
    sprintf(str,"ǒn헪@%s",Map->Name);
    Form1->Caption=str;
    if(Option.UnitListNoModal && Form_UnitListp->Visible)
        Form_UnitListp->MakeList();

    GameOperationEnabled(true);
    if(Situation->CPUMode[Situation->Phase]){
        PhaseEndEnabled(false);
        MoreEnabled(false);
        Timer1->Enabled=true;
    }
    else{
        PhaseEndEnabled(true);
        MoreEnabled(true);
        Timer1->Enabled=false;
        //GameEndJudge();
    }
    return 0;
}
//---------------------------------------------------------------------------
//oCĩZ[uf[^ǂށB
//ߋւ̌݊̂߂ɌÂR[hcĂ邾Ȃ̂
//ł邾ύXȂƁB
__fastcall TForm1::LoadGameBinary(char *file)
{
    VersionControl Version1;
    char str[100];
    int handle,i,v1,v2;

    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    read(handle,str,(sizeof SAVEVERHEAD)-1);
    str[(sizeof SAVEVERHEAD)-1]='\0';
    if(strcmp(str,SAVEVERHEAD)){
        ShowMessage("ǒn헪̃Z[u`ł͂܂B\n");
        close(handle);
        return -1;
    }
    read(handle,str,VERSIONLENGTH+1);
    v1=Version1.StrToValue(str);
    v2=Version1.StrToValue(SAVEVERSION);
    if(v1>v2){
        ShowMessage("Z[u`̃o[WႢ܂B\n");
        close(handle);
        return -1;
    }
    Map->Initialize();
    if(v1>=105){
        Map->Read(handle);  //}bv̏
        SideStatus1[0]->Read(handle);
        SideStatus1[1]->Read(handle);
        Situation->Read(handle);  //݂̏
    }
    else{
        Map->ReadVer104(handle);
        SideStatus1[0]->ReadVer104(handle);
        SideStatus1[1]->ReadVer104(handle);
        Situation->ReadVer104(handle);
    }
    for(i=0;i<2;i++)
        SideStatus1[i]->AdjustUnitFuel();
    if(v1>=103) //슄蓖Ă̏Ԃǂݍ
        read(handle, Situation->CPUMode, sizeof Situation->CPUMode);
    else
        Situation->CPUModeDefault();
    if(v1>=104){ //BڕWǂݍ
        for(i=0;i<2;i++)
            Purposes1[i]->Read(handle);
    }
    else
        for(i=0;i<2;i++)
            Purposes1[i]->Initialize();
    close(handle);
    if(v1<v2){
        if(v1<102)
            Map->VersionConvert(100);
        else if(v1<109)
            Map->VersionConvert(102);
    }
    return 0;
}
//---------------------------------------------------------------------------
// Yłꏊ`FbNB
// VKQ[JnƁAQ[[hɍsB
__fastcall TForm1::CheckCreatable(bool newgame)
{
    MapStatus *gndp;
    int side,count,j,graph,x,y,zx,zy;

    for(side=0;side<2;side++){
        count = Map->SearchChip(side*BUILDINGMAX,&zx,&zy); //sT
        if(count != 1)
            ShowMessage("s̐słB\nُ퓮Nꂪ܂B");
        if(!count)
            continue;
        // s΂̎͂𒲂ׂ
        SideStatus1[side]->PhaseStartX = zx;
        SideStatus1[side]->PhaseStartY = zy;
        Map->InitRange(); // s̎͂RwNX𒲂ׂ
        FieldScreen1->ExtraRangeSearch(Map,BaseData1,zx,zy,4,UT_MIGHTYSEARCH,1,false);
        for(y=0;y<Map->Height;y++){
            for(x=0;x<Map->Width;x++){
                gndp = &Map->Data[x][y];
                graph = gndp->Graph;
                gndp->SetLifeMax();
                if(newgame)
                   gndp->Life = gndp->LifeMax;
                if(Map->RangePoint[x][y] &&
                   BaseData1->CreatableExists(side,graph,SideStatus1[side]->LimitView)){
                    Map->Data[x][y].Create = true;
                }
            }
        }
        for(y=0;y<Map->Height;y++){
            for(x=0;x<Map->Width;x++){ //HE`ED
                gndp = &Map->Data[x][y];
                j = gndp->Building();
                if((j==GND_BIGFACTORY || j==GND_BIGAIRPORT || j==GND_SHIPYARD) &&
                   BaseData1->CreatableExists(side,j,SideStatus1[side]->LimitView)){
                    gndp->Create = true;
                }
            }
        }
    }

    return 0;
}
//---------------------------------------------------------------------------
//jbg}bvɔzu
//SideStatus̃jbgMapStateɏށB
__fastcall TForm1::PlaceUnits(void)
{
    int side,i,zx,zy;

    for(side=0;side<2;side++)
        for(i=0; i<SideStatus1[side]->UnitCount; i++){
            zx = SideStatus1[side]->Unit[i].X;
            zy = SideStatus1[side]->Unit[i].Y;
            if(zx != -1){ //ڂĂȂΔzu
                Map->Data[zx][zy].Side = (char)side;
                Map->Data[zx][zy].Unit = (char)i;
            }
        }
    return 0;
}
//---------------------------------------------------------------------------
//}bṽTCYƃrbg}bṽTCY킹
__fastcall TForm1::MapSizeSet(void)
{
    FieldScreen1->Initialize(Map->Width,Map->Height);
    Image1->Picture->Bitmap->Width  = FieldScreen1->BitmapWidth;
    Image1->Picture->Bitmap->Height = FieldScreen1->BitmapHeight;
    return 0;
}
//---------------------------------------------------------------------------
//SĂ̒n`ƃjbg`悷
__fastcall TForm1::DrawAll(void)
{
    int i;

    FieldScreen1->DrawMap(Map,SideStatus1[Situation->Phase]->LimitView);
    for(i=0;i<2;i++)
        FieldScreen1->DrawAllUnit(Map,SideStatus1[i],SideStatus1[Situation->Phase]->LimitView);

    return 0;
}
//---------------------------------------------------------------------------
//̎ǉyёS⋋
__fastcall TForm1::PhaseStart(void)
{
    SideStatus *Sidep;

    GameEndJudge();
    if(!Situation->Phase)
        Situation->Turn++;
    Sidep=SideStatus1[Situation->Phase];
    MoneyOperation(Situation->Phase,Sidep->Income); //
    if(Sidep->Money>MONEYMAX)
        Sidep->Money=MONEYMAX;
    FieldScreen1->FindSupplyRange(Map,BaseData1,Sidep); //S⋋͈̔
    Sidep->SupplyAll(Map,BaseData1);    //S⋋
    MoneyOperation(Situation->Phase,0); //S⋋̌Ɏ\XV
    return 0;
}
//---------------------------------------------------------------------------
//J[\n_̒n`\
__fastcall TForm1::MapChipStatusPut(int zx,int zy)
{
    int side,num;

    MapStatus *gndp = &Map->Data[zx][zy];
    MapChip *gndInfop = &BaseData1->MapInfo[gndp->Graph];
    FieldScreen1->DrawGroundStatusToTCanvas(Image_GroundStatus->Canvas,Panel1->Brush->Color,0,0,gndp,gndInfop);

    side=(int)Map->Data[zx][zy].Side; //jbg\
    num =(int)Map->Data[zx][zy].Unit;

    // eLTN[hł͎EÕjbg݂͑Ȃ̂ƓB
    if(SideStatus1[Situation->Phase]->LimitView && Map->Shade[zx][zy])
        side = -1;

    // jbgړĂrȂ炻̃jbg̏\B
    if(side==-1 && System.MovingUnit!=-1){
        if(zx==System.TargetX && zy==System.TargetY){
            side = Situation->Phase;
            num = System.MovingUnit;
        }
    }
    if(side==-1){
        // \Ă郆jbgKvɉăNAB
        if(DrawedStatusUnit==-1)
            return 0;
        FillCanvas(Image_UnitStatus->Canvas, Panel1->Brush->Color);
        FillCanvas(Image_Loading->Canvas,    Panel1->Brush->Color);
        DrawedStatusUnit=-1;
    }
    else{
        UnitStatusPut(side,num);
        DrawedStatusUnit = side*UNITMAX+num;
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbg̏\
__fastcall TForm1::UnitStatusPut(int Side,int Num)
{
    UnitStatus *unitp;
    UnitChip *unitInfop;
    //char str[50];

    unitp = &SideStatus1[Side]->Unit[Num];
    unitInfop = &BaseData1->UnitInfo[unitp->Type];
    FieldScreen1->DrawUnitStatusToTCanvas(Image_UnitStatus->Canvas,Panel1->Brush->Color,0,0,unitp,unitInfop);

    LoadStatusPut(Side,Num);
    return 0;
}
//---------------------------------------------------------------------------
//ڏ󋵕\̍XV
__fastcall TForm1::LoadStatusPut(int side,int num)
{
    UnitStatus *unitp = &SideStatus1[side]->Unit[num];
    UnitStatus *loaded;
    TCanvas *canvas = Image_Loading->Canvas;
    TColor backcolor = Panel1->Brush->Color;
    char str[32];
    int i,y;

    FillCanvas(canvas,backcolor);
    for(i=0;i<unitp->Load;i++){
        y = i*36;
        if(System.SelectedLoading == i){
            canvas->Brush->Color = clHighlight;
            canvas->FillRect(Rect(0,y,canvas->ClipRect.Right,y+36));
            canvas->Font->Color = clHighlightText;
        }else{
            canvas->Brush->Color = backcolor;
            canvas->Font->Color = clWindowText;
        }
        loaded = &SideStatus1[side]->Unit[unitp->LoadingUnit[i]];
        GBWImage->ImageList_UnitN->Draw(canvas,0,y,loaded->Graph);
        // jbg
        canvas->TextOut(36,y+4,BaseData1->UnitInfo[loaded->Type].Name);
        // Life
        sprintf(str,"Life %2d",loaded->Life);
        canvas->TextOut(36,y+20,str);
    }
    return 0;
}
//---------------------------------------------------------------------------
//TImagehԂB
__fastcall TForm1::ImageClear(TImage *Imagep)
{
    Imagep->Canvas->Brush->Color=clBtnFace;
    Imagep->Canvas->FillRect(Rect(0,0,Imagep->Width,Imagep->Height));
    return 0;
}
//---------------------------------------------------------------------------
// Q[̏ԁB
const enum TGBWSTATE
{
STATE_DEFAULT,
STATE_GETMOVETARGET,
STATE_CONFIRMACTION,
STATE_RECIEVEACTION,
STATE_GETACTIONRANGE,
STATE_SELECTTARGET,
STATE_ATTACKNORMAL,
STATE_ATTACKMEGAHEX,
STATE_DOWNUNIT,
STATE_ENDOFATTACK,
STATE_ENDOFOTHER
};
// }bvō{^̏B
__fastcall TForm1::MouseLeftDown(int zx,int zy)
{
    static UnitStatus *Unitp;
    static UnitChip *UnitInfop;
    static bool noMove;
    bool collision=false;
    int side,num,cx,cy;

    if(System.RadiusCursor){
        System.RadiusCursor = 0;
        EraseAttackRadius();
    }
    if(System.MovingUnit!=-1){
        Unitp = &SideStatus1[Situation->Phase]->Unit[System.MovingUnit];
        UnitInfop = &BaseData1->UnitInfo[Unitp->Type];
    }
    else if(System.HoldUnit!=-1){
        Unitp = &SideStatus1[Situation->Phase]->Unit[System.HoldUnit];
        UnitInfop = &BaseData1->UnitInfo[Unitp->Type];
    }
    switch(GBWState){
    case STATE_DEFAULT:
        //jbg񂾏ԂɂBړ͈͂̕\
        side = (int)Map->Data[zx][zy].Side;
        if(side == Situation->Phase){
            System.UseGun = -1;
            num = (int)Map->Data[zx][zy].Unit;
            if(!SideStatus1[side]->Unit[num].Actioned){
                System.PhaseEndable=false;
                System.HoldUnit=num;
                FieldScreen1->MoveRangeSearch(Map,BaseData1,&SideStatus1[side]->Unit[num],side,zx,zy);
                if(!System.NoDraw){
                    FieldScreen1->MoveRangePut(Map,SideStatus1[side],num);
                    ScreenRevise(FieldScreen1->BackupRect[0]);
                }
                System.SelectedLoading = -1;
                GBWState = STATE_GETMOVETARGET;
            }
            break;
        }
        MouseLeftDown_Default(zx,zy);
        break;
    case STATE_GETMOVETARGET:
        if(!Map->RangePoint[zx][zy])
            break;
        FieldScreen1->RestoreBitmap(BKUP_NORMAL);
        if(!Map->Visible[zx][zy]){ //E̊OȂ`FbN
            Unitp = &SideStatus1[Situation->Phase]->Unit[System.HoldUnit];
            if(WalkPath(Unitp,&zx,&zy,&cx,&cy))
                collision = true; //ړGjbgɏՓ˂
        }
        System.TargetX = zx;
        System.TargetY = zy;
        System.MovingUnit=System.HoldUnit;
        System.HoldUnit=-1;
        noMove = (zx==Unitp->X && zy==Unitp->Y);
        EraseMoveRangeAndShowMove(zx,zy,Situation->Phase,System.MovingUnit);
        if(collision){ //Փ˂Ă狭IɈړ肷B
            FieldScreen1->CursorPutZ(zx,zy,CURSOR_CLLSN);
            ScreenReviseBlock(zx,zy);
            //ZOCɂՓ˂ȂՓ˃}[N͈ړɕtB
            if(cx!=zx || cy!=zy){
                FieldScreen1->CursorPutZ(cx,cy,CURSOR_CLLSN);
                ScreenReviseBlock(cx,cy);
            }
            DamageWait(WAIT_SHOWCLLSN);
            Map->Visible[cx][cy] = true;
            //Փˑ̏Փ˃}[NB
            if(cx==zx && cy==zy){
                FieldScreen1->UnitPutAuto(Map,SideStatus1[!Situation->Phase],cx,cy,false);
                ScreenReviseBlock(cx,cy);
            }
            // ړOOtBbÑobNAbvB
            FieldScreen1->Backuped[BKUP_NORMAL] = false;
            GBWState = STATE_ENDOFOTHER;
            MouseLeftDown(zx,zy);
            break;
        }
        GBWState = STATE_CONFIRMACTION;
        MouseLeftDown(zx,zy);
        break;
    case STATE_CONFIRMACTION:
        if(((zx!=Unitp->X || zy!=Unitp->Y) && Map->Data[zx][zy].Side!=-1) ||
           ConfirmAction(Unitp,UnitInfop,noMove)){
            GBWState = STATE_GETACTIONRANGE;
            MouseLeftDown(zx,zy);
        }else{
            GBWState = STATE_RECIEVEACTION;
        }
        break;
    case STATE_RECIEVEACTION:
        if(System.UseGun == -1){
            GBWState = STATE_GETMOVETARGET;
            MouseRightDown(zx,zy);
            break;
        }
        GBWState = STATE_GETACTIONRANGE;
        MouseLeftDown(zx,zy);
        break;
    case STATE_GETACTIONRANGE:
        TempMove(noMove);
        if(System.UseGun == MENUITEM_NOACTION){
            //sII񂾏ꍇBUseGunPopupMenu_GunSelectItems̃CfbNXB
            GBWState = STATE_ENDOFOTHER;
            MouseLeftDown(System.TargetX,System.TargetY);
            break;
        }
        GBWState = STATE_SELECTTARGET;
        break;
    case STATE_SELECTTARGET:
        if(!Map->RangePoint[zx][zy]){
            if(zx==System.TargetX && zy==System.TargetY){
                GBWState = STATE_ENDOFOTHER;
                MouseLeftDown(zx,zy);
            }
            else
                System.RadiusCursor = 1;
            break;
        }
        FieldScreen1->RestoreBitmapOnce(BKUP_NORMAL);
        System.LeftX = Unitp->X;
        System.LeftY = Unitp->Y;
        MoveUnit(System.TargetX,System.TargetY,Situation->Phase,System.MovingUnit,!System.NoDraw);
        ScreenRevise(FieldScreen1->BackupRect[0]);
        //Ί킪I΂ĂāAꂪKwNXUΊȂ
        //KwNXȔsB
        if(System.UseGun!=-1 && UnitInfop->Radius[System.UseGun]>1){
            GBWState = STATE_ATTACKMEGAHEX;
            MouseLeftDown(zx,zy);
        }
        //łȂ΁A]̍U^~ԏB
        else if(Map->Data[zx][zy].Side!=-1){
            GBWState = STATE_ATTACKNORMAL;
            MouseLeftDown(zx,zy);
        }
        else{
            GBWState = STATE_DOWNUNIT;
            MouseLeftDown(zx,zy);
        }
        break;
    case STATE_ATTACKNORMAL:
        //퓬OɔRƁiԍω\j
        Unitp->Fuel -= System.ConsumeFuel;
        UnitBattle(Situation->Phase,System.MovingUnit,Map->Data[zx][zy].Unit,!System.NoDraw);
        GBWState = STATE_ENDOFATTACK;
        MouseLeftDown(zx,zy);
        break;
    case STATE_ATTACKMEGAHEX:
        Unitp->Fuel -= System.ConsumeFuel;
        if(UnitInfop->SuperMissile){
            AttackMegaHex(Situation->Phase,System.MovingUnit,System.TargetX,System.TargetY,System.UseGun,!System.NoDraw);
        }
        else{
            AttackMegaHex(Situation->Phase,System.MovingUnit,zx,zy,System.UseGun,!System.NoDraw);
        }
        GBWState = STATE_ENDOFATTACK;
        MouseLeftDown(zx,zy);
        break;
    case STATE_DOWNUNIT:
        if(!Map->RangePoint[zx][zy]){
            if(zx==System.TargetX && zy==System.TargetY){
                FieldScreen1->RestoreBitmapOnce(BKUP_NORMAL);
                ScreenRevise(FieldScreen1->BackupRect[BKUP_NORMAL]);
                GBWState = STATE_ENDOFATTACK;
                MouseLeftDown(zx,zy);
            }
            else
                System.RadiusCursor = 1;
            break;
        }
        FieldScreen1->RestoreBitmapOnce(BKUP_NORMAL);
        DownUnit(zx,zy,Situation->Phase,System.MovingUnit,!System.NoDraw);
        //ڂ̍~ԂƓɁAEXVB͈̏񂾂B
        if(SideStatus1[Situation->Phase]->LimitView && System.LeftX!=-1){
            UpdateLimitView(System.LeftX, System.LeftY, Unitp->X, Unitp->Y, UnitInfop);
        }
        System.LeftX = -1;
        if(SideStatus1[Situation->Phase]->Unit[System.MovingUnit].Load){
            //̍~ԂsׂɁA~Ԕ͈͂̍XVsB
            Map->InitRange();
            FieldScreen1->LoadRangeSearch(Map, BaseData1, Unitp, Situation->Phase, System.TargetX, System.TargetY);
            FieldScreen1->DrawAttackRange(Map);
            //if(!OutsideVisible(zx,zy))
            //    FieldScreen1->CursorPutZ(System.TargetX,System.TargetY,LOADCURSOR);
            ScreenRevise(FieldScreen1->BackupRect[BKUP_NORMAL]);
            ScreenReviseBlock(System.TargetX, System.TargetY);
            System.RadiusCursor = 1;
            break;
        }
        //S~Ԃꍇ͔RďIB
        //̎_ŎE͊SɍXVĂB
        if(!OutsideVisible(System.TargetX,System.TargetY))
            FieldScreen1->CursorPutZ(System.TargetX,System.TargetY,CURSOR_END);
        ScreenRevise(FieldScreen1->BackupRect[BKUP_NORMAL]);
        ScreenReviseBlock(Unitp->X, Unitp->Y);
        SideStatus1[Situation->Phase]->Unit[System.MovingUnit].Fuel -= System.ConsumeFuel;
        GBWState = STATE_DEFAULT;
        System.MovingUnit=-1;
        System.PhaseEndable=true;
        break;
    case STATE_ENDOFATTACK:
        if(Map->Data[System.TargetX][System.TargetY].Side != -1){
            //jbgȂȂĂȂΎE̍XVB
            //A~ԓrȂXV͊ɏIĂB(System.LeftX == -1)
            if(SideStatus1[Situation->Phase]->LimitView && System.LeftX!=-1)
                UpdateLimitView(System.LeftX, System.LeftY, Unitp->X, Unitp->Y, UnitInfop);
            if(!OutsideVisible(System.TargetX,System.TargetY)){
                FieldScreen1->CursorPutZ(System.TargetX,System.TargetY,CURSOR_END);
                ScreenReviseBlock(System.TargetX,System.TargetY);
            }
        }
        else{ //jbgȂȂĂO̎E邾
            if(SideStatus1[Situation->Phase]->LimitView)
                UpdateLimitView(System.LeftX, System.LeftY, -1,0,UnitInfop);
        }
        GBWState = STATE_DEFAULT;
        System.MovingUnit=-1;
        System.PhaseEndable=true;
        break;
    case STATE_ENDOFOTHER:       //jbg̍s̊SI
        int ox,oy;
        bool plused;
        FieldScreen1->RestoreBitmap(BKUP_NORMAL);
        ox = Unitp->X;
        oy = Unitp->Y;
        plused = MoveUnit(zx,zy,Situation->Phase,System.MovingUnit,!System.NoDraw);
        //łȂ΁AR炷
        if(!plused)
            SideStatus1[Situation->Phase]->Unit[System.MovingUnit].Fuel -= System.ConsumeFuel;
        if(!OutsideVisible(zx,zy))
            FieldScreen1->CursorPutZ(zx,zy,CURSOR_END);
        if(SideStatus1[Situation->Phase]->LimitView){
            //̏ꍇAꂽ̎Ê܂ܕێB
            //ijbgj
            if(plused)
                UpdateLimitView(ox,oy,-1,0,UnitInfop);
            else
                UpdateLimitView(ox,oy, Unitp->X, Unitp->Y, UnitInfop);
        }
        ScreenRevise(FieldScreen1->BackupRect[0]);
        ScreenReviseBlock(zx,zy);
        GBWState = STATE_DEFAULT;
        System.MovingUnit=-1;
        System.PhaseEndable=true;
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//Â{^̉BXɕ\B
__fastcall TForm1::MouseLeftDown_Default(int zx,int zy)
{
    TRect rect;
    UnitChip *UnitInfop;

    //Y\Ȃ琶Y_CAO\
    if(CanCreateUnit(zx,zy)){
        if(SideStatus1[Situation->Phase]->UnitCount >= Situation->UnitMax){
            ShowUnitMax();
            return -1;
        }
        Form_seisanp->Money = SideStatus1[Situation->Phase]->Money;
        Form_seisanp->MakeList(Situation->Phase,
                               Map->Data[zx][zy].Graph%BUILDINGMAX,
                               SideStatus1[Situation->Phase]->LimitView);
        Form_seisanp->ShowModal();
        if(Form_seisanp->ModalResult == mrOk){  //炵ĕǉ
            UnitInfop = &BaseData1->UnitInfo[Form_seisanp->UnitGraph%UNITTYPEMAX];
            MoneyOperation(Situation->Phase, -UnitInfop->Value);
                //ԂĂƒn`Ȃ̂ōĕ`
            if(Map->Shade[zx][zy])
                FieldScreen1->MapChipPutZ(Map,zx,zy);
            NewUnit(zx,zy,Situation->Phase,Form_seisanp->UnitGraph);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bvŉE{^̏
__fastcall TForm1::MouseRightDown(int zx,int zy)
{
    int i,ux,uy;
    UnitStatus *unitp;

    if(System.RadiusCursor){
        System.RadiusCursor = 0;
        EraseAttackRadius();
    }
    Popup_ShowRange->Enabled=false;
    Popup_KillUnit->Enabled=false;
    if(System.PhaseEndable){
        if(Map->Data[zx][zy].Side!=-1){
            Option.SelectedSide=Map->Data[zx][zy].Side;
            Option.SelectedUnit=i=Map->Data[zx][zy].Unit;
            Popup_ShowRange->Enabled=true;
        }
        if(Map->Data[zx][zy].Side==Situation->Phase){
            Option.SelectedUnit=i=Map->Data[zx][zy].Unit;
            if(!SideStatus1[Situation->Phase]->Unit[i].Actioned)
                Popup_KillUnit->Enabled=true;
        }
    }

    switch(GBWState){
    case STATE_SELECTTARGET:
        unitp = &SideStatus1[Situation->Phase]->Unit[System.MovingUnit];
        //jbg̈ړ
        if(unitp->Actioned)
            return 0; //~ԓr̃jbg͉ENbN𖳎
        FieldScreen1->RestoreBitmap(0);
        ux = unitp->X;
        uy = unitp->Y;
        Map->Data[ux][uy].Side = (char)Situation->Phase;
        DrawMapChip(System.TargetX, System.TargetY);
        if(Map->Data[System.TargetX][System.TargetY].Side!=-1)
            FieldScreen1->UnitPutAuto(Map,SideStatus1[Situation->Phase],System.TargetX,System.TargetY,false);
        FieldScreen1->UnitPutAuto(Map,SideStatus1[Situation->Phase],ux,uy,false);
        ScreenReviseBlock(System.TargetX,System.TargetY);
        ScreenReviseBlock(ux,uy);
        if(FieldScreen1->Backuped)
            ScreenRevise(FieldScreen1->BackupRect[0]);
        System.PhaseEndable=true;
        System.MovingUnit=-1;
        GBWState = STATE_DEFAULT;
        break;
    case STATE_RECIEVEACTION:
    case STATE_GETMOVETARGET:
        //jbĝ݂iړ͈͂̏j
        FieldScreen1->RestoreBitmap(0);
        ScreenRevise(FieldScreen1->BackupRect[0]);
        System.HoldUnit=-1;
        GBWState = STATE_DEFAULT;
        System.PhaseEndable=true;
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbgYoԂB͘_W
__fastcall TForm1::CanCreateUnit(int zx,int zy)
{
    int Graph;
    bool result=true;

    Graph=Map->Data[zx][zy].Graph;
    if(Map->Data[zx][zy].Side != -1)
        result=false;
    if(Graph/BUILDINGMAX != Situation->Phase)
        result=false;
    if(!Map->Data[zx][zy].Create)
        result=false;

    return (int)result;
}
//---------------------------------------------------------------------------
//w肵jbgւ̕⋋\B͘_W
__fastcall TForm1::CanSupplyUnit(int zx,int zy,int Side,int UnitType)
{
    bool result;
    int Graph;

    Graph=Map->Data[zx][zy].Graph;
    if(Side!=Graph/BUILDINGMAX)
        result=false;
    else
        result=BaseData1->UnitInfo[UnitType].Supply[Graph%BUILDINGMAX];

    return (int)result;
}
//---------------------------------------------------------------------------
//ړ͈͕\Ajbgw肳ꂽW֓ČB
__fastcall TForm1::EraseMoveRangeAndShowMove(int zx,int zy,int side,int num)
{
    bool Draw;
    UnitStatus *Unitp = &SideStatus1[side]->Unit[num];
    //UnitChip *UnitInfop = &BaseData1->UnitInfo[Unitp->Type];
    int ux = Unitp->X;
    int uy = Unitp->Y;

    DrawMapChip(ux,uy); //̏ꏊ̃jbg摜
    Draw = !OutsideVisible(zx,zy); //ړW͕`悷邩H
    if(Draw){
        FieldScreen1->UnitPutZ(zx,zy,Unitp->Graph);
        if(Unitp->Load)
            FieldScreen1->CursorPutZ(zx,zy,CURSOR_LOAD);
    }
    ScreenRevise(FieldScreen1->BackupRect[0]);
    return 0;
}
//---------------------------------------------------------------------------
//ǂ̍ŝmFBmF̗vΏ]ʂ̂thB
//߂l͍sȂ1AłȂ0
__fastcall TForm1::ConfirmAction(UnitStatus *unitp,UnitChip *unitInfop,bool noMove)
{
    //UnitStatus *Unitp = &SideStatus1[side]->Unit[unitNum];
    //UnitChip *UnitInfop = &BaseData1->UnitInfo[Unitp->Type];
    //if(!collision && UnitInfop->HasMegaHex()){
    if(unitInfop->SuperMissile){
        System.UseGun = 0;
        return 1;
    }
    if(unitInfop->HasMegaHex()){
        //CPȔꍇACPUMouse()System.UseGun̒lݒ肷B
        if(System.CPUControl)
            return 1;
        else
            SelectGunByUser(unitp,unitInfop,noMove);
        return 0;
    }
    return 1;
}
//---------------------------------------------------------------------------
__fastcall TForm1::ReceiveGunMenu(int index)
{
    if(RButtonDowned)
        System.UseGun = -1;
    else
        System.UseGun = index;
    MouseLeftDown(0,0);
    return 0;
}
//---------------------------------------------------------------------------
//ړB
__fastcall TForm1::TempMove(bool noMove)
{
    bool Draw,megaHex=false;
    int i,zx,zy,ux,uy,type,graph;
    int side = Situation->Phase;
    int unitNum = System.MovingUnit;
    UnitStatus *Unitp = &SideStatus1[side]->Unit[unitNum];
    UnitChip *UnitInfop = &BaseData1->UnitInfo[Unitp->Type];

    zx = System.TargetX;
    zy = System.TargetY;
    ux = Unitp->X;
    uy = Unitp->Y;

    type = Unitp->Type; 

    System.ConsumeFuel = Map->RangePoint[ux][uy] - Map->RangePoint[zx][zy];
    Map->Data[ux][uy].Side = -1; //~Ԕ͈͒̈
    graph = Map->Data[zx][zy].Graph;
    if(Map->Data[zx][zy].Side==-1){ //ڂłȂ΍U
        // X[p[~TC͓ʈib[ujB
        if(UnitInfop->SuperMissile){
            UnitChip backup = *UnitInfop;
            UnitInfop->MinRange[0] = 1;
            UnitInfop->MaxRange[0] = UnitInfop->Radius[0] -1;
            FieldScreen1->FindSingleAttackRange(Map,BaseData1,Unitp,zx,zy,0,side);
            *UnitInfop = backup;
            megaHex = true;
        }
        else{
            // KwNXUȊỎΊĝȂ]̎˒sB
            if(System.UseGun==-1 || System.UseGun==MENUITEM_DOWNUNIT ||
               !noMove  ||
               UnitInfop->Radius[System.UseGun]<=1){
                FieldScreen1->AttackRangeSearch(Map,BaseData1,Unitp,SideStatus1[!side],zx,zy,noMove,false);
            }else{
                //KwNXUΊw肵ꍇ͈ΊɊւPȎ˒B
                FieldScreen1->FindSingleAttackRange(Map,BaseData1,Unitp,zx,zy,System.UseGun,side);
                megaHex = true;
            }
            if(UnitInfop->CanLoadOn[graph])
                FieldScreen1->LoadRangeSearch(Map,BaseData1,Unitp,Situation->Phase,zx,zy);
        }
    }
    else{
        Map->InitRange();
        //͈͒sȂ͏Ȃƕss
    }

    if(megaHex)
        FieldScreen1->DrawMegaAttackRange(Map);
    else
        FieldScreen1->DrawAttackRange(Map);

    Draw = !OutsideVisible(zx,zy); //ړW͕`悷邩H
    if(Draw){
        if(System.UseGun != -1){
            System.RadiusCursor = UnitInfop->Radius[System.UseGun];
            System.SuperMissile = UnitInfop->SuperMissile;
        }else{
            System.RadiusCursor = 1;
        }
        //ړn_ɂāAKvȂeJ[\`悷B
        if(Map->Shade[zx][zy] || Map->Data[zx][zy].Side == -1){
            FieldScreen1->CursorPutZ(zx,zy,CURSOR_MOVE);
        }
        else{
            i = SideStatus1[side]->Unit[Map->Data[zx][zy].Unit].Type;
            if(type==i) //mF̃J[\
                FieldScreen1->CursorPutZ(zx,zy,CURSOR_PLUS);
            else //ڊmF̃J[\
                FieldScreen1->CursorPutZ(zx,zy,CURSOR_UP);
        }
        ScreenReviseBlock(zx,zy);
    }
    ScreenRevise(FieldScreen1->BackupRect[0]);
    return 0;
}
//---------------------------------------------------------------------------
// gp\ȃKwNXUΊłĂāA
// Ȃgp\ȉΊ킪Ȃ΁A
// [U[ɂI΂邽߂Ƀ|bvAbvj[\B
// ̊֐ICxg[vɖ߂āA
// j[ACeɊ֘AtꂽCxgN̂҂ׂB
__fastcall TForm1::SelectGunByUser(UnitStatus *unitp,UnitChip *unitInfop,bool noMove)
{
    int i,x,y,d;

    //gΊ̐𐔂B
    for(i=0;i<2;i++){
        TMenuItem *item = PopupMenu_SelectGun->Items->Items[i];
        item->Caption = unitInfop->GunName[i];
        item->Enabled = true;
        if(!unitp->GunRest[i]){
            item->Enabled = false;
        }else if(unitInfop->MinRange[i] > 1 && !noMove){
            item->Enabled = false;
        }
    }
    d = FieldScreen1->GraphDegree/2;
#if 0
    x = Form1->Left + ScrollBox1->Left + System.MouseX;
    y = Form1->Top  + ScrollBox1->Top  + System.MouseY;
#else
    x = Form1->Left + Image1->Left + System.MouseX + d;
    y = Form1->Top  + Image1->Top  + System.MouseY + d;
#endif
    PopupMenu_SelectGun->Items->Items[MENUITEM_DOWNUNIT]->Enabled = (unitp->Load > 0);
    PopupMenu_SelectGun->Popup(x,y);
    return 0;
}
//---------------------------------------------------------------------------
//jbguiY̐VKo^j
__fastcall TForm1::NewUnit(int zx,int zy,int Side,int Graph)
{
    UnitChip *UnitInfop;
    TRect rect;
    int x,y;

    Map->Data[zx][zy].Side=(char)Side;
    Map->Data[zx][zy].Unit=(char)SideStatus1[Side]->UnitCount;
    SideStatus1[Side]->AddUnit(BaseData1,zx,zy,Graph);
    UnitInfop = &BaseData1->UnitInfo[Graph%UNITTYPEMAX];

    if(!OutsideVisible(zx,zy)){
        FieldScreen1->XY_MapToPhy(zx,zy,&x,&y);
        FieldScreen1->UnitPut(x,y,Graph);
        FieldScreen1->CursorPut(x,y,CURSOR_END);
        ScreenReviseBlock(zx,zy);
    }
    //eLTNȂ王EXV
    if(SideStatus1[Situation->Phase]->LimitView && !ApplyShade){
        Map->Shade[zx][zy] = false; //Rjbg͏Ɍ
        UpdateLimitView(-1,0,zx,zy,UnitInfop);
        FieldScreen1->GetDrawRect(Map,&rect);
        ScreenRevise(rect);
    }
    if(Option.UnitListNoModal && Form_UnitListp->Visible)
        Form_UnitListp->MakeList(); //\ɐVjbgǉ
    return 0;
}
//---------------------------------------------------------------------------
//jbg̈ړoHHB炩ߍŒZH߂ĂKvB
//͖ړI̍W̃|C^B
//GƏՓ˂AՓ˒n_̍W|C^Ɋi[ 1 ԂB
//Փ˂NȂΉ 0 ԂB
__fastcall TForm1::WalkPath(UnitStatus *Unitp,int *zx,int *zy,int *colx,int *coly)
{
    bool stop, immediate=false, collision=false;
    int x=*zx,y=*zy,cx,cy,side,i,j;
    SideStatus *EnemySide;
//    char str[100];

    EnemySide = SideStatus1[!Situation->Phase];
    //ړI̍WoHtɒH
    for(i=0;i<1000;i++){ //[vɂȂƂȂ̂œKȉ񐔃[v
        if(x==Unitp->X && y==Unitp->Y) //oHSHΏI
            break;
        side = Map->Data[x][y].Side; //oHɓG邩`FbN
        stop = false;
        if(side!=-1 && side!=Situation->Phase){
            stop = true;
            immediate = true;
        }else if(Option.ZOCMode && !immediate &&
                 FieldScreen1->CirculationEnemy(Map, BaseData1, EnemySide,
                     x,y,Situation->Phase,Unitp->Type,true)){
            //ZOCAאډȅɗאړGΏՓˁB
            //oH̓GɂԂ钼OȂ炱͓KpȂ
            //iǂ݂̍WŒ~邩jB
            stop = true;
        }
        else
            immediate = false;
        if(stop){
            collision = true;
            cx = x;
            cy = y; //GAŏɂԂG̍WL^
        }
        j = Map->Back[x][y].x;
        y = Map->Back[x][y].y;
        x = j; //ڑƔz̎QƂȂ̂ňꎞϐB
    }
    if(collision){
        //Ԃ̍Wi[
        *colx = cx;
        *coly = cy;
        //GƂԂ钼O̍W烆jbg̋Ȃ܂Ŗ߂
        while(Map->Data[cx][cy].Side != -1){
            //鏊܂Ŗ߂ꍇ͂ŏI
            if(cx==Unitp->X && cy==Unitp->Y)
                break;
            j = Map->Back[cx][cy].x;
            cy = Map->Back[cx][cy].y;
            cx = j;
        }
        *zx = cx;
        *zy = cy;
/*
        if(Map->Data[*zx][*zy].Side != -1){
            sprintf(str,"Collision error:go(%d,%d),col(%d,%d)",ex,ey,cx,cy);
            ShowMessage(str);
        }
*/
        return 1;
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbgړiMap1SideStatus1̏j
//߂l͍ǂB 1AȂ 0
__fastcall TForm1::MoveUnit(int zx,int zy,int side,int unitNum,bool Draw)
{
    UnitStatus *unitp;
    MapStatus *ground;
    bool Occupy=false,Restore=false,Loaded=false,Plused=false;
    int i,j,oldX,oldY,type,life,damage,income;

    unitp = &SideStatus1[side]->Unit[unitNum];
    ground = &Map->Data[zx][zy];
    type = unitp->Type;
    life = unitp->Life;
    oldX = unitp->X;
    oldY = unitp->Y;
    Map->Data[oldX][oldY].Side = -1;
    if(ground->Side == -1){
        unitp->X=zx;
        unitp->Y=zy;
        UnitActioned(side,unitNum);
        ground->Side = (char)side;
        ground->Unit = (char)unitNum;
    }
    else{
        int existUnit = ground->Unit;
        i = SideStatus1[side]->Unit[existUnit].Type;
        if(type==i){
            PlusUnit(side,existUnit,unitNum);
            UnitActioned(side,existUnit);
            KillUnit(side,unitNum);
            Plused=true;
        } //
        else{
            unitp->X = -1;
            SideStatus1[side]->LoadUnit(existUnit,unitNum);
            UnitActioned(side,unitNum);
            UnitActioned(side,existUnit);
            Loaded=true;
        } //
    }
    i=Map->Data[zx][zy].Graph;
    if(!Loaded && !Plused && i<BUILDINGMAX*3 && i/BUILDINGMAX!=side && BaseData1->UnitInfo[type].CanOccupy){
        damage = min(life, ground->Life);
        ground->Life -= damage;
        if(ground->Life == 0){
            j=i%BUILDINGMAX;
            ground->Graph = (char)(j+side*BUILDINGMAX);
            ground->Life = 200;
            income = BaseData1->MapInfo[j].Income;
            SideStatus1[side]->Income += income;
            if(i<BUILDINGMAX*2)
                SideStatus1[!side]->Income -= income;
            //{݂s̎͂ɂȂꍇA̐Y\tO낷B
            if(!(j==GND_BIGFACTORY || j==GND_BIGAIRPORT || j==GND_SHIPYARD)){
                if(FieldScreen1->IsNeighbor(zx,zy,SideStatus1[side]->PhaseStartX,SideStatus1[side]->PhaseStartY,3))
                    ground->Create=true;
                else
                    ground->Create=false;
            }
        }
        Occupy=true;
    }   //
    if(!Loaded && !Plused && !Occupy && i/BUILDINGMAX==side && BaseData1->UnitInfo[type].CanOccupy){
        damage = min(life, ground->LifeMax - ground->Life);
        ground->Life += damage;
        Restore=true;   //ϋvx̉
    }
    if(Draw && !OutsideVisible(zx,zy)){
        if(Plused){
            FieldScreen1->CursorPutZ(zx,zy,CURSOR_PLUSED);
            ScreenReviseBlock(zx,zy);
            DamageWait(WAIT_SHOWPLUS);
        }
        if(Occupy){
            FieldScreen1->ValuePutZ(zx,zy,damage,COLOR_OCCUPY);
            ScreenReviseBlock(zx,zy);
            DamageWait(WAIT_SHOWOCCUPY);
        }
        if(Restore && damage){
            FieldScreen1->ValuePutZ(zx,zy,damage,COLOR_RESTORE);
            ScreenReviseBlock(zx,zy);
            DamageWait(WAIT_SHOWOCCUPY);  //EFCgl͋ʁB
        }
        FieldScreen1->UnitPutAuto(Map,SideStatus1[side],zx,zy,false);
        ScreenReviseBlock(zx,zy);
    }
    return (int)Plused;
}
//---------------------------------------------------------------------------
//jbg鎞Ac鑤ibaseUnitjLifeƔReXVB
__fastcall TForm1::PlusUnit(int side,int baseUnit,int plusUnit)
{
    UnitStatus *baseUnitp,*plusUnitp;

    baseUnitp = &SideStatus1[side]->Unit[baseUnit];
    plusUnitp = &SideStatus1[side]->Unit[plusUnit];

    baseUnitp->Life += plusUnitp->Life;
    //Re͑̒lɂȂB
    for(int i=0;i<2;i++){
        baseUnitp->GunRest[i] = max(baseUnitp->GunRest[i], plusUnitp->GunRest[i]);
    }
    baseUnitp->Fuel = max(baseUnitp->Fuel, plusUnitp->Fuel);

    if(Option.UnitListNoModal && Form_UnitListp->Visible && !System.CPUMinding)
        Form_UnitListp->MakeList();
    return 0;
}
//---------------------------------------------------------------------------
//jbg~ԂB
//zx,zy͍~ԂʒuASideLoader͖ړĨjbgςł郆jbgB
//܂~Ԃꂽjbg̎EB
__fastcall TForm1::DownUnit(int zx,int zy,int side,int loader,bool Draw)
{
    UnitStatus *unitp,*loaderp;
    UnitChip *unitInfop;
    TRect rect;
    int unitNum,loadIndex;

    loaderp = &SideStatus1[side]->Unit[loader];
    loadIndex = SelectDownUnit(zx,zy,side,loaderp);
    //~Ԃ郆jbg͉ȂB
    if(loadIndex == -1){
        ShowMessage("ɍ~Ԃł郆jbg܂");
        return -1;
    }
    loaderp->Load--;
    unitNum = loaderp->LoadingUnit[loadIndex];
    Map->Data[zx][zy].Side = (char)side;
    Map->Data[zx][zy].Unit = (char)unitNum;
    //̂Ƃ듋ڂł̂͂Q܂łȂ̂ŁÅȒPȏōςށB
    //LoadIndex01̂ǂ炩B
    if(!loadIndex)
        loaderp->LoadingUnit[0] = loaderp->LoadingUnit[1];
    unitp = &SideStatus1[side]->Unit[unitNum];
    unitp->X = zx;
    unitp->Y = zy;
    if(Draw){
        UnitActioned(side,unitNum);
        if(DrawUnit(zx,zy,side,false)){
            FieldScreen1->CursorPutZ(zx,zy,CURSOR_END);
            ScreenReviseBlock(zx,zy);
        }
        if(SideStatus1[Situation->Phase]->LimitView){
            unitInfop = &BaseData1->UnitInfo[unitp->Type];
            UpdateLimitView(-1,0,zx,zy,unitInfop);
            FieldScreen1->GetDrawRect(Map,&rect);
            ScreenRevise(rect);
        }
    }
    else{
        unitp->Actioned=true;
    }
    return 0;
}
//---------------------------------------------------------------------------
//w肵n_Ƀjbg~Ԃł邩B
//͘_WAڑUnitStatus̃|C^
//~Ԃłꍇ͂̓ڔԍB
__fastcall TForm1::SelectDownUnit(int zx,int zy,int Side,UnitStatus *Unitp)
{
//    UnitChip *UnitInfop;
    int i,Ground,Type,Cost;

    Ground = Map->Data[zx][zy].Graph;
    for(i=0; i<Unitp->Load; i++){
        Type = SideStatus1[Side]->Unit[Unitp->LoadingUnit[i]].Type;
//        UnitInfop = &BaseData1->UnitInfo[Type];
        Cost = BaseData1->UnitInfo[Type].MoveLost[Ground];
        if(Cost == 1)
            return i;
    }
    return -1;
}
//---------------------------------------------------------------------------
//jbgB}[NEFCgtŕ\
__fastcall TForm1::DisposalUnit(int Side,int UnitNum)
{
    int zx,zy,type;

    UnitXY(Side,UnitNum,&zx,&zy);
    type = SideStatus1[Side]->Unit[UnitNum].Type;
    FieldScreen1->CursorPutZ(zx,zy,CURSOR_KILLED);
    ScreenReviseBlock(zx,zy);
    DamageWait(WAIT_SHOWKILL);
    DrawMapChip(zx,zy);
    ScreenReviseBlock(zx,zy);
    if(SideStatus1[Side]->LimitView)
        UpdateLimitView(zx,zy,-1,0, &BaseData1->UnitInfo[type]);
    KillUnit(Side,UnitNum);
    return 0;
}
//---------------------------------------------------------------------------
//jbg폜B
//}bv̍XVAf[^̍폜AɕKvȂ畔\̍XVsB
__fastcall TForm1::KillUnit(int side,int unitNum)
{
    int zx,zy;

    UnitXY(side,unitNum,&zx,&zy);
    Map->Data[zx][zy].Side=-1;
    SideStatus1[side]->DeleteUnit(Map,unitNum);
    if(side==Situation->Phase && !System.CPUMinding &&
       Option.UnitListNoModal && Form_UnitListp->Visible)
        Form_UnitListp->MakeList();
    return 0;
}
//---------------------------------------------------------------------------
//jbgsς݂ɂ
__fastcall TForm1::UnitActioned(int side,int unitNum)
{
    SideStatus1[side]->Unit[unitNum].Actioned = true;
    if(Option.UnitListNoModal && Form_UnitListp->Visible && !System.CPUMinding)
        UnitListRevise(unitNum);
    return 0;
}
//---------------------------------------------------------------------------
//퓬i_[WvZAeECtASŃjbg폜j
__fastcall TForm1::UnitBattle(int AttackSide,int AttackNum,int TargetNum,bool Draw)
{
    bool Counter=false;
    int ax,ay,tx,ty,aDraw,tDraw,
        TargetSide=!AttackSide,ADamage=0,TDamage;

    UnitXY(TargetSide,TargetNum,&tx,&ty); //̏Aŋ߂Kv͖
    UnitXY(AttackSide,AttackNum,&ax,&ay);
    CalcBattle(AttackSide,AttackNum,TargetNum,&ADamage,&TDamage,&Counter);

    if(Draw){
        aDraw = !OutsideVisible(ax,ay); //ꂼ`ׂǂ߂
        tDraw = !OutsideVisible(tx,ty);
        //ꂽU_[W\
        if(Counter && aDraw){
            FieldScreen1->ValuePutZ(ax,ay,ADamage,COLOR_DAMAGE);
            ScreenReviseBlock(ax,ay);
        }
        if(tDraw){
            FieldScreen1->ValuePutZ(tx,ty,TDamage,COLOR_DAMAGE);
            ScreenReviseBlock(tx,ty);
        }
        DamageWait(WAIT_SHOWDAMAGE);
        if(Counter && aDraw){
            FieldScreen1->UnitPutAuto(Map,SideStatus1[AttackSide],ax,ay,false);
            ScreenReviseBlock(ax,ay);
        }
        if(tDraw){
            FieldScreen1->UnitPutAuto(Map,SideStatus1[TargetSide],tx,ty,false);
            ScreenReviseBlock(tx,ty);
        }
    }

    if(Counter){
        SideStatus1[AttackSide]->DisLife(AttackNum,ADamage);
        if(Option.UnitListNoModal && Form_UnitListp->Visible && !System.CPUMinding)
            UnitListRevise(AttackNum);
        //U͏ɑ쑤Ȃ̂ŁB\̓eXV
    }
    SideStatus1[TargetSide]->DisLife(TargetNum,TDamage);

    UpdateDamagedUnit(TargetSide,TargetNum,tx,ty,Draw);
    UpdateDamagedUnit(AttackSide,AttackNum,ax,ay,Draw);
    return 0;
}
//---------------------------------------------------------------------------
//UnitBattle()̃KwNXŁBlȂB
__fastcall TForm1::AttackMegaHex(int attackSide,int attackNum,int center_x,int center_y,int gunType,bool Draw)
{
    UnitStatus *attackUnit = &SideStatus1[attackSide]->Unit[attackNum];
    UnitStatus attackUnitStatus;
    UnitChip *unitInfop = &BaseData1->UnitInfo[attackUnit->Type];
    POINT list[1024];
    int i,count;

    attackUnitStatus = *attackUnit;
    attackUnit->GunRest[gunType]--;
    count = FieldScreen1->GetNeighborList(center_x,center_y,0,unitInfop->Radius[gunType],Map->Width,Map->Height,list,1024);
    for(i=0;i<count;i++){
        AttackNoCounter(attackSide,&attackUnitStatus,list[i].x,list[i].y,gunType,Draw);
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::AttackNoCounter(int attackSide,UnitStatus *attackUnit,int tx,int ty,int gunType,bool Draw)
{
    bool tDraw;
    int damage,targetType;
    MapStatus *ground = &Map->Data[tx][ty];
    int targetSide = ground->Side;
    if(targetSide == -1)
        return 0;
    int targetNum = ground->Unit;
    //UnitStatus *attackUnit = &SideStatus1[attackSide]->Unit[attackNum];
    UnitStatus *targetUnit = &SideStatus1[targetSide]->Unit[targetNum];
    targetType = targetUnit->Type;

    damage = CalcDamage(attackUnit,targetUnit,&gunType,1<<gunType,false);
    if(Draw){
        //`ׂǂ߂
        tDraw = !OutsideVisible(tx,ty);
        if(tDraw){
            FieldScreen1->ValuePutZ(tx,ty,damage,COLOR_DAMAGE);
            ScreenReviseBlock(tx,ty);
        }
        DamageWait(WAIT_SHOWDAMAGE);
        if(tDraw){
            //EÕjbgɍUꍇ̓_[Ŵݕ\A
            //̌etn`ɖ߂B
            if(!Map->Shade[tx][ty]){
                FieldScreen1->UnitPutAuto(Map,SideStatus1[targetSide],tx,ty,true);
            }else{
                FieldScreen1->DrawMapChipShadeZ(Map,tx,ty);
            }
            ScreenReviseBlock(tx,ty);
        }
    }

    SideStatus1[targetSide]->DisLife(targetNum,damage);
    if(UpdateDamagedUnit(targetSide,targetNum,tx,ty,tDraw)){
        //R̃jbgUďłꍇAEXVB
        if(targetSide == attackSide &&
           SideStatus1[attackSide]->LimitView){
            UpdateLimitView(tx,ty,-1,0,&BaseData1->UnitInfo[targetType]);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//퓬̌ʂvZ
//Counter͂炩falseɂĂ
__fastcall TForm1::CalcBattle(int AttackSide,int AttackNum,
    int TargetNum,int *ADamage,int *TDamage,bool *Counter)
{
    UnitStatus *AUnit,*TUnit;
    UnitChip *TUnitInfo;
    int ax,ay,tx,ty,
        TargetSide=!AttackSide,
        GunType,AGunFlag,TGunFlag;

    AUnit = &SideStatus1[AttackSide]->Unit[AttackNum];
    TUnit = &SideStatus1[TargetSide]->Unit[TargetNum];
    TUnitInfo = &BaseData1->UnitInfo[TUnit->Type];
    UnitXY(TargetSide,TargetNum,&tx,&ty); //̏Aŋ߂Kv͖
    UnitXY(AttackSide,AttackNum,&ax,&ay);
    AGunFlag=Map->RangePoint[tx][ty]; //AttackRangeSelect()QƂ̂ƁB
    //ł邩ǂ̔B
    if(CanCounter(AUnit,TUnit,TUnitInfo)){
        FieldScreen1->AttackRangeSearch(Map,BaseData1,TUnit,SideStatus1[AttackSide],tx,ty,true,true);
        if(Map->RangePoint[ax][ay])
            *Counter=true;
        TGunFlag=Map->RangePoint[ax][ay];
    }

    *TDamage = CalcDamage(AUnit,TUnit,&GunType,AGunFlag,false);
    AUnit->GunRest[GunType]--;
    if(*Counter){   //\Ȃ
        *ADamage=CalcDamage(TUnit,AUnit,&GunType,TGunFlag,true);
        TUnit->GunRest[GunType]--;
    }
    return 0;
}
//---------------------------------------------------------------------------
//_[W̌vZB
//Ujbg̎ށEԋyсAUjbg̎ނ
//Ũ_[W߂B
//discrease=true Ȃ_[W͌iU󂯂jB
__fastcall TForm1::CalcDamage(UnitStatus *attackUnit,UnitStatus *targetUnit,
    int *gunType,int gunFlag,bool discrease)
{
    UnitChip *tUnitInfo;
    int damage=0,disDamage,effect=0;

    tUnitInfo = &BaseData1->UnitInfo[targetUnit->Type];
    if(tUnitInfo->Type==0){
        int ground = Map->Data[targetUnit->X][targetUnit->Y].Graph;
        effect = BaseData1->MapInfo[ground].Shield;
    }
    *gunType = attackUnit->SelectGun(BaseData1,targetUnit->Type,gunFlag);
    if(*gunType!=-1){
        damage = BaseData1->UnitInfo[attackUnit->Type].Attack[*gunType][targetUnit->Type];
        if(!Option.IgnoreLife){
            damage *= attackUnit->Life;
            damage /= 100;
        }
    }
    //ɂ_[W̌B
    if(discrease){
        disDamage = damage/2;
        if(disDamage>10)
            disDamage=10;
        damage -= disDamage;
    }
    damage -= damage*effect/100; //n`ʁB
    if(Option.DamageFix && damage > targetUnit->Life)
        damage = targetUnit->Life;
    return damage;
}
//---------------------------------------------------------------------------
//\B
__fastcall TForm1::CanCounter(UnitStatus *attackUnit,UnitStatus *targetUnit,UnitChip *targetInfo)
{
    int gun;

    for(gun=0;gun<2;gun++){
        //Œ˒Pȉ̉ΊjbgȂ甽\B
        if(!targetUnit->GunRest[gun] || targetInfo->MinRange[gun] > 1)
            continue;
        if(FieldScreen1->IsNeighbor(targetUnit->X,targetUnit->Y,
                                    attackUnit->X,attackUnit->Y,
                                    targetInfo->MaxRange[gun])){
            return 1;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//_[W󂯁Ał\̂郆jbgɂāA
//ʋyѕ\̍XVsB
//łĂꍇ߂l1AłȂ0
__fastcall TForm1::UpdateDamagedUnit(int side,int unitnum,int unitx,int unity,bool bDraw)
{
    if(SideStatus1[side]->Unit[unitnum].Life > 0)
        return 0;
    if(bDraw){
        if(DrawMapChip(unitx,unity))
            ScreenReviseBlock(unitx,unity);
    }
    KillUnit(side,unitnum);
    return 1;
}
//---------------------------------------------------------------------------
//jbgړEŁEoƂɎEXVčĕ`悷
//decx,decÿʒu王E炵Aincx,incÿʒu王EB
__fastcall TForm1::UpdateLimitView(int decx,int decy,int incx,int incy,UnitChip *UnitInfop)
{
    TRect rect;

    if(decx != -1)
        FieldScreen1->FindVisible(Map,decx,decy,UnitInfop->Visibility+1,-1);
    if(incx != -1)
        FieldScreen1->FindVisible(Map,incx,incy,UnitInfop->Visibility+1,1);
    if(!ApplyShade){
        UpdateShade();
        FieldScreen1->GetDrawRect(Map,&rect);
        ScreenRevise(rect);
    }
    return 0;
}
//---------------------------------------------------------------------------
//Shade  Visible ƖĂ鏊 Shade XVB
//ɕω RangePoint 1ɂB
__fastcall TForm1::UpdateShade(void)
{
    int x,y,px,py,side;

    for(y=0;y<Map->Height;y++)
        for(x=0;x<Map->Width;x++)
            if(Map->Shade[x][y]){
                if(Map->Visible[x][y]){
                    side = Map->Data[x][y].Side;
                    if(side != -1)
                        FieldScreen1->UnitPutAuto(Map,SideStatus1[side],x,y,true);
                    else{
                        FieldScreen1->XY_MapToPhy(x,y,&px,&py);
                        FieldScreen1->MapChipPut(px,py,Map->Data[x][y].Graph);
                    }
                    Map->Shade[x][y] = false;
                    Map->RangePoint[x][y] = 1;
                }
            }
            else{
                if(!Map->Visible[x][y]){
                    FieldScreen1->XY_MapToPhy(x,y,&px,&py);
                    FieldScreen1->DrawMapChipShade(px,py,Map->Data[x][y].Graph);
                    Map->Shade[x][y] = true;
                    Map->RangePoint[x][y] = 1;
                }
            }
    return 0;
}
//---------------------------------------------------------------------------
//tŃ}bv̒n``悷B͘_WB
//`悵ꍇ 1AȂꍇ 0ԂB
__fastcall TForm1::DrawMapChip(int x,int y)
{
    if(OutsideVisible(x,y))
        return 0;
    FieldScreen1->DrawMapChipShadeZ(Map,x,y);
    return 1;
}
//---------------------------------------------------------------------------
//tŃjbg`悷B͘_WB
//`悵ꍇ 1AȂꍇ 0ԂB
__fastcall TForm1::DrawUnit(int x,int y,int side,bool DrawEnd)
{
    if(OutsideVisible(x,y))
        return 0;
    FieldScreen1->UnitPutAuto(Map,SideStatus1[side],x,y,DrawEnd);
    return 1;
}
//---------------------------------------------------------------------------
/*//Ww肵Aʂ̍XVtŃjbg`悷B
//܂}bv̂̈ʒuɓo^ĂȂjbgꎞIɕ\邽߂̊֐Bgp
__fastcall TForm1::DrawUnitWithRevise(int x,int y,UnitStatus *unitp)
{
    if(OutsideVisible(x,y))
        return 0;
    FieldScreen1->UnitPutAuto(Map,SideStatus1[side],x,y,DrawEnd);
    return 1;
}*/
//---------------------------------------------------------------------------
//w肵WɍU͈̓J[\`ĉʂXVAɃobNAbvB
__fastcall TForm1::DrawAttackRadius(int x,int y,int r)
{
    FieldScreen1->DrawCursorMegaHex(x,y,CURSOR_ATTACK,0,r);
    ScreenRevise(FieldScreen1->BackupRect[BKUP_MEGAHEX]);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::EraseAttackRadius(void)
{
    if(FieldScreen1->Backuped[BKUP_MEGAHEX]){
        FieldScreen1->RestoreBitmapOnce(BKUP_MEGAHEX);
        ScreenRevise(FieldScreen1->BackupRect[BKUP_MEGAHEX]);
    }
    return 0;
}
//---------------------------------------------------------------------------
//wWił邾jSɂȂ悤ɃXN[
__fastcall TForm1::SysAutoScroll(int zx,int zy)
{
    ScrollBox1->HorzScrollBar->Position=zx*FieldScreen1->GraphDegree-ScrollBox1->Width/2;
    ScrollBox1->VertScrollBar->Position=zy*FieldScreen1->GraphDegree-ScrollBox1->Height/2;
    return 0;
}
//---------------------------------------------------------------------------
//EFCgBPʂ̓~biCLK_TCK萔ɂj
__fastcall TForm1::TimeWait(int Time)
{
    clock_t clk;

    clk=clock();
    System.Controlable=false; //ꎞIɃAv̎s~
    while(clock()<clk+Time)
        Application->ProcessMessages();
    System.Controlable=true;
    return 0;
}
//---------------------------------------------------------------------------
//_[W\pEFCg
__fastcall TForm1::DamageWait(int Time)
{
    if(!System.NoDraw)
        TimeWait(Time*Option.DamageWaitFix/100);
    return 0;
}
//---------------------------------------------------------------------------
//jbgQƃEFCg
__fastcall TForm1::LookUpWait(int Time)
{
    TimeWait(Time*Option.LookUpWaitFix/100);
    return 0;
}
//---------------------------------------------------------------------------
//botpEFCg
__fastcall TForm1::CPUWait(int Time)
{
    if(!System.StopDemand && !System.NoDraw)
        TimeWait(Time*Option.CPUWaitFix/100);
    return 0;
}
//---------------------------------------------------------------------------
//bot̉z}EX
__fastcall TForm1::CPUMouse(int zx,int zy)
{
    if(zx<0 || zy<0 || zx>=Map->Width || zy>=Map->Height){
        char str[64];
        sprintf(str,"CPUMouse error (%d,%d)",zx,zy);
        PrintError(str);
        return -1;
    }
    MouseLeftDown(zx,zy);
    return 0;
}
//---------------------------------------------------------------------------
//bot̃jbgړ zx,zy:ړIW tx,ty:UڕW
//Target=-1̎U
__fastcall TForm1::ComControlUnit(int moveX,int moveY,int unitNum,int action,
    int gunType,int targetX,int targetY)
{
    int ux,uy,tx,ty;
    char str[100];

    ux = SideStatus1[Situation->Phase]->Unit[unitNum].X;
    uy = SideStatus1[Situation->Phase]->Unit[unitNum].Y;
    if(Map->Data[ux][uy].Side==-1){
        sprintf(str,"CPUٰݴװ:No unit\nux=%d,uy=%d,num=%d",ux,uy,unitNum);
        PrintError(str);
        return -1;
    }
    //̏őҋ@邾Ȃ
    if(ux==moveX && uy==moveY && action==ACTION_NOACTION){
        //RȊO̎{ݏłȂΉȂ
        if(!(Map->Data[moveX][moveY].IsBuilding() &&
             Map->Data[moveX][moveY].Graph/BUILDINGMAX != Situation->Phase)){
            SideStatus1[Situation->Phase]->Unit[unitNum].Actioned = true;
            return 0; //Iɍsς݃tO𗧂Ă
        }
    }

    if(Option.CPUScroll && !System.NoDraw){
        SysAutoScroll(moveX,moveY);
        CPUWait(WAIT_CPUSCROLL);
    }

    CPUMouse(ux,uy);
    CPUWait(WAIT_SHOWMOVE); //ړ͈͂\

    System.UseGun = gunType; //KwNXUΊȂꍇ͒P-1łB
    CPUMouse(moveX,moveY);      //ړMouseDown
    if(System.PhaseEndable)     //G[hœGɏՓ˂瑀I
        return 0;
    CPUWait(WAIT_SHOWATTACK);   //U͈͂\

    if(action==ACTION_NOACTION){
        CPUMouse(moveX,moveY);
    }
    else{
        if(action==ACTION_DOWNUNIT){   //~ԑ
            while(SideStatus1[Situation->Phase]->Unit[unitNum].Load){
                MindNextDown(moveX,moveY,&tx,&ty);
                if(tx!=-1){
                    CPUMouse(tx,ty);
                      //G[hœG̋ꏊɍ~Ԃ悤Ƃ瑀I
                    if(System.PhaseEndable)
                        break;
                    CPUWait(WAIT_SHOWLOAD);
                }
                else{ //~ԂȂxNbN
                    CPUMouse(moveX,moveY);
                    break;
                }
            }
        }
        else{
            CPUMouse(targetX,targetY);
        }
    }

    if(!System.PhaseEndable){
        sprintf(str,"CPUٰݴװ:Wrong control\naction=%d",action);
        PrintError(str);
    }

    CPUWait(WAIT_SHOWMOVEEND);

    return 0;
}
//---------------------------------------------------------------------------
//~ԏꏊ߂
__fastcall TForm1::MindNextDown(int zx,int zy,int *tx,int *ty)
{
    int AddX[2][6]={{0,1,1,1,0,-1},{-1,0,1,0,-1,-1}}, //IWiFieldScreen::RangeTrace()
        AddY[6]={-1,-1,0,1,1,0};
    int i,x,y;

    *tx=-1;
    for(i=0;i<6;i++){
        x=zx+AddX[zy%2][i];
        y=zy+AddY[i];
        if(x<0 || x>=Map->Width || y<0 || y>=Map->Height)
            continue;
        if(Map->RangePoint[x][y] && Map->Data[x][y].Side==-1){
            *tx=x;
            *ty=y;
            break;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//bot̃jbgY zx,zy:YW Graph:Yjbg
__fastcall TForm1::ComCreateUnit(int zx,int zy,int Graph)
{
    if(!CanCreateUnit(zx,zy))
        PrintError("CPUٰݴװ:Wrong Create");
    MoneyOperation(Situation->Phase,-BaseData1->UnitInfo[Graph%UNITTYPEMAX].Value);
    NewUnit(zx,zy,Situation->Phase,Graph);
    CPUWait(WAIT_SHOWCREATE);
    return 0;
}
//---------------------------------------------------------------------------
//bot샂[h
__fastcall TForm1::ComputerControl(void)
{
    MapData *OccupyMap=new MapData(),
            *DangerMap=new MapData();
    int i,j,k,m,x,y,count=0,units,moveX,moveY,action,targetX,targetY,gunType;
    int CreateCount=0,CreateX[COMCREATEMAX],CreateY[COMCREATEMAX];
    char str[100];

    if(System.GameEnd){
        delete DangerMap;
        delete OccupyMap;
        return 0;
    }

    System.CPUControl=true;
    ProgressBar_CPU->Visible=true;

    *OccupyMap=*Map;
    OccupyMap->InitRange();
    for(y=0;y<Map->Height;y++) //̒n`̎͂̃|Cgグ
        for(x=0;x<Map->Width;x++) //̃g[X
            if(Map->Data[x][y].IsBuilding() && Map->Data[x][y].BSide()!=Situation->Phase)
                FieldScreen1->ExtraRangeSearch(OccupyMap,BaseData1,x,y,64,UT_SOLDIER,4,false);

    System.NoDraw = Option.CPUNoGrp;
        //eLTN[hő肪vC[̎
        //`Gwc̎E̋yԔ͈͂ɐ
    if(!Situation->CPUMode[!Situation->Phase] || DEBUG_SHADE)
        if(SideStatus1[!Situation->Phase]->LimitView){
            ApplyShade = true;
            FieldScreen1->RangeLimit = true;
        }

    units = SideStatus1[Situation->Phase]->UnitCount;
    for(;;){
        if(!System.PhaseEndable){
            sprintf(str,"CPUװ:Hold=%d,Move=%d",System.HoldUnit,System.MovingUnit);
            PrintError(str);
        }
        System.CPUMinding=true;
        ComMindDangerous(DangerMap,0); //ɍl
        j=SearchActionable(DangerMap);
        if(j==-1)
            break;
        ComMindUnit(OccupyMap,j,&moveX,&moveY,&action,&targetX,&targetY,&gunType);
        System.CPUMinding=false;
        ComControlUnit(moveX,moveY,j,action,gunType,targetX,targetY);
        count++;
        if(System.NoDraw) //EFCg
            TimeWait(10);
        if(units) //ProgressBar::Max=100ƂB
            ProgressBar_CPU->Position = (count*100)/units;
        if(System.StopDemand)
            break;
        if(ErrorHappened){
            ShowMessage("CPȖ쒆ɃG[܂B\nG[e _errors.txt ɏo͂܂B\nvOIăG[e҂ɂm点B");
            break;
        }
    }
    if(System.StopDemand){
        delete DangerMap;
        delete OccupyMap;
        DemandExec();
        ProgressBar_CPU->Visible = false;
        ProgressBar_CPU->Position = 0;
        System.NoDraw = false;
        return 0;
    }

    //`悵ĂȂ\ΑSĕ`
    //ACPU̍sSB(ApplyShade)ꍇ͂ł͍ĕ`悵Ȃ
    if(!ApplyShade && System.NoDraw){
        DrawAll();
        ScreenReviseAll();
        System.NoDraw = false;
    }

    ComMindDangerous(DangerMap,0); //ɍl
    for(y=0;y<Map->Height;y++)
        for(x=0;x<Map->Width;x++)
            if(CreateCount<COMCREATEMAX && CanCreateUnit(x,y)){
                CreateX[CreateCount]=x;
                CreateY[CreateCount]=y;
                CreateCount++;
            }

    for(i=0;i<CreateCount;i++){
        if(SideStatus1[Situation->Phase]->UnitCount >= Situation->UnitMax)
            break;
        k=-1;
        m=-10000;
        for(j=0;j<CreateCount;j++){
            x=CreateX[j];
            y=CreateY[j];
            if(x==-1)
                continue; //vlI͔΂
            if(DangerMap->RangePoint[x][y] >= m){
                m=DangerMap->RangePoint[x][y];
                k=j;      //댯ȏ琶Y
            }
        }
        if(k!=-1){
            x=CreateX[k];
            y=CreateY[k];
            m=ComMindCreate(x,y,DangerMap->RangePoint[x][y]);
            if(m!=-1){
                if(Option.CPUScroll){
                    SysAutoScroll(x,y);
                    CPUWait(WAIT_CPUSCROLL);
                }
                ComCreateUnit(x,y,m+Situation->Phase*UNITTYPEMAX);
            }
            CreateX[k]=-1; //łQlȂ
        }
        if(System.StopDemand)
            break;
    }
    ProgressBar_CPU->Visible = false;
    ProgressBar_CPU->Position = 0;
    if(System.StopDemand){  //fv̌Ăяo
        delete DangerMap;
        delete OccupyMap;
        DemandExec();
        return 0;
    }

    //`悵ĂȂ\ΑSĕ`
    if(System.NoDraw){
        DrawAll();
        ScreenReviseAll();
        System.NoDraw = false;
    }

    PhaseEndExec(false);
    System.CPUControl = false;
    ApplyShade = false;
    FieldScreen1->RangeLimit = false;
    delete DangerMap;
    delete OccupyMap;

    return 0;
}
//---------------------------------------------------------------------------
//sł郆jbgT
__fastcall TForm1::SearchActionable(MapData *DangerMap)
{
    UnitStatus *Unitp;
    UnitChip *UnitInfop;
    int i,j,Point,MaxPoint=-10000,Unit=-1;

    for(i=0;i<SideStatus1[Situation->Phase]->UnitCount;i++){
        Unitp = &SideStatus1[Situation->Phase]->Unit[i];
        UnitInfop = &BaseData1->UnitInfo[Unitp->Type];
        if(!UnitActionable(Situation->Phase,i))
            continue;
        Point=DangerMap->RangePoint[Unitp->X][Unitp->Y];
        j=max(UnitInfop->MaxRange[0],UnitInfop->MaxRange[1]);
        if(j>1)
            Point+=Unitp->Life*j/2;
        if(UnitInfop->Loadable > Unitp->Load)
            Point-=1000; //ډ\jbg͒Ꮗ
        if(Point>MaxPoint){
            Unit=i;
            MaxPoint=Point;
        }
    }
    return Unit;
}
//---------------------------------------------------------------------------
//w胆jbgs\ǂԂ
__fastcall TForm1::UnitActionable(int Side,int Num)
{
    if(Situation->Phase!=Side)
        return 0;
    if(SideStatus1[Side]->Unit[Num].Actioned)
        return 0;
    if(SideStatus1[Side]->Unit[Num].X==-1)
        return 0;

    return 1;
}
//---------------------------------------------------------------------------
//bot쒆f̗vĂяo
__fastcall TForm1::DemandExec(void)
{
    switch(System.NowDemand){
    case DEMAND_OPEN:
        MIOpenClick(NULL);
        break;
    case DEMAND_SAVE:
        MISaveClick(NULL);
        break;
    case DEMAND_LOAD:
        MILoadClick(NULL);
        break;
    }
    System.StopDemand=false;
    System.NowDemand=DEMAND_NONE;
    return 0;
}
//---------------------------------------------------------------------------
//botvlijbgj
//jbgsāAőP̃|CgԂ
__fastcall TForm1::ComMindUnit(MapData *OccupyMap,int UnitNum,
    int *moveX,int *moveY,int *action,int *targetX,int *targetY,int *gunType)
{
    SideStatus *SideBack[2];
    UnitStatus *Unitp,*UnitBack=new UnitStatus();
    UnitChip *UnitInfop;
    MapStatus *ground;
    MapData *MapBack=new MapData(),
            *MapBack2=new MapData(),
            *SupplyMap=new MapData(),
            *PurposeMap=new MapData(),
            *DangerMap=new MapData(),
            *OccupySky=NULL;
    int i,j,k,x,y,tx,ty,ux,uy,act,gun,Point,Step,MaxPoint=-10000,
        OnCreate=-100,LoadPoint=100,PlusPoint=100,
        DangerPoint=-4,
        PurposePoint=5,SupplyPoint=0,OccupyPoint=2;
    bool NoMove,Loading;

    *action = ACTION_NOACTION;

    for(i=0;i<2;i++){  //wcf[^̃obNAbv
        SideBack[i]=new SideStatus(i);
        *SideBack[i]=*SideStatus1[i];
    }
    *MapBack=*Map;
    *SupplyMap=*Map;
    *PurposeMap=*Map;
    *DangerMap=*Map;

    Unitp=&SideStatus1[Situation->Phase]->Unit[UnitNum];
    UnitInfop=&BaseData1->UnitInfo[Unitp->Type];
    *moveX=ux=Unitp->X;
    *moveY=uy=Unitp->Y;

    SupplyMap->InitRange();
    i=BaseData1->UnitInfo[Unitp->Type].MoveMax*4;
    for(y=0;y<Map->Height;y++) //⋋n`̎͂̃|Cgグ
        for(x=0;x<Map->Width;x++)
            if(Map->Data[x][y].Graph<20 && Map->Data[x][y].Graph/BUILDINGMAX==Situation->Phase)
                if(BaseData1->UnitInfo[Unitp->Type].Supply[Map->Data[x][y].Graph%BUILDINGMAX])
                    FieldScreen1->ExtraRangeSearch(SupplyMap,BaseData1,x,y,i,Unitp->Type,1,false);
    SupplyPoint += (100-Unitp->Life)/20;  //LifeȂ
    if(Unitp->Fuel<BaseData1->UnitInfo[Unitp->Type].FuelMax/3)
        SupplyPoint+=3;  //cRȂ
    for(i=0;i<2;i++)
        if(BaseData1->UnitInfo[Unitp->Type].GunMax[i] && !Unitp->GunRest[i])
            SupplyPoint+=3;  //e򂪐sĂ鎞

    PurposeMap->InitRange(); //G̎sڎw
    if(Map->SearchChip((!Situation->Phase)*BUILDINGMAX,&x,&y)){
        if(UnitInfop->Type==1)
            i=UT_SOLDIER;
        else
            i=Unitp->Type;
        if(BaseData1->UnitInfo[i].MoveMax){ //ړ͂Ȃ璲
            Step=12/BaseData1->UnitInfo[i].MoveMax;
            FieldScreen1->ExtraRangeSearch(PurposeMap,BaseData1,x,y,Step*128,i,Step,false);
        }
    }
    if(UnitInfop->Type==1){ //Cテjbg͗O
        j=0;
        for(y=0;y<Map->Height;y++)
            for(x=0;x<Map->Width;x++)
                if(Map->Data[x][y].IsPort())
                    if(PurposeMap->RangePoint[x][y]>j){
                        tx=x;
                        ty=y;
                        j=PurposeMap->RangePoint[x][y];
                    } //łsɋ߂`ڎw
        if(j)
            FieldScreen1->ExtraRangeSearch(PurposeMap,BaseData1,tx,ty,128,UT_BATTLESHIP,1,false);
        for(y=0;y<Map->Height;y++)
            for(x=0;x<Map->Width;x++)
                if(Map->Data[x][y].IsPort())
                    PurposeMap->RangePoint[x][y]=0;
    }
    if(!PurposeMap->RangePoint[ux][uy])
        FieldScreen1->ExtraRangeSearch(PurposeMap,BaseData1,x,y,64,UT_MIGHTYSEARCH,1,false);
    ComMindDangerous(DangerMap,Unitp->Type);

    if(UnitInfop->Type==2){
        OccupySky=new MapData();
        *OccupySky=*Map;
        OccupySky->InitRange();
        for(y=0;y<Map->Height;y++) //̒n`̎͂̃|Cgグ
            for(x=0;x<Map->Width;x++) //q󕔑̃g[X
                if(Map->Data[x][y].IsBuilding() && Map->Data[x][y].BSide()!=Situation->Phase)
                    FieldScreen1->ExtraRangeSearch(OccupySky,BaseData1,x,y,64,Unitp->Type,4,false);
    }

    FieldScreen1->MoveRangeSearch(Map,BaseData1,&SideStatus1[Situation->Phase]->Unit[UnitNum],Situation->Phase,ux,uy);
    *MapBack2=*Map;
    *UnitBack=*Unitp;
    for(y=0;y<Map->Height;y++)
        for(x=0;x<Map->Width;x++){
            if(!Map->RangePoint[x][y])
                continue;
            ground = &Map->Data[x][y];
            act = ACTION_NOACTION;
            gun = -1;
            Point=0;
            NoMove = (x==ux && y==uy);
            if(Unitp->Type==UT_BATTERY)
                if(!CanSupplyUnit(x,y,Situation->Phase,UT_BATTERY))
                    Point-=1000; //C͕⋋\n_ɂȂ
            Loading=false;
            if(ground->Side!=-1 && !NoMove){
                i = SideStatus1[Situation->Phase]->Unit[ground->Unit].Type;
                if(i==Unitp->Type){
                    if(SideStatus1[Situation->Phase]->UnitCount > Situation->UnitMax/2)
                        Point+=PlusPoint;
                }
                else
                    if(DangerMap->RangePoint[x][y]<=DangerAverage && OccupyMap->RangePoint[ux][uy]<30)
                        Point+=LoadPoint;
                Loading=true;
                //ڂ܂͍BǂɂU͂łȂ
            }
            if(UnitInfop->CanOccupy && ground->IsBuilding() && ground->BSide()!=Situation->Phase)
                Point+=(400-Map->Data[x][y].Life);
            if(!UnitInfop->CanOccupy && ground->Building()==GND_CAPITAL)
                Point-=1000; //E퓬HȊOGsɂ͓Ȃ
            Point+=SupplyPoint*SupplyMap->RangePoint[x][y];
            if(SupplyPoint<4){ //⋋DłȂ
                i = PurposeMap->RangePoint[x][y];
                i *= PurposePoint*2;
                if(UnitInfop->Type==2)
                    j=OccupySky->RangePoint[x][y];
                else
                    j=OccupyMap->RangePoint[x][y];
                k=(Unitp->Type<=1 || (Unitp->Load && Unitp->LoadingType(SideStatus1[Situation->Phase],0)<=1));
                j=(j*OccupyPoint*(1+k*9))/10;
                if(i>j || UnitInfop->Type==1)
                    Point+=i; //C㕔͍`̐̃|Cg𖳎
                else
                    Point+=j;
                if(!Loading && ground->Create && ground->BSide()==Situation->Phase)
                    Point+=OnCreate; //Y{݂̏
            }
            else{
                if(CanSupplyUnit(x,y,Situation->Phase,Unitp->Type))
                    Point+=SupplyPoint*4;
            }
            if(DangerMap->RangePoint[x][y] > 0) //̊댯x͔F߂Ȃ
                Point+=DangerPoint*DangerMap->RangePoint[x][y];
            if(UnitInfop->Type==0) //n`ʂ̍l
                Point+=BaseData1->MapInfo[ground->Graph].Shield/5;
            if(!Loading){
                if(UnitInfop->HasMegaHex() && (NoMove || UnitInfop->SuperMissile)){
                    int max_p=0;
                    for(i=0;i<2;i++){
                        if(!Unitp->GunRest[i])
                            continue;
                        if(UnitInfop->Radius[i] <= 1){
                            FieldScreen1->AttackRangeSearch(Map,BaseData1,Unitp,SideStatus1[!Situation->Phase],x,y,NoMove,false);
                            FieldScreen1->LoadRangeSearch(Map,BaseData1,Unitp,Situation->Phase,x,y);
                        }
                        else if(NoMove){
                            FieldScreen1->FindSingleAttackRange(Map,BaseData1,Unitp,x,y,i,Situation->Phase);
                        }
                        MoveUnit(x,y,Situation->Phase,UnitNum,false);
                        int p = ComVirtualAttack(OccupyMap,UnitNum,&act,&tx,&ty,i);
                        if(p > max_p){
                            gun = i;
                            max_p = p;
                        }
                    }
                    Point += max_p;
                }
                else{
                    FieldScreen1->AttackRangeSearch(Map,BaseData1,Unitp,SideStatus1[!Situation->Phase],x,y,NoMove,false);
                    FieldScreen1->LoadRangeSearch(Map,BaseData1,Unitp,Situation->Phase,x,y);
                    MoveUnit(x,y,Situation->Phase,UnitNum,false);
                    Point += ComVirtualAttack(OccupyMap,UnitNum,&act,&tx,&ty,-1);
                }
            }
            if(Point>MaxPoint){
                MaxPoint = Point;
                *moveX = x;
                *moveY = y;
                *action = act;
                *targetX = tx;
                *targetY = ty;
                *gunType = gun;
            }
            *Map=*MapBack2;
            if(tx!=-1 || Loading){ //퓬ځAĂ
                for(i=0;i<2;i++)
                    *SideStatus1[i] = *SideBack[i];
            }
            else{
                *Unitp=*UnitBack;
            }
        }
    *Map=*MapBack;
    for(i=0;i<2;i++)
        *SideStatus1[i]=*SideBack[i];
    delete UnitBack;
    delete SideBack[0];
    delete SideBack[1];
    delete DangerMap;
    delete PurposeMap;
    delete SupplyMap;
    delete MapBack;
    delete MapBack2;
    if(OccupySky!=NULL)
        delete OccupySky;
    return MaxPoint;
}
//---------------------------------------------------------------------------
//botzU  ߂l͍ŗǑĨ|Cg
__fastcall TForm1::ComVirtualAttack(MapData *OccupyMap,int unitNum,
    int *action,int *tx,int *ty,int gunType)
{
    UnitStatus *unitp;
    UnitChip *unitInfop;
    int p,x,y,point,maxPoint=0;
    const int point_unload=0;

    *tx=-1;
    unitp = &SideStatus1[Situation->Phase]->Unit[unitNum];
    unitInfop = &BaseData1->UnitInfo[unitp->Type];
    if(unitInfop->SuperMissile){
        p = ComGetAttackPoint(unitp,unitp->X,unitp->Y,gunType);
        if(p != -1){
            maxPoint = p;
            if(unitp->X > 0)
                *tx = unitp->X-1;
            else
                *tx = unitp->X+1;
            *ty = unitp->Y;
            *action = ACTION_ATTACK;
        }
        return maxPoint;
    }
    for(y=0;y<Map->Height;y++){
        for(x=0;x<Map->Width;x++){
            if(!Map->RangePoint[x][y])
                continue;
            point=0;  //|CǧvZ
            // Ί킪w肳ĂȂAjbg݂Ȃ
            // ~Ԃ̃|CgvZB
            if(gunType==-1 && Map->Data[x][y].Side==-1){
                point += point_unload + (OccupyMap->RangePoint[x][y])*100;
                if(point > maxPoint){
                    maxPoint = point;
                    *action = ACTION_DOWNUNIT;
                }
            }
            else{
                p = ComGetAttackPoint(unitp,x,y,gunType);
                if(p != -1){
                    point += p;
                    if(point > maxPoint){
                        maxPoint = point;
                        *tx=x;
                        *ty=y;
                        *action = ACTION_ATTACK;
                    }
                }
            }
        }
    }

    return maxPoint;
}
//---------------------------------------------------------------------------
//jbgWɌčUꍇ̃|Cg߂B
//߂l-1̎́AɍUł郆jbg݂ȂB
__fastcall TForm1::ComGetAttackPoint(UnitStatus *attack,int cx,int cy,int gunType)
{
    const int aDeathP=-500,tDeathP=500,aDamageP=-10,tDamageP=15;
    UnitStatus *target;
    UnitChip *attackInfo = &BaseData1->UnitInfo[attack->Type];
    UnitChip *targetInfo;
    int i,j,damage,point=0,gunFlag,radius,count,tx,ty,side;
    bool existEnemy=false;
    POINT list[1024];

    if(gunType == -1){
        gunFlag = 3;
        radius = 1;
    }
    else{
        gunFlag = (1<<gunType);
        radius = attackInfo->Radius[gunType];
    }
    count = FieldScreen1->GetNeighborList(cx,cy,0,radius,Map->Width,Map->Height,list,1024);
    for(i=0;i<count;i++){
        tx = list[i].x;
        ty = list[i].y;
        side = Map->Data[tx][ty].Side;
        if(side==-1)
            continue;
        target = &SideStatus1[side]->Unit[Map->Data[tx][ty].Unit];
        targetInfo = &BaseData1->UnitInfo[target->Type];
        damage = CalcDamage(attack,target,&j,gunFlag,false);
        //jbg̏ꍇ͕tɂB
        //͒PɎ蔲łAYɗ͔ꍇ͏vB
        if(side==Situation->Phase)
            damage = -damage;
        point += tDamageP*ComMindDamage(damage,target->Type);
        if(target->Life <= damage)
            point += tDeathP;
        if(Map->Data[tx][ty].Create)
            point = point*15/10;
        existEnemy |= (damage > 0);
    }

    if(existEnemy){
        if(count==1 && CanCounter(attack,target,targetInfo)){
            damage = CalcDamage(target,attack,&i,-1,true);
            point += aDamageP*ComMindDamage(damage,attack->Type);
            if(attack->Life <= damage)
                point += aDeathP;
        }
        else{
            //ԐڍȔꍇA댯ȃ^[QbgD悷B
            if(attackInfo->MaxRange[gunType] > 1)
                point += point*ComMindDamage(CalcDamage(target,attack,&i,-1,false),attack->Type)/30;
        }
        return point;
    }
    return -1;
}
//---------------------------------------------------------------------------
//botvlijbgYj
__fastcall TForm1::ComMindCreate(int zx,int zy,int Dangerous)
{
    int i,j,k,x,y,u,v,*p,ValuePoint,Count[UNITTYPEMAX],
        NearU[2][UNITTYPEMAX],NearC[BUILDINGMAX],
        Type,Point[UNITTYPEMAX],MaxPoint=0,UnitType=-1;
    MapData *MindMap=new MapData();
    UnitChip *UnitInfop;
    SideStatus *MySide,*EnemySide;

    MySide = SideStatus1[Situation->Phase];
    EnemySide = SideStatus1[!Situation->Phase];

    *MindMap = *Map;
    for(i=0;i<UNITTYPEMAX;i++){
        Count[i]=0; //̃jbgޕʂɐ
        Point[i]=0;
    }
    p=NearU[0];
    for(i=0;i<UNITTYPEMAX*2;i++)
        *p++=0;  //{݂̎͂̎{݂𐔂
    for(i=0;i<BUILDINGMAX;i++)
        NearC[i]=0;

    for(i=0;i<MySide->UnitCount;i++)
        Count[MySide->Unit[i].Type]++;

    MindMap->InitRange();
    FieldScreen1->ExtraRangeSearch(MindMap,BaseData1,zx,zy,7,UT_MIGHTYSEARCH,1,false);
    for(y=0;y<MindMap->Height;y++)
        for(x=0;x<MindMap->Width;x++){
            if(MindMap->RangePoint[x][y]){
                if(MindMap->Data[x][y].Side!=-1){
                    i=MindMap->Data[x][y].Side;
                    j=MindMap->Data[x][y].Unit;
                    if(SideStatus1[i]->Unit[j].Life>50){
                        k=SideStatus1[i]->Unit[j].Type;
                        NearU[i][k]++;
                    }//͂̃jbgiGj𐔂
                }    //Ct̒Ⴂ͐ɓȂ
                if(CanCreateUnit(x,y))
                    NearC[MindMap->Data[x][y].Graph%BUILDINGMAX]++;
                     //͂̐Y\Ȏ{݂̃JEgB
            }
        }

    Type=Map->Data[zx][zy].Building();
    switch(Type){
    case GND_CAPITAL:
    case GND_CITY:
    case GND_FACTORY:
    case GND_BIGFACTORY:
        if(Count[UT_SOLDIER]<10)
            Point[UT_SOLDIER]+=(10-Count[UT_SOLDIER])*200;
        if(Count[UT_SOLDIER2]>8)
            Point[UT_SOLDIER2]-=(Count[UT_SOLDIER2]-8)*200;
        if(Count[UT_TANK_B]>5)
            Point[UT_TANK_B]-=(Count[UT_SOLDIER2]-5)*200;
        break;
    case GND_AIRPORT:
    case GND_BIGAIRPORT:
        Point[UT_CARRYHELI]+=(5-Count[UT_CARRYHELI])*150;
        Point[UT_FIGHTER_A]+=(2-Count[UT_FIGHTER_A])*200;
        break;
    case GND_SHIPPORT:
    case GND_SHIPYARD:
        i=NearU[!Situation->Phase][UT_BATTLESHIP]-NearU[Situation->Phase][UT_BATTLESHIP];
        i+=NearU[!Situation->Phase][UT_BATTERY]-NearU[Situation->Phase][UT_BATTERY];
        i+=NearU[!Situation->Phase][UT_BOMBER]-NearU[Situation->Phase][UT_FIGHTER_A];
        if(i<0)
            i=0;
        Point[UT_BATTLESHIP]-=i*100;
        Point[UT_PLANESHIP]-=i*100;
        Point[UT_CARRYSHIP]+=(2-Count[UT_CARRYSHIP])*200-i*100;
        j = NearU[!Situation->Phase][UT_BATTLESHIP]
           -NearU[Situation->Phase][UT_BATTLESHIP]
           +NearU[!Situation->Phase][UT_SUBMARINE]
           -NearU[Situation->Phase][UT_SUBMARINE];
        if(j>0)
            Point[UT_SUBMARINE]-=j*100;
        break;
    }

    for(i=0;i<UNITTYPEMAX;i++){
        if(!BaseData1->CanCreateUnit(Type,i,SideStatus1[Situation->Phase]->LimitView))
            continue;
        UnitInfop = &BaseData1->UnitInfo[i];
        for(j=0;j<EnemySide->UnitCount;j++){
            u = EnemySide->Unit[j].Type;
            v = sqrt(BaseData1->UnitInfo[u].Value/1000);
            for(k=0;k<2;k++)
                Point[i] += UnitInfop->Attack[k][u]*v;
        } //葤̃jbgɑ΂čU͂̍I
        if(i==UT_BATTERY){
            j = NearC[GND_CAPITAL]+NearC[GND_CITY]+NearC[GND_FACTORY]+NearC[GND_BIGFACTORY];
            if(j<4) //͂ɏ\ȐY{݂͖C̃|Cg
                Point[i]-=(4-j)*5000;
        }
        if(Count[i] > Situation->UnitMax/5)
            Point[i] -= (Count[i]-Situation->UnitMax/5)*Point[i]/Situation->UnitMax;
        //jbgΐ̃^Cṽ|Cg𑝂₷
        if(!MySide->UnitCount && UnitInfop->CanOccupy)
            Point[i] += 1000;
    }

    for(i=0;i<UNITTYPEMAX;i++){
        if(!BaseData1->CanCreateUnit(Type,i,SideStatus1[Situation->Phase]->LimitView))
            continue;
        ValuePoint=((int)sqrt((double)BaseData1->UnitInfo[i].Value/1000));
        if(Dangerous>0)
            ValuePoint/=Dangerous;
        if((SideStatus1[Situation->Phase]->Money<BaseData1->UnitInfo[i].Value*2 || SideStatus1[Situation->Phase]->UnitCount<Situation->UnitMax/2) && ValuePoint)
            Point[i]/=ValuePoint;
        if(Point[i]>MaxPoint && SideStatus1[Situation->Phase]->Money>=BaseData1->UnitInfo[i].Value){
            MaxPoint=Point[i];
            UnitType=i;
        }
    }//u댯v܂́u\Ajbgx̐vł΍jbg
    delete MindMap;
    return UnitType;
}
//---------------------------------------------------------------------------
//botvli댯x̌vZj
__fastcall TForm1::ComMindDangerous(MapData *DangerMap,int UnitType)
{
    int d,i,j,k,m,x,y;

    DangerMap->InitRange();
    for(i=0;i<SideStatus1[!Situation->Phase]->UnitCount;i++){
        x=SideStatus1[!Situation->Phase]->Unit[i].X;
        if(x==-1)
            continue;
        y=SideStatus1[!Situation->Phase]->Unit[i].Y;
        j=SideStatus1[!Situation->Phase]->Unit[i].Type;
        k=SideStatus1[!Situation->Phase]->Unit[i].Life;
        if(!BaseData1->UnitInfo[j].GunMax[0])
            continue;   //U\̖͂jbg͖
        m=max(BaseData1->UnitInfo[j].Attack[0][UnitType],BaseData1->UnitInfo[j].Attack[1][UnitType]);
        d=m*k/1000;
        FieldScreen1->ExtraRangeSearch(DangerMap,BaseData1,x,y,BaseData1->UnitInfo[j].MoveMax*d,j,d,false);
        FieldScreen1->ExtraRangeSearch(DangerMap,BaseData1,x,y,BaseData1->UnitInfo[j].MaxRange[0],UT_MIGHTYSEARCH,d,true);
    }  //ɂƂċЂł郆jbg

    for(i=0;i<SideStatus1[Situation->Phase]->UnitCount;i++){
        x=SideStatus1[Situation->Phase]->Unit[i].X;
        if(x==-1)
            continue;
        y=SideStatus1[Situation->Phase]->Unit[i].Y;
        j=SideStatus1[Situation->Phase]->Unit[i].Type;
        k=SideStatus1[Situation->Phase]->Unit[i].Life;
        d=k/26; //Ct݂̂Ŕf
        FieldScreen1->ExtraRangeSearch(DangerMap,BaseData1,x,y,BaseData1->UnitInfo[j].MoveMax+1,j,-d,true);
        FieldScreen1->ExtraRangeSearch(DangerMap,BaseData1,x,y,BaseData1->UnitInfo[j].MaxRange[0]+1,UT_MIGHTYSEARCH,-d,true);
    }  //͂ɖΊ댯xႢƂ݂Ȃ

    DangerAverage=i=0;//}bvŜ̊댯l̕ς߂
    for(y=0;y<DangerMap->Height;y++)
        for(x=0;x<DangerMap->Width;x++){
            DangerAverage=DangerMap->RangePoint[x][y];
            i++;
        }
    DangerAverage/=i;
    DangerAverage*=DangerAverage>0;

    return 0;
}
//---------------------------------------------------------------------------
//botvli^ꂽ󋵂̃|CgvZj
__fastcall TForm1::ComMindSituation(MapData *Mapp,MapData *DangerMap,SideStatus *Side1,SideStatus *Side2)
{
    UnitStatus *Unitp;
    int i,j,Point=0;

    for(i=0;i<=Side1->UnitCount;i++){
        Unitp=&Side1->Unit[i];
        Point+=Unitp->Life;
        Point+=Unitp->Fuel/4;
        if(sqrt(Unitp->Life/10))
            j=sqrt(Unitp->Life/10);
        else
            j=1;
        Point -= DangerMap->RangePoint[Unitp->X][Unitp->Y]/j;
        if(CanSupplyUnit(Unitp->X,Unitp->Y,Side1->Side,Unitp->Type)){
            Point+=100-Unitp->Life; //⋋\
            Point+=(Unitp->GunRest[0]==0)*40;
            Point+=(BaseData1->UnitInfo[Unitp->Type].GunMax[1] && Unitp->GunRest[1]==0)*40;
        }
        if(Mapp->Data[Unitp->X][Unitp->Y].Create)
            if(Mapp->Data[Unitp->X][Unitp->Y].BSide() == Side2->Side)
                Point+=100; //G̐Y\{݂ǂ
            else
                Point-=50;  //̐Y\{݂ǂ
        if(Unitp->Type<=1){
            j=Mapp->Data[Unitp->X][Unitp->Y].Graph;
            if(j<30){       //̃jbg͗D
                if(j/BUILDINGMAX == Side1->Side)
                    Point+=100;
                else
                    Point+=200-Mapp->Data[Unitp->X][Unitp->Y].Life/2;
            }
        }
    }

    return Point;
}
//---------------------------------------------------------------------------
//botvlii܂߂_[W̕]j
__fastcall TForm1::ComMindDamage(int Damage,int UnitType)
{
    int Value;

    Value = Damage + (Damage*BaseData1->UnitInfo[UnitType].Value/1000)/2;
    return Value/2;
}
//---------------------------------------------------------------------------
//BڕW
__fastcall TForm1::GamePurposeJudge(int Side)
{
    bool Completed[GAMEPURPOSEMAX],Show=false,b;
    char str[100];
    int i;

    for(i=0;i<GAMEPURPOSEMAX;i++)
        Completed[i]=false;

    for(i=0;i<GAMEPURPOSEMAX;i++)
        if(Purposes1[Side]->Data[i].CompleteTurn!=-1)
            Completed[i]=true;
    //ȑÓÂƂ

    for(i=0;i<GAMEPURPOSEMAX;i++)
        if(Purposes1[Side]->Data[i].Enabled && !Completed[i]){
            if(PurposeCondition(Purposes1[Side],i)){
                Completed[i]=true;
                Show=true;
                if(!Purposes1[Side]->AllAnd) //^[L^
                    Purposes1[Side]->Data[i].CompleteTurn=Situation->Turn;
            }
        }
    //Sǂׂ
    b=true;
    for(i=0;i<GAMEPURPOSEMAX;i++)
        if(Purposes1[Side]->Data[i].Enabled && !Completed[i])
            b=false;
    //SĖꍇAS̃^[L^
    if(Purposes1[Side]->AllAnd && b)
        for(i=0;i<GAMEPURPOSEMAX;i++)
            if(Purposes1[Side]->Data[i].Enabled)
                Purposes1[Side]->Data[i].CompleteTurn=Situation->Turn;
     //߂đSĂ̏𖞂E܂͐VPB
    if((!Purposes1[Side]->AllAnd || b) && Show){
        if(Purposes1[Side]->AllAnd)
            strcpy(str,"̃}bv̖ڕW͒B܂B");
        else
            if(b)
                strcpy(str,"SĂ̖ڕWB܂B");
            else
                strcpy(str,"ꕔ̖ڕWB܂B");
        ShowFormPurpose(Side,str);
    }

    return 0;
}
//---------------------------------------------------------------------------
//eB
__fastcall TForm1::PurposeCondition(GamePurposes *Purposesp,int Num)
{
    bool Result=false;
    int ItemValue;

    switch(Num){
    case 0: //Turn^[ȍ~ɁARItemValueValueȏł
        ItemValue=GamePurposeValue(Situation->Phase,Purposesp->Data[Num].ItemID1);
        if(Situation->Turn >= Purposesp->Data[Num].Turn1)
            if(ItemValue >= Purposesp->Data[Num].Value1)
                Result=true;
        break;
    case 1: //Turn^[܂łɁAGRItemValueValueȉł
        ItemValue=GamePurposeValue(!Situation->Phase,Purposesp->Data[Num].ItemID1);
        if(Situation->Turn <= Purposesp->Data[Num].Turn1)
            if(ItemValue <= Purposesp->Data[Num].Value1)
                Result=true;
        break;
    }

    return (int)Result;
}
//---------------------------------------------------------------------------
//B̗vfi{݁EjbgȂǁj̒lvZ
__fastcall TForm1::GamePurposeValue(int Side,int ItemID)
{
    int i,Value,BuildCount[BUILDINGMAX*3];

    Map->SearchBuilding(BuildCount);
    i=ItemID-ITEM_BUILDING;
    if(i>=0 && i<BUILDINGMAX){
        Value=BuildCount[Side*BUILDINGMAX+i];
        return Value; //̐
    }
    switch(ItemID){
    case ITEM_ALLBUILDING: //SĂ̌
        Value=0;
        for(i=0;i<BUILDINGMAX;i++)
            Value+=BuildCount[Side*BUILDINGMAX+i];
        break;
    case ITEM_ALLUNIT:     //jbg
        Value=SideStatus1[Side]->UnitCount;
        break;
    case ITEM_INCOME:
        Value=SideStatus1[Side]->Income;
        break;
    case ITEM_MONEY:
        Value=SideStatus1[Side]->Money;
        break;
    }

    return Value;
}
//---------------------------------------------------------------------------
//BڕW_CAO\
__fastcall TForm1::ShowFormPurpose(int Side,char *TopMessage)
{
    TForm_Purpose *Dialogp=new TForm_Purpose(this);

    Dialogp->Purposesp=Purposes1[Side];
    Dialogp->BaseDatap=BaseData1;
    Dialogp->MakeMessage(TopMessage);
    Dialogp->ShowModal();

    delete Dialogp;
    return 0;
}
//---------------------------------------------------------------------------
//
__fastcall TForm1::GameEndJudge(void)
{
    TForm_End *Dialogp;
    char str[100],str2[100],
         Occupy[9]="",Genocide[11]="";
    int i,j,zx,zy,Winner=-1;

    for(i=0;i<2;i++){
        j=Map->SearchChip(i*BUILDINGMAX,&zx,&zy);
        if(!j){
            Winner=!i;
            strcpy(Occupy,"ś@");
        }
        if(!SideStatus1[i]->UnitCount && Situation->Turn>1){
            Winner=!i;
            strcpy(Genocide,"GS");
        }
    }
    if(Winner!=-1){
        Dialogp=new TForm_End(this);
        Dialogp->MakeLabel();
        Dialogp->Label_Message[0]->Caption=Map->Name;
        strcpy(Dialogp->Version,VERSION); //o[W\̂
        sprintf(str,"퓬F%s̏",BaseData1->SideName[Winner]);
        Dialogp->Label_Message[1]->Caption=str;
        sprintf(str,"F%s%s",Occupy,Genocide);
        Dialogp->Label_Message[2]->Caption=str;
        sprintf(str,"^[F%d",Situation->Turn);
        Dialogp->Label_Message[3]->Caption=str;
        for(i=0;i<2;i++){
            sprintf(str,"c(%s)F%d",BaseData1->SideName[i],SideStatus1[i]->UnitCount);
            Dialogp->Label_Message[4+i]->Caption=str;
        }
        for(i=0;i<2;i++)
            if(Purposes1[Winner]->Data[i].Enabled){
                Purposes1[Winner]->PurposeMessage(i,str2,BaseData1);
                if(Purposes1[Winner]->Data[i].CompleteTurn!=-1)
                    sprintf(str,"%sF%d^[ŒB",str2,Purposes1[Winner]->Data[i].CompleteTurn);
                else
                    sprintf(str,"%sFB",str2);
                Dialogp->Label_Message[6+i]->Caption=str;
            }
        if(Purposes1[Winner]->AllAnd)
            Dialogp->Label_Message[8]->Caption="ȏ̏S";
        Dialogp->Label_Message[10]->Caption="uʂRs[vŃNbv{[hɃRs[܂B";
        Dialogp->ShowModal();
        System.GameEnd=true;
        PhaseEndEnabled(false);
        Dialogp->DeleteLabel();
        delete Dialogp;
    }
    return (Winner!=-1);
}
//---------------------------------------------------------------------------
//tFCYIBۂɂ͊JnĂB
//bRemote=trueȂł̃tFCY̐ؑւ̂ݍsB
__fastcall TForm1::PhaseEndExec(bool bRemote)
{
    int oldPhase,newPhase;

    oldPhase = Situation->Phase;
    newPhase = !oldPhase;
    SideStatus1[oldPhase]->EndClear();
    if(bRemote){
        Situation->Phase = newPhase;
        PhaseStart();
        return 0;
    }

    GamePurposeJudge(oldPhase);
        //eLTNȂ王ES߂
    if(SideStatus1[newPhase]->LimitView){
        FieldScreen1->FindVisibleAll(Map,BaseData1,SideStatus1[newPhase]);
        //lԑCPU̎CPȖȂB
        if(!((!Situation->CPUMode[oldPhase] && Situation->CPUMode[newPhase]) || (Debug_Shade && newPhase))){
            UpdateShade();
        }
    }else
        Map->InitVisible(1);
        //Gh}[N߂Ƀjbgĕ`
    FieldScreen1->DrawAllUnit(Map, SideStatus1[oldPhase], SideStatus1[newPhase]->LimitView);
    ScreenReviseAll();

    Situation->Phase = newPhase;
    PhaseStart();
    if(Debug_Check)
        CheckSituation();
    if(!System.GameEnd && Situation->CPUMode[oldPhase] && !Situation->CPUMode[newPhase]){
        if(Option.CPUSound)
            MessageBeep(MB_ICONASTERISK);
        ShowMessage("tFCYI");
        PhaseEndEnabled(true);
        MoreEnabled(true);
    }
    SysAutoScroll(SideStatus1[newPhase]->PhaseStartX,SideStatus1[newPhase]->PhaseStartY);
    TimeWait(WAIT_CPUSCROLL);
    if(Option.UnitListNoModal && Form_UnitListp->Visible){
        Form_UnitListp->Side=Situation->Phase;
        Form_UnitListp->SideStatusp=SideStatus1[Situation->Phase];
        Form_UnitListp->MakeList();
    }
    if(Situation->CPUMode[Situation->Phase]){
        PhaseEndEnabled(false);
        MoreEnabled(false);
        Timer1->Enabled=true;
    }       //bot̊JnCxgN

    return 0;
}
//---------------------------------------------------------------------------
//VKQ[̏
__fastcall TForm1::OpenEnabled(bool Value)
{
    MIOpen->Enabled=Value;
    SpeedButton_Open->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//Z[ȕ
__fastcall TForm1::SaveEnabled(bool Value)
{
    MISave->Enabled=Value;
    SpeedButton_Save->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//[h̏
__fastcall TForm1::LoadEnabled(bool Value)
{
    MILoad->Enabled=Value;
    SpeedButton_Load->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//󋵂̏
__fastcall TForm1::StatusEnabled(bool Value)
{
    Status->Enabled=Value;
    SpeedButton_Status->Enabled=Value;
    Popup_Status->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//\̏
__fastcall TForm1::UnitListEnabled(bool Value)
{
    UnitList->Enabled=Value;
    SpeedButton_UnitList->Enabled=Value;
    Popup_UnitList->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//쌟̏
__fastcall TForm1::MoreEnabled(bool Value)
{
    More->Enabled=Value;
    SpeedButton_More->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//tFCYGh̏
__fastcall TForm1::PhaseEndEnabled(bool Value)
{
    PhaseEnd->Enabled=Value;
    SpeedButton_PhaseEnd->Enabled=Value;
    Popup_PhaseEnd->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//IvV̏
__fastcall TForm1::OptionEnabled(bool Value)
{
    OptionA->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//Q[̏ԁBQ[̐isAZ[uȂǁB
__fastcall TForm1::GameOperationEnabled(bool Value)
{
    Image1->Enabled = Value;
    PhaseEndEnabled(Value);
    MoreEnabled(Value);
    UnitListEnabled(Value);
    StatusEnabled(Value);
    SaveEnabled(Value);
    GBWState = STATE_DEFAULT;
    ErrorHappened = false;
    return 0;
}
//---------------------------------------------------------------------------
//̑i\ύXj
__fastcall TForm1::MoneyOperation(int Side,int AddMoney)
{
    char str[50];

    SideStatus1[Side]->Money+=AddMoney;
    sprintf(str,"@%6d  ",SideStatus1[Side]->Money);
    Label_Money->Caption=str;
    return 0;
}
//---------------------------------------------------------------------------
//QƃJ[\̕\
__fastcall TForm1::LookUpCursorPut(int zx,int zy,int Side,int Index)
{
    int i;

    for(i=0;i<3;i++){
        if(i)
            LookUpWait(WAIT_SHOWLOOKUP);
        FieldScreen1->CursorPutZ(zx,zy,CURSOR_LOOKUP);
        ScreenReviseBlock(zx,zy);
        LookUpWait(WAIT_SHOWLOOKUP);
        FieldScreen1->UnitPutAuto(Map,SideStatus1[Side],zx,zy,true);
        ScreenReviseBlock(zx,zy);
        if(Index != NowLookup)
            break; //rŕʂ̌sꂽ_Œ~
    }

    return 0;
}
//---------------------------------------------------------------------------
//jbg̈ʒuQ
__fastcall TForm1::ShowLookup(int Index)
{
    int zx,zy;

    NowLookup = Index; //\Ă΂鎖̂ŒlʂĂ
    UnitXY(Situation->Phase,Index,&zx,&zy);
    SysAutoScroll(zx,zy);
    LookUpCursorPut(zx,zy,Situation->Phase,Index);
    return 0;
}
//---------------------------------------------------------------------------
//w胆jbg̍WT
__fastcall TForm1::UnitXY(int side,int unitNum,int *zx,int *zy)
{
    UnitStatus *unitp;
    int i,j;

    unitp = &SideStatus1[side]->Unit[unitNum];
    if(unitp->X != -1){
        *zx = unitp->X;
        *zy = unitp->Y;
        return 0;
    }
    //ړĨjbgڒȂ瓋ڃjbgT
    for(i=0;i<SideStatus1[side]->UnitCount;i++){
        unitp = &SideStatus1[side]->Unit[i];
        for(j=0;j<unitp->Load;j++){
            if(unitp->LoadingUnit[j]==unitNum){
                break;
            }
        }
    }
    *zx = unitp->X;
    *zy = unitp->Y;
    //ɓڒȂċAĂяo
    if(*zx==-1)
        UnitXY(side,i,zx,zy);
    return 0;
}
//---------------------------------------------------------------------------
//\̓eXV
__fastcall TForm1::UnitListRevise(int UnitNum)
{
//    Form_UnitListp->OnListBox1DrawItem(Form_UnitListp->ListBox1,UnitNum,Form_UnitListp->ListBox1->ClientRect,(TOwnerDrawState)odSelected);
    Form_UnitListp->ListUnitRevise(UnitNum);

    return 0;
}
//---------------------------------------------------------------------------
//胆jbg̎˒\
__fastcall TForm1::ShowUnitRange(int Side,int Num)
{
    UnitStatus *Unitp;

    Unitp=&SideStatus1[Side]->Unit[Num];
    if(!Unitp->GunRest[0] && !Unitp->GunRest[1])
        return 0; //eΖ

    FieldScreen1->FindAttackRange(Map,BaseData1,Unitp);
    FieldScreen1->RangePut(Map,CURSOR_ATTACK,NULL,-1,false,false);
    FieldScreen1->CursorPutZ(Unitp->X,Unitp->Y,CURSOR_LOOKUP);
    ScreenRevise(FieldScreen1->BackupRect[0]);
    Option.ShowRange=true;

    return 0;
}
//---------------------------------------------------------------------------
//胆jbg̎˒\
__fastcall TForm1::ClearUnitRange(void)
{
    if(!Option.ShowRange)
        return -1;
    FieldScreen1->RestoreBitmap(0);
    ScreenRevise(FieldScreen1->BackupRect[0]);
    Option.ShowRange=false;

    return 0;
}
//---------------------------------------------------------------------------
//
__fastcall TForm1::ShowUnitMax(void)
{
    char str[100];

    sprintf(str,"%dłB",Situation->UnitMax);
    ShowMessage(str);
    return 0;
}
//---------------------------------------------------------------------------
//
__fastcall TForm1::SetEconomyMode(bool b)
{
    if(b){
        FieldScreen1->FastDrawMode(Image1->Canvas);
        EconomyMode = true;
    }
    else{
        FieldScreen1->FastDrawMode(NULL);
        EconomyMode = false;
    }
    return 0;
}
//---------------------------------------------------------------------------
//fobOpBQ[󋵂Ɉُ킪ΌoāA̓e\
//ُ킪ȂΉȂ
__fastcall TForm1::CheckSituation(void)
{
    UnitStatus *Unitp;
    int side,num,i,load,type;

    for(side=0;side<2;side++)
        for(num=0; num<SideStatus1[side]->UnitCount; num++){
            Unitp = &SideStatus1[side]->Unit[num];
            if(Unitp->Life > 100) //Ct`FbN
                ShowMessage("Check:Found too large life");
            //ڃ`FbN
            //ڂłȂjbg𓋍ڂĂ
            for(i=0;i<Unitp->Load;i++){
                load = Unitp->LoadingUnit[i];
                type = SideStatus1[side]->Unit[load].Type;
                if(!BaseData1->UnitInfo[Unitp->Type].LoadUnit[type])
                    ShowMessage("Check:Found incorrect load");
            }
        }

    return 0;
}
//---------------------------------------------------------------------------
/*
__fastcall TForm1::EncryptPOP3Password(char *pass,char *crypt)
{
    return 0;
}*/
//---------------------------------------------------------------------------
__fastcall TForm1::PrintError(char *msg)
{
    char lines[256];
    sprintf(lines,"Error:\n%s\nState=%d\n",msg,GBWState);
    PrintLog("_errors.txt",msg);
    ErrorHappened = true;
    return 0;
}
//---------------------------------------------------------------------------

__fastcall TSystemStatus::Initialize(void)
{
    PhaseEndable=true;
    Controlable=true;
    GameEnd=false;
    StopDemand = false;
    CPUMinding = false;
    RadiusCursor = 0;
    strcpy(SaveFile,NEWFILENAME);
    HoldUnit = -1;
    MovingUnit = -1;
    UseGun = -1;
    SelectedLoading = -1;
    return 0;
}
//---------------------------------------------------------------------------

