//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Option.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_Option *Form_Option;
//---------------------------------------------------------------------------
__fastcall TForm_Option::TForm_Option(TComponent* Owner)
    : TForm(Owner)
{
    Result=false;
    MailHidden=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Option::ButtonOKClick(TObject *Sender)
{
    Result=true;
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Option::ButtonCancelClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Option::Button_MailClick(TObject *Sender)
{
    if(MailHidden)
        ShowMail();
    else
        HideMail();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Option::Button_CopySMTPClick(TObject *Sender)
{
    Edit_SMTPServer->Text = Edit_POPServer->Text;
    Edit_SMTPUser->Text   = Edit_POPUser->Text;
}
//---------------------------------------------------------------------------
__fastcall TForm_Option::ShowMail(void)
{
    MailHidden = false;
    Width = 576;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_Option::HideMail(void)
{
    MailHidden = true;
    Width = 316;
    return 0;
}
//---------------------------------------------------------------------------

