//---------------------------------------------------------------------------
#ifndef tableH
#define tableH

//#define CATEGORY_SIZE 2048
//#define CATEGORY_NEST 128
#define ST_LINEMAX      32768 //TStringTables
#define DT_BUFFER     1048576 //i[ł镶iǂ߂t@CTCYj
#define TABLE_MAX     32768   //i[ł鍀ڂ̐
#define CATEGORY_MAX  4000    //JeS
#define CATEGORY_LEN  32      //JeS̕

#include <windows.h>
#include <vcl.h>
#include <stdlib.h>
//---------------------------------------------------------------------------
//񃊃XgǗAeLXgt@Cւ̓o͂sB
//TStringList͍@\ǂݏo삪xׁAȈՂȑ֕iB
class TStringTable
{
private:
    char *Buffer;           //̓ei[
    int BufferSize;         //mۂꂽobt@TCY
    int LineSize;           //mۂꂽs|C^̐

    __fastcall GetIndex(void);
public:
    char *Lines[ST_LINEMAX];  //Buffer̍s|C^
    int BufferMax;          //ۂɊi[Ăobt@ȇ傫
    int LineMax;            //ۂɊi[Ăs

    TStringTable(int size){
        Buffer = new char[size];
        BufferSize = size;
        LineSize = ST_LINEMAX;
        BufferMax = 0;
        LineMax = 0;
        Buffer[BufferSize-1] = '\0';
    }
    ~TStringTable(void){
        delete Buffer;
    }
    __fastcall LoadFromFile(char *file);
    __fastcall SaveToFile(char *file);
    __fastcall Append(char *);
};
//---------------------------------------------------------------------------
//L[lɑΉliji[e[uB
//xɃf[^oAxɃf[^ǂݍނ߂̕Ȃ̂
//IɃf[^XV悤ȗprɂ͎gȂB
//ڂJeS폜悤ȋ@\ȂB
//eXVꂽAǂݍށiGet()jGetCatIndex()Kv
class TDataTable
{
private:
	TStringTable *StrList;      //key=valuě`ŕi[
    int CurrentCategory;        //݂̃JeS[̔ԍ
    int CurrentIndex;           //L[n߂CfbNX
    char CtNames[CATEGORY_MAX][CATEGORY_LEN]; //JeS̖O
    int CtLocate[CATEGORY_MAX]; //JeS̃CfbNX
    int CtMax;                  //JeS̐
    __fastcall GetCatIndex(void);
    __fastcall FindKey(const char *key);
    __fastcall SearchCategory(const char *,int);
public:
    TDataTable(void){
        StrList = new TStringTable(DT_BUFFER);
        CurrentIndex = 0;
    }
    ~TDataTable(void){
        delete StrList;
    }
    __fastcall LoadFromFile(char *file);
    __fastcall SaveToFile(char *file);
    __fastcall SetCategory(const char *category);
    __fastcall GetCategory(const char *category);
    __fastcall GetSubCategory(const char *category);
//    __fastcall EndCategory(void);
    __fastcall Put(const char *key,const char *value);
    __fastcall Put(const char *key,const int value);
    __fastcall Get(const char *key,char *value);
    __fastcall Get(const char *key,int *value);
    __fastcall Get(const char *key,bool *value);
    __fastcall PutValues(const char *key,int value[],int count);
    __fastcall GetValues(const char *key,int value[],int count);
    __fastcall PutStrings(const char *key,char *value[],int count);
    __fastcall GetStrings(const char *key,char *value[],int count,int len);
    __fastcall PutTwoValues(const char *key,int v1,int v2);
    __fastcall GetTwoValues(const char *key,int *v1,int *v2);
    __fastcall PutRect(const char *key,TRect rect);
    __fastcall GetRect(const char *key,TRect *rect);
    __fastcall GetEntryCategory(char **,int);
    __fastcall GetNext(char *key,char *value);
    __fastcall GetNext(char *key,int *value);
};
//---------------------------------------------------------------------------
class TLabelTable 
{
private:
    char *Buffer;
    char **Labels;
    int Count;
    int Max;
public:
    TLabelTable(int nodesize,int nodecount);
    ~TLabelTable();
    void Clear(void);
    int Add(char *);
    int Get(char *);
};
//---------------------------------------------------------------------------
#endif

