//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <stdlib.h>
#include <sys\stat.h>
#pragma hdrstop

#define max(x,y) (x>y ? x : y)
#define min(x,y) (x<y ? x : y)

#include "gbwfield.h"
//---------------------------------------------------------------------------
__fastcall MapStatus::Initialize(int type)
{
    Graph = (char)type;
    SetLifeMax();
    Life = LifeMax;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall MapStatus::SetLifeMax(void)
{
    LifeMax = 200 + 200*(IsBuilding() && (Graph%BUILDINGMAX)==GND_CAPITAL);
    return 0;
}
//---------------------------------------------------------------------------
//{݂ǂ 0:{݂ł͂Ȃ 1:{݂
__fastcall MapStatus::IsBuilding(void)
{
    if(Graph/BUILDINGMAX <= 2)
        return 1;
    return 0;
}
//---------------------------------------------------------------------------
//`ǂ 0:`ł͂Ȃ 1:`
__fastcall MapStatus::IsPort(void)
{
    int i=Graph%BUILDINGMAX;

    if(Graph/BUILDINGMAX<=2 && (i==GND_SHIPPORT || i==GND_SHIPYARD))
        return 1;
    return 0;
}
//---------------------------------------------------------------------------
//wcBȂ-1
__fastcall MapStatus::BSide(void)
{
    if(Graph >= BUILDINGMAX*2)
        return -1;
    return Graph/BUILDINGMAX;
}
//---------------------------------------------------------------------------
//{ݎށB{݂Ȃ-1
__fastcall MapStatus::Building(void)
{
    if(Graph >= BUILDINGMAX*3)
        return -1;
    return Graph%BUILDINGMAX;
}
//---------------------------------------------------------------------------
//Save1.04ȑÕt@Cǂ
__fastcall MapStatus::ReadVer104(int handle)
{
    int i;

    read(handle,&Create,sizeof (bool));
    read(handle,&Graph,sizeof (char));
    read(handle,&Side,sizeof (char));
    read(handle,&Unit,sizeof (char));
    read(handle,&Life,sizeof (int));
    read(handle,&i,sizeof (int)); //RestPower̕
    return 0;
}
//---------------------------------------------------------------------------
/*
//Q[Z[up̏
__fastcall MapStatus::Write(int handle)
{
    write(handle,&Create,sizeof (bool));
    write(handle,&Graph,sizeof (char));
    write(handle,&Side,sizeof (char));
    write(handle,&Unit,sizeof (char));
    write(handle,&Life,sizeof (int));
    return 0;
}*/
//---------------------------------------------------------------------------
//Q[Z[up̓ǂݍ
__fastcall MapStatus::Read(int handle,int Ver)
{
    read(handle,&Create,sizeof (bool));
    read(handle,&Graph,sizeof (char));
    read(handle,&Side,sizeof (char));
    read(handle,&Unit,sizeof (char));
    read(handle,&Life,sizeof (int));

    return 0;
}
//---------------------------------------------------------------------------
//͈͒p̒lɂB
__fastcall MapData::InitRange(void)
{
    memset(RangePoint[0],0,MAPWIDTHMAX*MAPHEIGHTMAX*sizeof(int));
    return 0;
}
//---------------------------------------------------------------------------
//E̒lvalueŏB
//eLTN[hmFɒVisibleꍇ̂ŁA
//eLTN[hŖƂ͗ȊO̒lŖ߂ĂƁB
__fastcall MapData::InitVisible(int value)
{
    int i,*p = Visible[0];

    for(i=0;i<MAPWIDTHMAX*MAPHEIGHTMAX;i++)
        *p++ = value;
    return 0;
}
//---------------------------------------------------------------------------
//}bv̒n`TB߂l͌
__fastcall MapData::SearchChip(int Num,int *zx,int *zy)
{
    int x,y,count=0;

    for(y=0;y<Height;y++)
        for(x=0;x<Width;x++)
            if(Data[x][y].Graph==Num){
                *zx=x;
                *zy=y;
                count++;
            }

    return count;
}
//---------------------------------------------------------------------------
//}bv̌TBCount(BUILDINGMAX*3)pӂKv
__fastcall MapData::SearchBuilding(int Count[])
{
    int x,y,i,*p=Count;

    for(i=0;i<BUILDINGMAX*3;i++)
        *p++=0; //z񏉊
    for(y=0;y<Height;y++)
        for(x=0;x<Width;x++)
            if(Data[x][y].IsBuilding())
                Count[Data[x][y].Graph]++; //ΐ

    return 0;
}
//---------------------------------------------------------------------------
//}bv̓ee[uɏށB}bvt@Cp
__fastcall MapData::WriteTextCompact(TDataTable *table)
{
    char key[100];
    int x,y,array[MAPWIDTHMAX];

    table->Put(KEY_MAPNAME,Name);
    table->Put(KEY_MAPWIDTH,Width);
    table->Put(KEY_MAPHEIGHT,Height);
    table->Put(KEY_UNITFILE,UnitDataFile);
    //n`̔zi[B
    //όAwNX͍X4000Ȃ̂ŗǂƂB
    table->SetCategory(CTG_GROUNDS);
    for(y=0; y<Height; y++){
        sprintf(key,"%s%d",KEY_MAPGROUND,y);
        for(x=0; x<Width; x++)
            array[x] = (int)Data[x][y].Graph;
        table->PutValues(key,array,Width);
        //ꃉCЂƂ܂Ƃ߂ɂĊi[B
    }
    return 0;
}
//---------------------------------------------------------------------------
//e[u}bv̓eǂݏoB}bvt@Cp
__fastcall MapData::ReadTextCompact(TDataTable *table)
{
    char key[100];
    int i,x,y,array[MAPWIDTHMAX];

    table->Get(KEY_MAPNAME,Name);
    table->Get(KEY_MAPWIDTH,&Width);
    table->Get(KEY_MAPHEIGHT,&Height);
    table->Get(KEY_UNITFILE,UnitDataFile);
    //n`̔zi[B
    //όAwNX͍X4000Ȃ̂ŗǂƂB
    table->GetCategory(CTG_GROUNDS);
    for(i=0;i<MAPWIDTHMAX;i++)
        array[i] = 0;          //œK҂āB
    for(y=0; y<Height; y++){
        sprintf(key,"%s%d",KEY_MAPGROUND,y);
        table->GetValues(key,array,Width);
        //ꃉCЂƂ܂Ƃ߂ɂĎoB
        for(x=0; x<Width; x++)
            Data[x][y].Graph = (char)array[x];
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bṽXe[^X
__fastcall MapData::Initialize(void)
{
    int x,y;

    Name[0]='\0';
    UnitDataFile[0]='\0';
    for(y=0;y<MAPHEIGHTMAX;y++)
        for(x=0;x<MAPWIDTHMAX;x++){
            Data[x][y].Create=false;
            Data[x][y].Graph=60;
            Data[x][y].Side=-1;
            Data[x][y].Life=200;
        }
    return 0;
}
//---------------------------------------------------------------------------
//Save1.04ȑÕt@Cǂ
__fastcall MapData::ReadVer104(int handle)
{
    int x,y;

    read(handle,&Width,sizeof (int));
    read(handle,&Height,sizeof (int));
    read(handle,Name,(sizeof (char))*41);
    lseek(handle,3l,SEEK_CUR); //MapStatus̔z̑Oɉ3oCg
    for(x=0;x<MAPWIDTH_OLD;x++)
        for(y=0;y<MAPHEIGHT_OLD;y++)
            Data[x][y].ReadVer104(handle);
    return 0;
}
//---------------------------------------------------------------------------
/*
//Q[Z[up̏
__fastcall MapData::Write(int handle)
{
    int x,y,len,Ver=4;

    write(handle,&Ver,sizeof Ver);  //[Jo[W
    write(handle,&Width,sizeof (int)); //傫B
    write(handle,&Height,sizeof (int));
    len=strlen(Name);
    write(handle,&len,sizeof len);
    write(handle,Name,len);
    len=strlen(UnitDataFile);
    write(handle,&len,sizeof len);
    write(handle,UnitDataFile,len);

    for(y=0;y<Height;y++)
        for(x=0;x<Width;x++)
            Data[x][y].Write(handle);
    return 0;
}*/
//---------------------------------------------------------------------------
//Q[Z[up̓ǂݍ
__fastcall MapData::Read(int handle)
{
    int x,y,len,Ver;

    read(handle,&Ver,sizeof Ver);  //[Jo[W
    read(handle,&Width,sizeof (int)); //傫B
    read(handle,&Height,sizeof (int));
    read(handle,&len,sizeof len);
    read(handle,Name,len);
    Name[len]='\0';
    if(Ver>=4){
        read(handle,&len,sizeof len);
        read(handle,UnitDataFile,len);
        UnitDataFile[len]='\0';
    }

    for(y=0;y<Height;y++)
        for(x=0;x<Width;x++)
            Data[x][y].Read(handle,Ver);
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uɃQ[Z[up݂̏sB
__fastcall MapData::WriteText(TDataTable *table)
{
    char ctg[50];
    int x,y;

    table->Put(KEY_MAPWIDTH, Width);
    table->Put(KEY_MAPHEIGHT, Height);
    table->Put(KEY_MAPNAME, Name);
    table->Put(KEY_UNITFILE, UnitDataFile);

    for(y=0;y<Height;y++)
        for(x=0;x<Width;x++){
            sprintf(ctg,"%s %d,%d",CTG_MAPSTATUS,x,y);
            table->SetCategory(ctg);
            table->Put(KEY_MS_GRAPH, Data[x][y].Graph);
            if(Data[x][y].Graph < BUILDINGMAX*3)
                table->Put(KEY_MS_LIFE, Data[x][y].Life);
        }
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uQ[Z[up̓ǂݍ݂sB
__fastcall MapData::ReadText(TDataTable *table)
{
    char ctg[50];
    int x,y,v;

    table->Get(KEY_MAPWIDTH, &Width);
    table->Get(KEY_MAPHEIGHT, &Height);
    table->Get(KEY_MAPNAME, Name);
    table->Get(KEY_UNITFILE, UnitDataFile);

    for(y=0;y<Height;y++)
        for(x=0;x<Width;x++){
            sprintf(ctg,"%s %d,%d",CTG_MAPSTATUS,x,y);
            table->GetSubCategory(ctg);
            table->Get(KEY_MS_GRAPH, &v); Data[x][y].Graph = (char)v;
            if(Data[x][y].Graph < BUILDINGMAX*3)
                table->Get(KEY_MS_LIFE, &Data[x][y].Life);
            else
                Data[x][y].Life = 200;
            v = -1;
        }
    return 0;
}
//---------------------------------------------------------------------------
//}bvf[^`̊eo[WɂăRo[g
__fastcall MapData::VersionConvert(int Ver)
{
    if(Ver<101)
        Ver100To101Convert();
    if(Ver<103)
        Ver102To103Convert();

    return 0;
}
//---------------------------------------------------------------------------
//MapType 1.00̃f[^1.01ɃRo[g
__fastcall MapData::Ver100To101Convert(void)
{
    int x,y;

    for(y=0;y<MAPHEIGHT_OLD;y++)
        for(x=0;x<MAPWIDTH_OLD;x++) //1.00MAPWIDTHMAX,MAPHEIGHTMAX
            if(20<=Data[x][y].Graph && Data[x][y].Graph<=29)
                Data[x][y].Graph+=(char)10;
    return 0;
}
//---------------------------------------------------------------------------
//MapType 1.02̃f[^1.03ɃRo[g
__fastcall MapData::Ver102To103Convert(void)
{
    int x,y,Grp;

    for(y=0;y<Height;y++)
        for(x=0;x<Width;x++){
            Grp = Data[x][y].Graph;
            if(Grp >= 10)
                Data[x][y].Graph += (char)10;
            if(Grp >= 20)
                Data[x][y].Graph += (char)10;
            if(Grp >= 30)
                Data[x][y].Graph += (char)10;
        }
    return 0;
}
//---------------------------------------------------------------------------
//jbg{f[^̃ftHgl߂
__fastcall UnitChip::SetDefault(void)
{
    int i;

    Defined=false;
    Type=Army;
    MoveMax=2;
    Value=0;
    MinRange[0]=MinRange[1]=2;
    MaxRange[0]=MaxRange[1]=2;
    Radius[0]=Radius[1]=1;
    Loadable=0;
    FuelMax=1;
    for(i=0;i<GROUNDMAX;i++){
        MoveLost[i]=1;
        CanLoadOn[i]=1;
    }
    memset(Attack,0,sizeof Attack);
    strcpy(Name,"o^");
    for(i=0;i<2;i++){
        GunMax[i]=0;
        GunName[i][0]='\0';
    }
    CanOccupy=false;
    OnlyTekisaku=false;
    NearRange2nd=false;
    SuperMissile=false;
    OnlyFuel=false;
    SupplySurround=false;
    SupplyLoading=false;
    SupplyLife=false;
    memset(Supply,0,sizeof Supply);
    memset(SupplyUnit,0,sizeof SupplyUnit);
    memset(LoadUnit,0,sizeof LoadUnit);
    return 0;
}
//---------------------------------------------------------------------------
//KwNXUΊĂ邩B
__fastcall UnitChip::HasMegaHex(void)
{
    if(SuperMissile)
        return 1;
    for(int i=0;i<2;i++)
        if(Radius[i] > 1)
            return 1;
    return 0;
}
//---------------------------------------------------------------------------
//jbg{f[^
__fastcall UnitChip::Write(int handle)
{
    int dummy = 0;

    write(handle,&Type,sizeof Type);
    write(handle,&MoveMax,sizeof MoveMax);
    write(handle,&Value,sizeof Value);
    write(handle,&dummy,sizeof dummy); //MinRange
    write(handle,&dummy,sizeof dummy); //MaxRange
    write(handle,&Loadable,sizeof Loadable);
    write(handle,&FuelMax,sizeof FuelMax);
    write(handle,&GunMax,sizeof GunMax);
    write(handle,MoveLost,sizeof MoveLost);
    write(handle,Attack[0],sizeof Attack);
    write(handle,Name,sizeof Name);
    write(handle,GunName[0],sizeof GunName);
    write(handle,&CanOccupy,sizeof CanOccupy);
    write(handle,LoadUnit,sizeof LoadUnit);
    write(handle,Supply,sizeof Supply);
    write(handle,Creatable,sizeof Creatable);

    write(handle,&NearRange2nd,sizeof NearRange2nd);
    write(handle,&OnlyFuel,sizeof OnlyFuel);
    write(handle,&SupplySurround,sizeof SupplySurround);
    write(handle,&SupplyLoading,sizeof SupplyLoading);
    write(handle,SupplyUnit,sizeof SupplyUnit);

    write(handle,MinRange,sizeof MinRange);
    write(handle,MaxRange,sizeof MaxRange);

    write(handle,&Visibility,sizeof Visibility);
    write(handle,&VisionType,sizeof VisionType);

    write(handle,Radius,sizeof Radius);
    write(handle,&OnlyTekisaku,sizeof OnlyTekisaku);
    write(handle,&SuperMissile,sizeof SuperMissile);
    write(handle,&SupplyLife,sizeof SupplyLife);
    write(handle,CanLoadOn,sizeof CanLoadOn);
    return 0;
}
//---------------------------------------------------------------------------
//jbg{f[^ǂݍ
__fastcall UnitChip::Read(int handle,int Ver)
{
    int minr,maxr,i;

    read(handle,&Type,sizeof Type);
    read(handle,&MoveMax,sizeof MoveMax);
    read(handle,&Value,sizeof Value);
    read(handle,&minr,sizeof(int));
    read(handle,&maxr,sizeof(int));
    read(handle,&Loadable,sizeof Loadable);
    read(handle,&FuelMax,sizeof FuelMax);
    read(handle,&GunMax,sizeof GunMax);
    if(Ver>=104)
        read(handle,MoveLost,sizeof MoveLost);
    else{
        for(i=0;i<80;i++) //n`ޑ
            if((i/10)%2 == 0)
                read(handle,&MoveLost[i],sizeof(int));
    }
    if(Ver>=103)
        read(handle,Attack[0],sizeof Attack);
    else{ //jbg̎ނ̍ő吔100
        read(handle,Attack[0],sizeof(int)*100);
        read(handle,Attack[1],sizeof(int)*100);
    }
    read(handle,Name,sizeof Name);
    read(handle,GunName[0],sizeof GunName);
    read(handle,&CanOccupy,sizeof CanOccupy);
    if(Ver>=103)
        read(handle,LoadUnit,sizeof LoadUnit);
    else //jbg̎ނ̍ő吔100
        read(handle,LoadUnit,sizeof(bool)*100);
    if(Ver>=104){
        read(handle,Supply,sizeof Supply);
        read(handle,Creatable,sizeof Creatable);
    }
    else{
        read(handle,Supply,sizeof(bool)*10);
        read(handle,Creatable,sizeof(bool)*10);
    }
    if(Ver>=101){ //⋋֌Wǉ
        read(handle,&NearRange2nd,sizeof NearRange2nd);
        read(handle,&OnlyFuel,sizeof OnlyFuel);
        read(handle,&SupplySurround,sizeof SupplySurround);
        read(handle,&SupplyLoading,sizeof SupplyLoading);
        if(Ver>=103)
            read(handle,SupplyUnit,sizeof SupplyUnit);
        else //jbg̎ނ̍ő吔100
            read(handle,SupplyUnit,sizeof(bool)*100);
    }
    if(Ver>=102){ //˒֌Wǉ
        read(handle,MinRange,sizeof MinRange);
        read(handle,MaxRange,sizeof MaxRange);
    }
    else{
        MinRange[0]=MinRange[1]=minr;
        MaxRange[0]=MaxRange[1]=maxr;
    }
    if(Ver>=105){ //G֌Wǉ
        read(handle,&Visibility,sizeof Visibility);
        read(handle,&VisionType,sizeof VisionType);
    }
    if(Ver>=106){ //ڒn`ǉ
        read(handle,Radius,sizeof Radius);
        read(handle,&OnlyTekisaku,sizeof OnlyTekisaku);
        read(handle,&SuperMissile,sizeof SuperMissile);
        read(handle,&SupplyLife,sizeof SupplyLife);
        read(handle,CanLoadOn,sizeof CanLoadOn);
    }
    return 0;
}
//---------------------------------------------------------------------------
//̃o[WŎgĂf[^t@Cǂ
__fastcall BaseData::OldDataLoad(char *file)
{
    int handle,unitcount[3],h,i,j,k,n,
        incomedata[10]={4000,1000,2000,3000,2000,3000,2000,3000,0,0};
    short s,t;
    char str[100];
    bool Create[3][10]={{true,true,true,true,false,false,false,false,false,false},
                        {false,false,false,false,true,true,false,false,false,false},
                        {false,false,false,false,false,false,true,true,false,false}};
    bool supplydata[3][10]={{true,true,true,true,false,false,false,false,true,true},
                           {false,false,false,false,true,true,false,false,false,false},
                           {false,false,false,false,false,false,true,true,false,false}};

    handle=open(file,O_BINARY|O_RDONLY);
    if(handle==-1)
        return -1;
    for(i=0;i<UNITSTANDARD;i++)
        strcpy(UnitInfo[i].Name,"\");
    for(i=0;i<3;i++){
        read(handle,(char *)&s,sizeof s);
        unitcount[i]=s;
    }
    for(i=0;i<3;i++){
        for(h=0;h<unitcount[i];h++){
            n=i*8+(i>0)*8+h;
            UnitInfo[n].CanOccupy = n<=1;
            UnitInfo[n].Defined = true;
            switch(i){
            case 0:
                UnitInfo[n].Type=UnitInfo[n].Army;
                break;
            case 1:
                UnitInfo[n].Type=UnitInfo[n].Force;
                break;
            case 2:
                UnitInfo[n].Type=UnitInfo[n].Navy;
                break;
            }
            read(handle,UnitInfo[n].Name,sizeof UnitInfo[n].Name);
            read(handle,(char *)&t,sizeof t);
            UnitInfo[n].Value=t;
            read(handle,(char *)&t,sizeof t);
            UnitInfo[n].MoveMax=t;
            read(handle,(char *)&t,sizeof t);
            UnitInfo[n].FuelMax=t;
            for(j=0;j<32;j++)  //֌W̏ړl߂BC㕔͍`ƑDȊOȂ
                if(i!=2 || j%10==6 || j%10==7)
                    UnitInfo[n].MoveLost[j]=1;
                else
                    UnitInfo[n].MoveLost[j]=0;
            for(j=0;j<8;j++){  //̑GȒn`ɂāB͑SĂŐ錾̂]܂
                read(handle,(char *)&t,sizeof t);
                UnitInfo[n].MoveLost[32+j]=t;
                if(t<1 || t>9){
                    sprintf(str,"f[^ُ c:%d n:%d g:%d",i,h,j);
                    ShowMessage(str);
                }
                if(t==9)
                    UnitInfo[n].MoveLost[32+j]=0;
            }
            read(handle,(char *)&t,sizeof t);
            UnitInfo[n].MinRange[0]=t;
            UnitInfo[n].MinRange[1]=t;
            read(handle,(char *)&t,sizeof t);
            UnitInfo[n].MaxRange[0]=t;
            UnitInfo[n].MaxRange[1]=t;
            for(j=0;j<2;j++){           //Ί햼ƒe
                read(handle,UnitInfo[n].GunName[j],17);
                read(handle,(char *)&t,sizeof t);
                UnitInfo[n].GunMax[j]=t;
            }
            read(handle,(char *)&t,sizeof t);
            UnitInfo[n].Loadable=t;    //ډ\
            for(j=0;j<40;j++){ //ډ\jbg
                read(handle,(char *)&t,sizeof t);
                if(t)
                    UnitInfo[n].LoadUnit[j]=true;
                else
                    UnitInfo[n].LoadUnit[j]=false;
            }
            for(k=0;k<2;k++)
                if(UnitInfo[n].GunMax[k]){
                    for(j=0;j<unitcount[0];j++){  //Βn
                        read(handle,(char *)&t,sizeof t);
                        UnitInfo[n].Attack[k][j]=t;
                    }
                    for(j=16;j<16+unitcount[1];j++){ //΋
                        read(handle,(char *)&t,sizeof t);
                        UnitInfo[n].Attack[k][j]=t;
                    }
                    for(j=24;j<24+unitcount[2];j++){ //Ί
                        read(handle,(char *)&t,sizeof t);
                        UnitInfo[n].Attack[k][j]=t;
                    }
                }
            for(j=0;j<10;j++){ //⋋EY\n`f[^
                UnitInfo[n].Supply[j]=supplydata[i][j];
                UnitInfo[n].Creatable[j]=Create[i][j];
            }
        }
    }
    UnitInfo[12].Creatable[0]=false;
    UnitInfo[12].Creatable[1]=false;
    UnitInfo[12].Creatable[2]=false; //Ԃy
    strcpy(UnitInfo[21].Name,"\"); //X[p[~TC
    strcpy(UnitInfo[22].Name,"\"); //qA@
    UnitInfo[22].MoveMax=UnitInfo[21].MoveMax=0;

    for(j=0;j<GROUNDMAX;j++) //˒ׂ̈̃_~[f[^
        UnitInfo[UT_MIGHTYSEARCH].MoveLost[j]=1;
    for(i=0;i<20;i++){  //n`f[^
        n=(i>=10)*30+i%10;
        read(handle,MapInfo[n].Name,sizeof MapInfo[n].Name);
        if(n<10){
            strcpy(MapInfo[n+10].Name,MapInfo[n].Name);
            strcpy(MapInfo[n+20].Name,MapInfo[n].Name);
        }
        read(handle,(char *)&t,sizeof t);
        MapInfo[n].Shield=t;
        if(n<10){
            MapInfo[n+10].Shield=t;
            MapInfo[n+20].Shield=t;
        }
    }
    for(i=0;i<10;i++)
        MapInfo[i+10].Income=MapInfo[i].Income=incomedata[i];
    close(handle);
    return 0;
}
//---------------------------------------------------------------------------
//[hȂꍇ̃ftHgl߂
__fastcall BaseData::SetDefault(void)
{
    int i;

    for(i=0;i<UNITTYPEMAX;i++)
        UnitInfo[i].SetDefault();
    UserBitmapFile[0]='\0';
    strcpy(SideName[0],UNION1NAME);
    strcpy(SideName[1],UNION2NAME);
    UnitGrpGet=0;
    Sides=2;
    NoStandard=false;

    return 0;
}
//---------------------------------------------------------------------------
//jbgf[^S
__fastcall BaseData::ClearUnit(void)
{
    int i;

    for(i=0;i<UNITTYPEMAX;i++)
        UnitInfo[i].SetDefault();
    return 0;
}
//---------------------------------------------------------------------------
//jbgY\ǂ̔ijbgf[^j
__fastcall BaseData::CanCreateUnit(int Building,int Type,bool sakuteki)
{
    UnitChip *UnitInfop = &UnitInfo[Type];

    if(!sakuteki && UnitInfop->OnlyTekisaku)
        return 0;
    if(NoStandard && Type<UNITSTANDARD)
        return 0;
    if(!(UnitInfop->Defined && UnitInfop->Creatable[Building]))
        return 0;
    return 1;
}
//---------------------------------------------------------------------------
//̒n`ŐY\ȃjbg邩
__fastcall BaseData::CreatableExists(int Side,int GroundNum,bool sakuteki)
{
    int i,bn,s=0;

    if(GroundNum/BUILDINGMAX != Side)
        return 0;
    if(NoStandard) //WjbgĂ`FbNȂ
        s=UNITSTANDARD;
    bn=GroundNum%BUILDINGMAX;
    //jbgЂƂłY\Ȃ߂l͐^ƂȂ
    for(i=s;i<UNITTYPEMAX;i++)
        if(CanCreateUnit(bn,i,sakuteki))
            return 1;
    return 0;
}
//---------------------------------------------------------------------------
#define CTG_GND_NAME   "Name"
#define CTG_GND_SHIELD "Shield"
#define CTG_GND_INCOME "Income"
//n`̏
__fastcall BaseData::WriteGround(int handle)
{
    int i;

    for(i=0;i<GROUNDMAX;i++){
        write(handle,&MapInfo[i].Shield,sizeof (int));
        write(handle,&MapInfo[i].Income,sizeof (int));
        write(handle,&MapInfo[i].Name,sizeof MapInfo[i].Name);
    }
    return 0;
}
//---------------------------------------------------------------------------
//n`̓ǂݍ
__fastcall BaseData::ReadGround(int handle)
{
    int i,j;
    int incomedata[BUILDINGMAX]={4000,1000,2000,3000,2000,3000,2000,3000,0,0,
                                 2000,100,1000,0,0,0,0,0,0,0};
/*
    for(i=0;i<80;i++)
        if((i/10)%2 == 0){
            read(handle,&MapInfo[i].Shield,sizeof (int));
            read(handle,&MapInfo[i].Income,sizeof (int));
            read(handle,&MapInfo[i].Name,sizeof MapInfo[i].Name);
        }
*/
    for(i=0;i<GROUNDMAX;i++){
        read(handle,&MapInfo[i].Shield,sizeof (int));
        read(handle,&MapInfo[i].Income,sizeof (int));
        read(handle,&MapInfo[i].Name,sizeof MapInfo[i].Name);
    }
    //bIɎ߂
    for(i=0;i<3;i++)
        for(j=0;j<BUILDINGMAX;j++)
            MapInfo[i*BUILDINGMAX+j].Income = incomedata[j];
    return 0;
}
//---------------------------------------------------------------------------
//Wf[^̏݁in`Ejbgj
__fastcall BaseData::WriteStandard(void)
{
    VersionControl Version1;
    int Ver; //[U[jbgt@CƓ
    int i,handle;

    handle=open(STANDARDFILE,O_RDWR|O_BINARY|O_CREAT|O_TRUNC,S_IWRITE);
    if(handle==-1)
        return -1;
    Ver = Version1.StrToValue(UNITVERSION);
    write(handle,&Ver,sizeof Ver); //o[W
    WriteGround(handle);
    for(i=0;i<UNITSTANDARD;i++) //ʓ|Ȃ̂œo^`FbN͖
        UnitInfo[i].Write(handle);
    close(handle);

    return 0;
}
//---------------------------------------------------------------------------
//Wf[^̓ǂݍ݁in`Ejbgj
__fastcall BaseData::ReadStandard(void)
{
    int i,handle,Ver;

    handle=open(StandardPath,O_RDONLY|O_BINARY);
    if(handle==-1)
        return -1;
    read(handle,&Ver,sizeof Ver);
    ReadGround(handle);
    for(i=0;i<UNITSTANDARD;i++){ //蓮ōXV
        UnitInfo[i].Read(handle,Ver);
        if(strcmp(UnitInfo[i].Name,"\"))
            UnitInfo[i].Defined=true;
    }
    close(handle);

    return 0;
}
//---------------------------------------------------------------------------
//[U[jbgf[^̏
__fastcall BaseData::WriteUser(char *file)
{
    int i,count=0,handle,len;

    handle=open(file,O_RDWR|O_BINARY|O_CREAT|O_TRUNC,S_IWRITE);
    if(handle==-1)
        return -1;
    write(handle,UNITVERHEAD,(sizeof UNITVERHEAD)-1);
    write(handle,UNITVERSION,sizeof UNITVERSION);
    len=strlen(UserBitmapFile);
    write(handle,&len,sizeof len);
    write(handle,UserBitmapFile,len);
    write(handle,&Sides,sizeof Sides);
    for(i=0;i<Sides;i++){
        len=strlen(SideName[i]);
        write(handle,&len,sizeof len);
        write(handle,SideName[i],sizeof SideName[i]);
    }
    write(handle,&UnitGrpGet,sizeof UnitGrpGet);
    write(handle,&NoStandard,sizeof NoStandard);
    for(i=0;i<UNITTYPEMAX;i++) //o^ς݂̕
        if(UnitInfo[i].Defined)
            count++;
    write(handle,&count,sizeof count); //ސ
    for(i=0;i<UNITTYPEMAX;i++)
        if(UnitInfo[i].Defined){
            write(handle,&i,sizeof i);
            UnitInfo[i].Write(handle);
        }
    close(handle);

    return 0;
}
//---------------------------------------------------------------------------
//[U[jbgf[^̓ǂݍ
//0-39͏㏑BWf[^g͍ēǍKv
__fastcall BaseData::ReadUser(char *file)
{
    VersionControl Version1;
    char str[100];
    int i,n,count=0,v1,v2,handle,len;

    if(!strcmp(file,"")){ //t@C󔒂ȂWf[^ǂ
        SetDefault();
        ClearUnit();
        ReadStandard();
        return 0;
    }
    handle=open(file,O_RDONLY|O_BINARY);
    if(handle==-1){
        sprintf(str,"w肳ꂽjbgf[^t@C %s܂B",file);
        ShowMessage(str);
        return -1;
    }
    read(handle,str,(sizeof UNITVERHEAD)-1);
    str[(sizeof UNITVERHEAD)-1]='\0';
    if(strcmp(str,UNITVERHEAD)){
        ShowMessage("ǒn헪̃jbgf[^`ł͂܂B");
        close(handle);
        return -1;
    }
    read(handle,str,sizeof UNITVERSION);
    v1=Version1.StrToValue(str);
    v2=Version1.StrToValue(UNITVERSION);
    if(v1>v2){
        ShowMessage("jbgf[^̃o[WႢ܂B");
        close(handle);
        return -1;
    }
    ClearUnit();
    if(v1<v2){
        ReadStandard();
    }

    read(handle,&len,sizeof len);
    read(handle,UserBitmapFile,len);
    UserBitmapFile[len]='\0';
    read(handle,&Sides,sizeof Sides);
    for(i=0;i<Sides;i++){
        read(handle,&len,sizeof len);
        read(handle,SideName[i],sizeof SideName[i]);
    }
    read(handle,&UnitGrpGet,sizeof UnitGrpGet);
    read(handle,&NoStandard,sizeof NoStandard);
    read(handle,&count,sizeof count);
    for(i=0;i<count;i++){
        read(handle,&n,sizeof n);
        UnitInfo[n].Read(handle,v1);
        UnitInfo[n].Defined=true;
    }
    // o[W̏ꍇA⋋֌W̃p[^B
    if(v1==100){
        UnitInfo[UT_SUPPLYCAR].SupplySurround=true; //⋋A
        for(i=0;i<=12;i++)                       //Wnテjbg
            UnitInfo[UT_SUPPLYCAR].SupplyUnit[i]=true;
        UnitInfo[UT_PLANESHIP].SupplyLoading=true; //
        for(i=16;i<=20;i++)                     //Wq󃆃jbg
            UnitInfo[UT_PLANESHIP].SupplyUnit[i]=true;
    }
    // o[W̏ꍇA[_[A@̐ݒ𒼂B
    // [_[A@قǌÂɑ΂Ă͉ȂB
    // i̔ԍgĂȂΐVWf[^̂܂܎c͂j
    UnitChip *radar = &UnitInfo[UT_RADAR];
    if(v1<106 && radar->Defined){
        bool canLoadOn[20]=
            {true,true,false,false,false, false,false,false,true,false,
             false,true,true,false,false, false,false,false,false,false};
        memcpy(&radar->CanLoadOn[60], canLoadOn, sizeof(bool)*20);
        for(i=0;i<3;i++)
            radar->CanLoadOn[BUILDINGMAX*i+GND_HOUSING] = false;
        radar->OnlyTekisaku = true;
    }
    close(handle);
    return 0;
}
//---------------------------------------------------------------------------
// eCSVt@Cɏo͂B
__fastcall BaseData::SaveToCSV(char *file)
{
    FILE *fp;
    int num;
    bool defined[UNITSTANDARD];

    // WjbgȂꍇ́ADefinedtOꎞIɃNAB
    if(NoStandard){
        for(int i=0;i<UNITSTANDARD;i++){
            defined[i] = UnitInfo[i].Defined;
            UnitInfo[i].Defined = false;
        }
    }

    NeedGroundCount = GetNeedGroundList(NeedGroundList,GROUNDMAX);
    NeedBuildingCount = GetNeedBuildingList(NeedBuildingList,BUILDINGMAX);

    fp = fopen(file,"w");
    if(!fp)
        return -1;

    // jbg
    fprintf(fp,"jbg,,,i,ړ,E,E^Cv,R,Ri,");
    fprintf(fp,"̔\,ډ\,ډ\,");
    PrintCSV_UnitName(fp);
    fprintf(fp,"אڕ⋋,");
    PrintCSV_UnitName(fp);
    fprintf(fp,"ڕ⋋,");
    PrintCSV_UnitName(fp);
    for(int gun=0;gun<2;gun++){
        fprintf(fp,"Ί%d,", gun+1);
        fprintf(fp,"e,ei,˒,a,");
        PrintCSV_UnitName(fp);
    }
    fprintf(fp,"ړ,");
    PrintCSV_GroundName(fp);
    fprintf(fp,"{,");
    PrintCSV_BuildingName(fp);
    fprintf(fp,"\,");
    PrintCSV_GroundName(fp);
    fprintf(fp,"Gp,,0wcX,0wcY,1wcX,1wcY");
    fprintf(fp,",0wc,1wc\n");

    for(num=0;num<UNITTYPEMAX;num++){
        if(UnitInfo[num].Defined){
            PrintCSVLine_Unit(fp,num);
            fprintf(fp,"\n");
        }
    }

    // n`
    fprintf(fp,"n`,,n`,,ϋvx,s@\,ƗY,n`X,n`Y,X,Y,0wcX,0wcY,1wcX,1wcY\n");
    for(int i=0;i<NeedGroundCount;i++){
        num = NeedGroundList[i];
        PrintCSVLine_Ground(fp,num);
        fprintf(fp,"\n");
    }

    fprintf(fp,"wc,");
    for(int side=0;side<Sides;side++){
        fprintf(fp,"%s", SideName[side]);
        if(side < Sides-1)
            fprintf(fp,",");
    }
    fprintf(fp,"\n");

    if(UserBitmapFile[0] != '\0')
        fprintf(fp,"摜t@C,%s\n", UserBitmapFile);
    else
        fprintf(fp,"摜t@C,default.bmp\n");
    fprintf(fp,"n`摜ʒu,%d,%d\n", 0,0);
    fprintf(fp,"jbg摜ʒu,%d,%d\n", 0,32*8);
    //fprintf(fp,"n`ސ,%d\n", GROUNDMAX - BUILDINGMAX*3);
    //fprintf(fp,"{ݎސ,%d\n", BUILDINGMAX);
    //fprintf(fp,"jbgސ,%d\n", UNITSTANDARD + UnitGrpGet);

    if(NoStandard){
        for(int i=0;i<UNITSTANDARD;i++){
            UnitInfo[i].Defined = defined[i];
        }
    }

    fclose(fp);
    return 0;
}
//---------------------------------------------------------------------------
// jbgsB
__fastcall BaseData::PrintCSVLine_Unit(FILE *fp,int unitnum)
{
    UnitChip *unitInfop = &UnitInfo[unitnum];
    static char *typeName[3] = {"","C","q"};
    int i;

    fprintf(fp,"%d,", unitnum);
    PrintCSV_String(fp,unitInfop->Name);
    fprintf(fp,"%s,", typeName[unitInfop->Type]);
    fprintf(fp,"%d,", unitInfop->Value);
    fprintf(fp,"%d,", unitInfop->MoveMax);
    fprintf(fp,"%d,", unitInfop->Visibility);
    fprintf(fp,"%d,", unitInfop->VisionType);
    fprintf(fp,"%d,2,", unitInfop->FuelMax);

    if(unitInfop->CanOccupy){
        fprintf(fp,"100,");
    }else{
        fprintf(fp,",");
    }

    // ډ\
    fprintf(fp,"%d,", unitInfop->Loadable);
    // ډ\jbg
    PrintCSV_String(fp,unitInfop->Name);
    for(i=0;i<UNITTYPEMAX;i++){
        UnitChip *targetInfo = &UnitInfo[i];
        if(!targetInfo->Defined)
            continue;
        PrintCSV_Bool(fp,unitInfop->LoadUnit[i]);
    }

    // ⋋֌W
    // אڕ⋋
    PrintCSV_String(fp,unitInfop->Name);
    if(unitInfop->SupplySurround){
        for(i=0;i<UNITTYPEMAX;i++){
            UnitChip *targetInfo = &UnitInfo[i];
            if(!targetInfo->Defined)
                continue;
            if(unitInfop->SupplyUnit[i]){
                if(unitInfop->OnlyFuel){
                    fprintf(fp,"R");
                }else{
                    fprintf(fp,"Re");
                }
            }
            fprintf(fp,",");
        }
    }
    else{
        for(i=0;i<UNITTYPEMAX;i++){
            if(UnitInfo[i].Defined)
                fprintf(fp,",");
        }
    }
    // ڕ⋋
    PrintCSV_String(fp,unitInfop->Name);
    if(unitInfop->SupplyLoading){
        for(i=0;i<UNITTYPEMAX;i++){
            UnitChip *targetInfo = &UnitInfo[i];
            if(!targetInfo->Defined)
                continue;
            if(unitInfop->SupplyUnit[i]){
                if(unitInfop->OnlyFuel){
                    fprintf(fp,"R");
                }else{
                    fprintf(fp,"Re");
                }
                if(unitInfop->SupplyLife){
                    fprintf(fp,"");
                }
            }
            fprintf(fp,",");
        }
    }
    else{
        for(i=0;i<UNITTYPEMAX;i++){
            if(UnitInfo[i].Defined)
                fprintf(fp,",");
        }
    }
    // ⋋֌W͈ȏB

    // Ί
    for(int gun=0;gun<2;gun++){
        PrintCSV_String(fp, unitInfop->GunName[gun]);
        //fprintf(fp,"%s,", unitInfop->GunName[gun]);
        fprintf(fp,"%d,5,", unitInfop->GunMax[gun]);
        // ˒
        fprintf(fp,"%d-", unitInfop->MinRange[gun]);
        fprintf(fp,"%d,", unitInfop->MaxRange[gun]);
        // a
        fprintf(fp,"1-%d,", unitInfop->Radius[gun]);
        // U
        for(i=0;i<UNITTYPEMAX;i++){
            if(!UnitInfo[i].Defined)
                continue;
            fprintf(fp,"%d,", unitInfop->Attack[gun][i]);
        }
    }
    // Ί͈ȏB

    // n`Ƃ̊֌W
    // ړ
    PrintCSV_String(fp,unitInfop->Name);
    for(i=0;i<NeedGroundCount;i++){
        int num = NeedGroundList[i];
        fprintf(fp,"%d,", unitInfop->MoveLost[num]);
    }
    // {
    PrintCSV_String(fp,unitInfop->Name);
    for(i=0;i<NeedBuildingCount;i++){
        int num = NeedBuildingList[i];
        if(unitInfop->Creatable[num])
            fprintf(fp,"");
        if(unitInfop->Supply[num])
            fprintf(fp,"");
        fprintf(fp,",");
    }
    // \
    PrintCSV_String(fp,unitInfop->Name);
    for(i=0;i<NeedGroundCount;i++){
        int num = NeedGroundList[i];
        if(unitInfop->CanLoadOn[num])
            fprintf(fp,"~ڗg");
        fprintf(fp,",");
    }

    PrintCSV_Bool(fp,unitInfop->OnlyTekisaku);
    PrintCSV_Bool(fp,unitInfop->SuperMissile);

    int x,y;
    x = unitnum%10;
    y = unitnum/10;
    if(NoStandard)
        y -= UNITSTANDARD/10;
    fprintf(fp,"%d,%d",x,y);
    y += (UNITSTANDARD+UnitGrpGet)/10;
    if(NoStandard)
        y -= UNITSTANDARD/10;
    fprintf(fp,",%d,%d",x,y);
    fprintf(fp,",,");

    //fseek(fp,-1,SEEK_CUR);
    return 0;
}
//---------------------------------------------------------------------------
// n`sB
// {݂͑SwcʂȂ̂ŁAe{ݎނɂĈ񂾂ĂяoƁB
__fastcall BaseData::PrintCSVLine_Ground(FILE *fp,int gndnum)
{
    MapChip *gnd = &MapInfo[gndnum];
    bool isBuilding = (gndnum < BUILDINGMAX*3);
    int x,y;

    fprintf(fp,"%d,", gndnum);
    //fprintf(fp,"%s,", gnd->Name);
    PrintCSV_String(fp,gnd->Name);
    fprintf(fp,"%d,", gnd->Shield);
    if(isBuilding){
        fprintf(fp,"%d", gnd->Income);
        // ϋvx,s@\,ƗY
        int type = gndnum%BUILDINGMAX;
        if(type == 0){
            fprintf(fp,",400,,");
        }else{
            fprintf(fp,",200,,");
            if(type==GND_BIGFACTORY || type==GND_BIGAIRPORT || type==GND_SHIPYARD){
                fprintf(fp,"");
            }
            //fprintf(fp,",");
        }
    }else{
        fprintf(fp,",,,");
    }
    // en`̃OtBbNWLqB
    if(isBuilding){
        fprintf(fp,",,");
        x = gndnum%10;
        y = (gndnum/10)%2 +2; // +2͒ʏn`̕B
        // ewcB
        for(int i=0;i<3;i++)
            fprintf(fp,",%d,%d",x,y+i*2);
    }
    else{
        x = gndnum%10;
        y = (gndnum - BUILDINGMAX*3)/10;
        fprintf(fp,",%d,%d",x,y);
    }
    return 0;
}
//---------------------------------------------------------------------------
// ̒l1ȂCfbNXłȂOo͂B
#define TMP_USENAME 0
// o^Ă郆jbg̖OJ}ŋ؂ďo͂B
__fastcall BaseData::PrintCSV_UnitName(FILE *fp)
{
#if TMP_USENAME
    for(int i=0;i<UNITTYPEMAX;i++){
        if(UnitInfo[i].Defined)
            fprintf(fp,"%s,", UnitInfo[i].Name);
    }
#else
    for(int i=0;i<UNITTYPEMAX;i++){
        if(UnitInfo[i].Defined)
            fprintf(fp,"%02d,", i);
    }
#endif
    return 0;
}
#undef TMP_USENAME
//---------------------------------------------------------------------------
// o^Ăn`̖OJ}ŋ؂ďo͂B
// ߂l͏o͂O̐B
__fastcall BaseData::PrintCSV_GroundName(FILE *fp)
{
#if TMP_USENAME
    for(int i=0;i<NeedGroundCount;i++){
        int num = NeedGroundList[i];
        fprintf(fp,"%s,", MapInfo[num].Name);
    }
#else
    for(int i=0;i<NeedGroundCount;i++){
        int num = NeedGroundList[i];
        fprintf(fp,"%02d,", num);
    }
#endif
    return NeedGroundCount;
}
//---------------------------------------------------------------------------
// {݂̖OiȉjBPrintCSV_GroundName() ƓlB
__fastcall BaseData::PrintCSV_BuildingName(FILE *fp)
{
#if TMP_USENAME
    for(int i=0;i<NeedBuildingCount;i++){
        int num = NeedBuildingList[i];
        fprintf(fp,"%s,", MapInfo[num].Name);
    }
#else
    for(int i=0;i<NeedBuildingCount;i++){
        int num = NeedBuildingList[i];
        fprintf(fp,"%02d,", num);
    }
#endif
    return NeedBuildingCount;
}
//---------------------------------------------------------------------------
// ^UloB
__fastcall BaseData::PrintCSV_Bool(FILE *fp,bool b)
{
    if(b){
        fprintf(fp,",");
    }else{
        fprintf(fp,",");
    }
    return 0;
}
//---------------------------------------------------------------------------
// oB
__fastcall BaseData::PrintCSV_String(FILE *fp,char *str)
{
    bool b=false;
    int i=0;
    while(str[i] != '\0'){
        if(str[i]=='\t' || str[i]==' ' || str[i]==','){
            b=true;
            break;
        }
        i++;
    }
    // ɋ؂L͂
    if(b){
        fprintf(fp,"\"%s\",",str);
    }else{
        fprintf(fp,"%s,",str);
    }
    return 0;
}
//---------------------------------------------------------------------------
// Ver.1.xxłCSV[hT|[g͑ςȂ̂Œ~B
// R[ĥܑ͖Ȃ̂ŎcĂBȉ̕sB
// EIDɂn`/jbg̎
// En`/jbg̃OtBbNW̒`̓ǂݍ
// En`/{/jbg͎ۂɓǂݍ񂾐Ō肷邪A
__fastcall BaseData::LoadFromCSV(char *file)
{
    TCSVTable *table = new TCSVTable();
    int row,endrow;

    if(table->LoadFromFile(file) == -1)
        return -1;

    row = table->GetRowByName("jbg");
    if(row != -1){
        // jbg񂪏Ăsǂ܂łׂB
        endrow = CSV_GetEndOfNumberRow(table,row);
        for(int i=row+1; i<=endrow; i++){
            CSV_GetUnit(table,i,row);
        }
    }

    row = table->GetRowByName("n`");
    if(row != -1){
        // n`񂪏Ăsǂ܂łׂB
        endrow = CSV_GetEndOfNumberRow(table,row);
        for(int i=row+1; i<=endrow; i++){
            CSV_GetGround(table,i,row);
        }
    }

    // wc
    row = table->GetRowByName("wc");
    if(row != -1){
        int col=1;
        for(int i=0;i<2;i++){
            if(table->GetCellByXY(col,row,SideName[i],sizeof SideName[i]) == -1)
                break;
        }
    }

    row = table->GetRowByName("摜t@C");
    if(row != -1){
        table->GetCellByXY(1,row,UserBitmapFile,sizeof UserBitmapFile);
    }
    row = table->GetRowByName("jbgސ");
    if(row != -1){
        table->GetCellByXY(1,row,&UnitGrpGet);
        UnitGrpGet -= UNITSTANDARD;
    }

    delete table;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall BaseData::CSV_GetUnit(TCSVTable *table,const int row,const int keyrow)
{
    const int cellsize=1024;
    char cell[cellsize];
    UnitChip *unitInfop;
    int i,col;

    table->GetCellByXY(0,row,&i);
    if(i<0 || i>=UNITTYPEMAX)
        return -1;
    unitInfop = &UnitInfo[i];

    unitInfop->Defined = true;
    table->GetCellByKeyRow(keyrow,"",row, unitInfop->Name, sizeof unitInfop->Name);

    col = table->GetCellColumnByName(keyrow,"");
    if(table->GetCellByXY(col,row,cell,cellsize) != -1){
        if(!strcmp(cell,"C")){
            unitInfop->Type = UnitChip::Navy;
        }else if(!strcmp(cell,"q")){
            unitInfop->Type = UnitChip::Force;
        }else{
            unitInfop->Type = UnitChip::Army;
        }
    }

    table->GetCellByKeyRow(keyrow,"i",  row, &unitInfop->Value);
    table->GetCellByKeyRow(keyrow,"ړ",row, &unitInfop->MoveMax);
    table->GetCellByKeyRow(keyrow,"E",  row, &unitInfop->Visibility);
    table->GetCellByKeyRow(keyrow,"R",  row, &unitInfop->FuelMax);
    table->GetCellByKeyRow(keyrow,"ډ\",row, &unitInfop->Loadable);

    col = table->GetCellColumnByName(keyrow,"");
    unitInfop->CanOccupy = CSV_GetBool(table,col,row);

    col = table->GetCellColumnByName(keyrow,"Gp");
    unitInfop->OnlyTekisaku = CSV_GetBool(table,col,row);

    col = table->GetCellColumnByName(keyrow,"");
    unitInfop->SuperMissile = CSV_GetBool(table,col,row);

    col = table->GetCellColumnByName(keyrow,"ډ\");
    if(col != -1){
        int num;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,&num) == -1)
                break;
            if(num<0 || num>=UNITTYPEMAX)
                continue;
            if(CSV_GetBool(table,col,row))
                unitInfop->LoadUnit[num] = true;
        }
    }

    // ⋋֌WB[`ׂĂ邾Ȃ̂
    // f[^\VK̕ɂɐB
    col = table->GetCellColumnByName(keyrow,"אڕ⋋");
    if(col != -1){
        int num;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,&num) == -1)
                break;
            if(num<0 || num>=UNITTYPEMAX)
                continue;
            if(table->GetCellByXY(col,row,cell,cellsize) == -1)
                continue;
            if(strstr(cell,"e") != NULL)
                unitInfop->SupplyUnit[num] = true;
            if(strstr(cell,"R") == NULL)
                unitInfop->OnlyFuel = true;
        }
    }
    col = table->GetCellColumnByName(keyrow,"ڕ⋋");
    if(col != -1){
        int num;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,&num) == -1)
                break;
            if(num<0 || num>=UNITTYPEMAX)
                continue;
            if(table->GetCellByXY(col,row,cell,cellsize) == -1)
                continue;
            if(strstr(cell,"e") != NULL)
                unitInfop->SupplyUnit[num] = true;
            if(strstr(cell,"R") == NULL)
                unitInfop->OnlyFuel = true;
            if(strstr(cell,"") != NULL)
                unitInfop->SupplyLife = true;
        }
    }
    // ȏA⋋֌W

    // Ί
    for(int gun=0;gun<2;gun++){
        CSV_GetGun(table,unitInfop,gun,row,keyrow);
    }

    // ړ
    col = table->GetCellColumnByName(keyrow,"ړ");
    if(col != -1){
        int gndnum;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
                break;
            if(sscanf(cell,"%d",&gndnum) != 1)
                break;
            if(gndnum<0 || gndnum>=GROUNDMAX)
                continue;
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d", &unitInfop->MoveLost[gndnum]);
        }
    }

    // n`̉\ȓ
    col = table->GetCellColumnByName(keyrow,"\");
    if(col != -1){
        int gndnum;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
                break;
            if(sscanf(cell,"%d",&gndnum) != 1)
                break;
            if(gndnum<0 || gndnum>=GROUNDMAX)
                continue;
            table->GetCellByXY(col,row,cell,cellsize);
            // f[^\ł͍ڗg̉߂傴ρB~͖B
            if(strstr(cell,"") != NULL)
                unitInfop->CanLoadOn[gndnum] = true;
            if(strstr(cell,"g") != NULL)
                unitInfop->CanLoadOn[gndnum] = true;
        }
    }

    // {݂Ƃ̊֌W
    col = table->GetCellColumnByName(keyrow,"{");
    if(col != -1){
        int gndnum;
        col++;
        for(;;col++){
            if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
                break;
            if(sscanf(cell,"%d",&gndnum) != 1)
                break;
            if(gndnum<0 || gndnum>=BUILDINGMAX)
                continue;
            table->GetCellByXY(col,row,cell,cellsize);
            if(strstr(cell,"") != NULL)
                unitInfop->Creatable[gndnum] = true;
            if(strstr(cell,"") != NULL)
                unitInfop->Supply[gndnum] = true;
        }
    }

    return 0;
}
//---------------------------------------------------------------------------
// ΊǂݍށBindex ͉ΊԍB
__fastcall BaseData::CSV_GetGun(TCSVTable *table,UnitChip *unitInfop,
    int index,int row,int keyrow)
{
    const int cellsize=256;
    char cell[cellsize];
    char key[16];
    int col,i;

    sprintf(key,"Ί%d",index);
    col = table->GetCellColumnByName(keyrow,key);
    if(col == -1)
        return -1;
    table->GetCellByXY(col,row, unitInfop->GunName[index], sizeof unitInfop->GunName[index]);
    col++;
    for(;;col++){
        if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
            break;
        // U͂̋Lqn܂ĂΏIB
        if(sscanf(cell,"%d",&i) == 1)
            break;
        if(!strcmp(cell,"e")){
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d", &unitInfop->GunMax[index]);
        }else if(!strcmp(cell,"˒")){
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d-%d", &unitInfop->MinRange[index], &unitInfop->MaxRange[index]);
        }else if(!strcmp(cell,"a")){
            table->GetCellByXY(col,row,cell,cellsize);
            sscanf(cell,"%d-%d", &i, &unitInfop->Radius[index]);
        }
    }
    // U͂̋LqǂݍށB
    int num;
    for(;;col++){
        if(table->GetCellByXY(col,keyrow,cell,cellsize) == -1)
            break;
        if(sscanf(cell,"%d",&num) != 1)
            break;
        if(num<0 || num>=UNITTYPEMAX)
            continue;
        table->GetCellByXY(col,row,cell,cellsize);
        sscanf(cell,"%d", &unitInfop->Attack[index][num]);
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall BaseData::CSV_GetGround(TCSVTable *table,const int row,const int keyrow)
{
    MapChip *gndInfop;
    int i;

    table->GetCellByXY(0,row,&i);
    if(i<0 || i>=GROUNDMAX)
        return -1;
    gndInfop = &MapInfo[i];

    table->GetCellByKeyRow(keyrow,"",row, gndInfop->Name, sizeof gndInfop->Name);
    table->GetCellByKeyRow(keyrow,"n`",row, &gndInfop->Shield);
    table->GetCellByKeyRow(keyrow,"",row, &gndInfop->Income);
    return 0;
}
//---------------------------------------------------------------------------
// ŏ̃ZɐĂsǂ܂őĂ邩ׁA
// Ō̍s̃CfbNXԂB
// X numbers ɂ̓ZɓĂ鐮̃Xgi[B
// X Xg̃TCYȂΎsƂĖ߂l -1
__fastcall BaseData::CSV_GetEndOfNumberRow(TCSVTable *table,int row)
{
    const int cellsize=64;
    char cell[cellsize];
    int endrow,i;

    for(endrow=row+1;;endrow++){
        if(table->GetCellByXY(0,endrow,cell,cellsize) == -1)
            break;
        if(sscanf(cell,"%d",&i) != 1)
            break;
    }
    return endrow;
}
//---------------------------------------------------------------------------
// ZɉĂ 1, Ȃ 0.
__fastcall BaseData::CSV_GetBool(TCSVTable *table,int col,int row)
{
    const int cellsize=64;
    char cell[cellsize];
    if(table->GetCellByXY(col,row,cell,cellsize) == -1)
        return 0;
    return (cell[0] != '\0');
}
//---------------------------------------------------------------------------
// Œۑׂn`̃CfbNXXgԂB
// {݂܂Ƃ߂ĕۑ邽߁B
// ߂l̓Xg̒Bi[Ȃ -1
__fastcall BaseData::GetNeedGroundList(int *list,int size)
{
    int num,count;
    count = GetNeedBuildingList(list,size);
    if(count == -1)
        return -1;
    for(num=BUILDINGMAX*3;num<GROUNDMAX;num++){
        if(MapInfo[num].Name[0] != '\0'){
            if(count == size)
                return -1;
            list[count++] = num;
        }
    }
    return count;
}
//---------------------------------------------------------------------------
// Œۑׂ{݂̃CfbNXXgԂB
// GetNeedGroundList() ̐QƂB
__fastcall BaseData::GetNeedBuildingList(int *list,int size)
{
    int num,count=0;
    for(num=0;num<BUILDINGMAX;num++){
        if(MapInfo[num].Name[0] != '\0'){
            if(count == size)
                return -1;
            list[count++] = num;
        }
    }
    return count;
}
//---------------------------------------------------------------------------
//gpΊ̑I -1:gp\ȉΊ킪
//Flagɂ͎gp\ȉΊBFlag |= 1<<UsableGun
__fastcall UnitStatus::SelectGun(BaseData *BaseDatap,int TargetType,int Flag)
{
    int h,i=0,GunType=-1;

    for(h=0;h<2;h++) //e򂪎cĂă_[W̑傫I
        if(Flag & (1<<h))
            if(GunRest[h] && BaseDatap->UnitInfo[Type].Attack[h][TargetType]>i){
                i=BaseDatap->UnitInfo[Type].Attack[h][TargetType];
                GunType=h;
            }
    return GunType;
}
//---------------------------------------------------------------------------
//ڒ̃jbgTypeԂ LoadNum=0,1
__fastcall UnitStatus::LoadingType(SideStatus *Sidep,int LoadNum)
{
    if(!Load)
        return -1;
    return Sidep->Unit[LoadingUnit[LoadNum]].Type;
}
//---------------------------------------------------------------------------
// w肳ꂽjbgŃCX^XB
// GfB^EY̏\ɎgpB
__fastcall UnitStatus::SetDefault(int graph,int type,UnitChip *unitInfop)
{
    Graph = graph;
    Type = type;
    Life = 100;
    Fuel = unitInfop->FuelMax;
    for(int i=0;i<2;i++)
        GunRest[i] = unitInfop->GunMax[i];
    Ver2Mode = false;
    return 0;
}
//---------------------------------------------------------------------------
//Ver.1.04ȑÕf[^ǂ
__fastcall UnitStatus::ReadVer104(int handle)
{
    read(handle,&X,sizeof (int));
    read(handle,&Y,sizeof (int));
    read(handle,&Graph,sizeof (int));
    if(Graph>=40)
        Graph+=60;
    read(handle,&Type,sizeof (int));
    read(handle,&Life,sizeof (int));
    read(handle,&Fuel,sizeof (int));
    read(handle,&Load,sizeof (int));
    read(handle,GunRest,(sizeof (int))*2);
    read(handle,LoadingUnit,(sizeof (int))*2);
    lseek(handle,3l,SEEK_CUR);
    read(handle,&Actioned,sizeof (bool));
    return 0;
}
//---------------------------------------------------------------------------
/*
//^ꂽnhŃjbg̏
__fastcall UnitStatus::Write(int handle)
{
    write(handle,&X,sizeof (int));
    write(handle,&Y,sizeof (int));
    write(handle,&Graph,sizeof (int));
    write(handle,&Type,sizeof (int));
    write(handle,&Life,sizeof (int));
    write(handle,&Fuel,sizeof (int));
    write(handle,&Load,sizeof (int));
    write(handle,GunRest,sizeof GunRest);
    write(handle,LoadingUnit,sizeof LoadingUnit);
    write(handle,&Actioned,sizeof (bool));
    return 0;
}*/
//---------------------------------------------------------------------------
//jbgǂݍށBVer͌ĂяoǗēnB
__fastcall UnitStatus::Read(int handle,int Ver)
{
    read(handle,&X,sizeof (int));
    read(handle,&Y,sizeof (int));
    read(handle,&Graph,sizeof (int));
    if(Ver<2 && Graph>=40) //UNITTYPEMAXgɂGraph̕ω
        Graph+=60;
    if(Ver<4 && Graph>=100) //UNITTYPEMAXgɂGraph̕ω
        Graph+=100;
    read(handle,&Type,sizeof (int));
    read(handle,&Life,sizeof (int));
    read(handle,&Fuel,sizeof (int));
    read(handle,&Load,sizeof (int));
    read(handle,GunRest,sizeof GunRest);
    read(handle,LoadingUnit,sizeof LoadingUnit);
    read(handle,&Actioned,sizeof (bool));
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uɃjbg̏ށB
//JeSw͌ĂяoōsB
__fastcall UnitStatus::WriteText(TDataTable *table)
{
    table->PutTwoValues(KEY_US_XY, X,Y);
    if(Ver2Mode){
        int owner = Graph/UNITTYPEMAX;
        int id = Graph%UNITTYPEMAX;
        table->Put("ID", id);
        table->Put("Owner", owner);
    }else{
        table->Put(KEY_US_GRAPH, Graph);
        table->Put(KEY_US_TYPE, Type);
    }
    table->Put(KEY_US_LIFE, Life);
    table->Put(KEY_US_FUEL, Fuel);
    table->PutValues(KEY_US_LOAD, LoadingUnit, Load);
    table->PutValues(KEY_US_GUNREST, GunRest, 2);
    table->Put(KEY_US_ACTIONED, (int)Actioned);
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[u烆jbg̏ǂݍށB
//JeSw͌ĂяoōsB
__fastcall UnitStatus::ReadText(TDataTable *table)
{
    table->GetTwoValues(KEY_US_XY, &X,&Y);
    table->Get(KEY_US_GRAPH, &Graph);
    table->Get(KEY_US_TYPE, &Type);
    table->Get(KEY_US_LIFE, &Life);
    table->Get(KEY_US_FUEL, &Fuel);
    Load = table->GetValues(KEY_US_LOAD, LoadingUnit, 2);
    table->GetValues(KEY_US_GUNREST, GunRest, 2);
    table->Get(KEY_US_ACTIONED, &Actioned);
    return 0;
}
//---------------------------------------------------------------------------

__fastcall SideStatus::Initialize(void)
{
    UnitCount=0;
    Money=0;
    PhaseStartX=PhaseStartY=0;
    MailAddress[0] = '\0';
    return 0;
}
//---------------------------------------------------------------------------
//tFCYIp
__fastcall SideStatus::EndClear(void)
{
    int i;

    for(i=0;i<UnitCount;i++)
        Unit[i].Actioned=false;
    return 0;
}
//---------------------------------------------------------------------------
//̌vZ
__fastcall SideStatus::CalcIncome(MapData *Mapp,BaseData *BaseDatap)
{
    int x,y;

    Income=0;
    for(y=0;y<Mapp->Height;y++)
        for(x=0;x<Mapp->Width;x++)
            if(Mapp->Data[x][y].BSide() == Side)
                Income += BaseDatap->MapInfo[Mapp->Data[x][y].Graph].Income;

    return 0;
}
//---------------------------------------------------------------------------
//jbg̒ǉ
__fastcall SideStatus::AddUnit(BaseData *BaseDatap,int zx,int zy,int Graph)
{
    int Type;

    Type=Graph%UNITTYPEMAX;
    if(UnitCount>=UNITMAX)
        return -1;
    Unit[UnitCount].Life=100;
    Unit[UnitCount].Fuel=BaseDatap->UnitInfo[Type].FuelMax;
    Unit[UnitCount].Load=0;
    Unit[UnitCount].GunRest[0]=BaseDatap->UnitInfo[Type].GunMax[0];
    Unit[UnitCount].GunRest[1]=BaseDatap->UnitInfo[Type].GunMax[1];
    Unit[UnitCount].X=zx;
    Unit[UnitCount].Y=zy;
    Unit[UnitCount].Graph=Graph;
    Unit[UnitCount].Type=Type;
    Unit[UnitCount].Actioned=true;
    UnitCount++;
    return 0;
}
//---------------------------------------------------------------------------
//jbg̍폜
__fastcall SideStatus::DeleteUnit(MapData *Mapp,int UnitNum)
{
    int DeleteList[UNITMAX],i;

    i=MakeDeleteList(UnitNum,DeleteList,0);
    Sort(DeleteList,i);
    PressUnit(Mapp,DeleteList,i);

    return 0;
}
//---------------------------------------------------------------------------
//w肵jbgɓڂĂ郆jbgSăXgɏo
//߂l̓Xg̗vf
__fastcall SideStatus::MakeDeleteList(int UnitNum,int DeleteList[],int Count)
{
    int i;

    DeleteList[Count]=UnitNum; //w肳ꂽjbggXgɒǉ
    Count++;
    for(i=0;i<Unit[UnitNum].Load;i++) //ڂĂ΂ɂĂׂ
        Count=MakeDeleteList(Unit[UnitNum].LoadingUnit[i],DeleteList,Count);
    return Count;
}
//---------------------------------------------------------------------------
//폜ꂽjbg̐Ղl߂
__fastcall SideStatus::PressUnit(MapData *Mapp,int UnitNums[],int Units)
{
    int i,j,k,x,y;

    for(i=0;i<Units;i++){
        for(j=UnitNums[i];j<UnitCount-1;j++) //l߂
            Unit[j]=Unit[j+1];
        for(y=0;y<Mapp->Height;y++)    //}bṽjbgԍC
            for(x=0;x<Mapp->Width;x++)
                if(Mapp->Data[x][y].Side==Side && Mapp->Data[x][y].Unit>UnitNums[i])
                    Mapp->Data[x][y].Unit--;
        for(j=0;j<UnitCount;j++)
            for(k=0;k<Unit[j].Load;k++)
                if(Unit[j].LoadingUnit[k]>UnitNums[i])
                    Unit[j].LoadingUnit[k]--; //ڒ̃jbg̔ԍC
        UnitCount--;
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbgɃjbg𓋍
__fastcall SideStatus::LoadUnit(int Loader,int Loaded)
{
    if(Unit[Loader].Load > 1)
        return -1;
    Unit[Loader].LoadingUnit[Unit[Loader].Load]=Loaded;
    Unit[Loader].Load++;
    return 0;
}
//---------------------------------------------------------------------------
//~\[gB̂ŉɂȂƂɂł蒼
__fastcall SideStatus::Sort(int Data[],int DataCount)
{
    int i,j,m,n;

    for(i=0;i<DataCount;i++){ //̃Vv\[g
        m=-1;
        n=i;
        for(j=i;j<DataCount;j++)
            if(Data[j]>m){
                m=Data[j];
                n=j;
            }
        Swap(&Data[i],&Data[n]);
    }
    return 0;
}
//---------------------------------------------------------------------------
//XbvB̃NX̃o[łKR͑SȂ
__fastcall SideStatus::Swap(int *p,int *q)
{
    int i;

    i=*p;
    *p=*q;
    *q=i;
    return 0;
}
//---------------------------------------------------------------------------
//jbg̃Ct
__fastcall SideStatus::DisLife(int UnitNum,int Decrease)
{
    int i,j;

    Unit[UnitNum].Life-=Decrease;
    for(i=0;i<Unit[UnitNum].Load;i++)
        if(Unit[Unit[UnitNum].LoadingUnit[i]].Life > Unit[UnitNum].Life){
            j=Unit[Unit[UnitNum].LoadingUnit[i]].Life - Unit[UnitNum].Life;
            DisLife(Unit[UnitNum].LoadingUnit[i],j);
            //ڃjbg̓ڃjbg_[W󂯂
        }
    return 0;
}
//---------------------------------------------------------------------------
//S⋋
__fastcall SideStatus::SupplyAll(MapData *Mapp,BaseData *BaseDatap)
{
    int Graph,i,j,x,y,u;
    UnitChip *UnitInfop;

    if(Money < 0)   //}CiXȂ牽Ȃ
        return 0;
    for(i=0;i<UnitCount;i++){
        if(Unit[i].X==-1)
            continue;
        UnitInfop = &BaseDatap->UnitInfo[Unit[i].Type];
        Graph = Mapp->Data[Unit[i].X][Unit[i].Y].Graph;
        if(Graph/BUILDINGMAX == Side)
            if(UnitInfop->Supply[Graph%BUILDINGMAX]){
                SupplyToUnit(BaseDatap,i,true,false);
            }
        if(UnitInfop->SupplyLoading && Unit[i].Load){
            for(j=0;j<Unit[i].Load;j++){
                u=Unit[i].LoadingUnit[j];
                if(UnitInfop->SupplyUnit[Unit[u].Type])
                    SupplyToUnit(BaseDatap,u,UnitInfop->SupplyLife,UnitInfop->OnlyFuel);
            }
        }
        //ڂĂ郆jbgɕ⋋B⋋\łKv
    }
    for(y=0;y<Mapp->Height;y++) //⋋jbg̎
        for(x=0;x<Mapp->Width;x++)
            if(Mapp->RangePoint[x][y] && Mapp->Data[x][y].Side==Side){
                i=Mapp->Data[x][y].Unit;
                SupplyToUnit(BaseDatap,i,false,Mapp->RangePoint[x][y]==2);
            }
    //炩ߔ⋋\ǂׂĂÔ߁ARangePoint
    //`FbNŗǂAꉞSideĂB
    //R̂ݕ⋋IvVFieldScreen::FindSupplyRange()ŒׂĂ

    return 0;
}
//---------------------------------------------------------------------------
//Q[JnASẴjbg̒eƔRtɂB
__fastcall SideStatus::SupplySetUnit(BaseData *BaseDatap)
{
    int i;

    for(i=0;i<UnitCount;i++)
        if(Unit[i].X!=-1)
            SupplyToUnit(BaseDatap,i,false,false);

    return 0;
}
//---------------------------------------------------------------------------
//Rƒe⋋BR͖ALifeFuel͏t
__fastcall SideStatus::SupplyToUnit(BaseData *BaseDatap,int UnitNum,bool bLife,bool OnlyFuel)
{
    UnitStatus *Unitp = &Unit[UnitNum];
    UnitChip *UnitInfop = &BaseDatap->UnitInfo[Unitp->Type];
    int SupplyLife,SupplyFuel,SupplyGun,i,rate;

    if(bLife){
        rate = UnitInfop->Value/100;
        SupplyLife = 100-Unitp->Life;
        if(SupplyLife>20)
            SupplyLife=20;
        if(SupplyLife*rate > Money)
            SupplyLife = Money/rate;
        Money-=SupplyLife*rate;
        Unitp->Life += SupplyLife; //Life⋋
    }
    SupplyFuel = UnitInfop->FuelMax - Unitp->Fuel;
    if(SupplyFuel*FUELVALUE > Money)
        SupplyFuel = Money/FUELVALUE;
    Money -= SupplyFuel*FUELVALUE;
    Unitp->Fuel += SupplyFuel; //R⋋
    if(OnlyFuel) //RȂ炱ŏI
        return 0;

    for(i=0;i<2;i++){     //e⋋
        SupplyGun = UnitInfop->GunMax[i] - Unitp->GunRest[i];
        if(SupplyGun*GUNVALUE > Money)
            SupplyGun = Money/GUNVALUE;
        Money -= SupplyGun*GUNVALUE;
        Unitp->GunRest[i]+=SupplyGun;
    }
    return 0;
}
//---------------------------------------------------------------------------
//s̃jbgTB͌Jn郆jbgԍB
//߂l͍ŏɌsjbg̔ԍBȂ-1
__fastcall SideStatus::SearchNoActioned(int UnitNum)
{
    int i,j=-1;

    for(i=UnitNum;i<UnitCount;i++)
        if(!Unit[i].Actioned && Unit[i].X!=-1){
            j=i;
            break;
        }
    if(j==-1) //Ō܂ŒTČȂΐ擪ɖ߂ĒT
        for(i=0;i<UnitNum;i++)
            if(!Unit[i].Actioned && Unit[i].X!=-1){
                j=i;
                break;
            }

    return j;
}
//---------------------------------------------------------------------------
//R}CiXɂȂĂ郆jbgC
__fastcall SideStatus::AdjustUnitFuel(void)
{
    int i;

    for(i=0;i<UNITMAX;i++)
        if(Unit[i].Fuel<0)
            Unit[i].Fuel=0;
    return 0;
}
//---------------------------------------------------------------------------
//Ver.1.04ȑÕf[^ǂ
__fastcall SideStatus::ReadVer104(int handle)
{
    int i;

    read(handle,&Side,sizeof (int));
    read(handle,&UnitCount,sizeof (int));
    read(handle,&Money,sizeof (int));
    read(handle,&Income,sizeof (int));
    read(handle,&PhaseStartX,sizeof (int));
    read(handle,&PhaseStartY,sizeof (int));
    for(i=0;i<40;i++)
        Unit[i].ReadVer104(handle);
    return 0;
}
//---------------------------------------------------------------------------
/*
__fastcall SideStatus::Write(int handle)
{
    int i,Ver=4;

    write(handle,&Ver,sizeof (int));
    write(handle,&Side,sizeof (int));
    write(handle,&UnitCount,sizeof (int));
    write(handle,&Money,sizeof (int));
    write(handle,&Income,sizeof (int));
    write(handle,&PhaseStartX,sizeof (int));
    write(handle,&PhaseStartY,sizeof (int));
    for(i=0;i<UnitCount;i++)
        Unit[i].Write(handle);
    return 0;
}*/
//---------------------------------------------------------------------------
//
__fastcall SideStatus::Read(int handle)
{
    int i,Ver;

    read(handle,&Ver,sizeof (int));
    read(handle,&Side,sizeof (int));
    read(handle,&UnitCount,sizeof (int));
    read(handle,&Money,sizeof (int));
    read(handle,&Income,sizeof (int));
    read(handle,&PhaseStartX,sizeof (int));
    read(handle,&PhaseStartY,sizeof (int));
    if(Ver>=3)
        for(i=0;i<UnitCount;i++)
            Unit[i].Read(handle,Ver);
    else
        for(i=0;i<UNITMAX_OLD;i++)
            Unit[i].Read(handle,Ver);

    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uɐwcށBJeS͌ĂяoŎwB
__fastcall SideStatus::WriteText(TDataTable *table)
{
    char ctg[50];
    int i;

    table->Put(KEY_SS_MONEY, Money);
    table->Put(KEY_SS_INCOME, Income);
    table->PutTwoValues(KEY_SS_ORIGINXY, PhaseStartX,PhaseStartY);
    table->Put(KEY_SS_LIMITVIEW, LimitView);
    table->Put(KEY_SS_MAIL, MailAddress);
    table->Put(KEY_SS_PLAYER, PlayerName);

    for(i=0;i<UnitCount;i++){
        sprintf(ctg,"%s%d-%d",CTG_UNITSTATUS,Side,i);
        table->SetCategory(ctg);
        Unit[i].WriteText(table);
    }
    return 0;
}
//---------------------------------------------------------------------------
//^ꂽe[uwcǂݍށBJeS͌ĂяoŎwB
__fastcall SideStatus::ReadText(TDataTable *table)
{
    char ctg[50];
    int i;

    table->Get(KEY_SS_MONEY, &Money);
    table->Get(KEY_SS_INCOME, &Income);
    table->GetTwoValues(KEY_SS_ORIGINXY, &PhaseStartX,&PhaseStartY);
    table->Get(KEY_SS_LIMITVIEW, &LimitView);
    table->Get(KEY_SS_MAIL, MailAddress);
    table->Get(KEY_SS_PLAYER, PlayerName);

    UnitCount = 0;
    for(i=0;i<UNITMAX;i++){
        sprintf(ctg,"%s%d-%d",CTG_UNITSTATUS,Side,i);
        if(table->GetSubCategory(ctg) == -1)
            break;
        Unit[i].ReadText(table);
        UnitCount++;
    }
    return 0;
}
//---------------------------------------------------------------------------
//ݒ
__fastcall GamePurpose::Initialize(void)
{
    Enabled=false;
    Reserved1=false;
    Turn1=0;
    Turn2=0;
    ItemID1=0;
    ItemID2=0;
    Value1=0;
    Value2=0;
    Value3=0;
    CompleteTurn=-1;
    return 0;
}
//---------------------------------------------------------------------------
//t@Cɐݒeo
__fastcall GamePurpose::Write(int handle)
{
    int size;

    size=sizeof (bool);
    write(handle,&Enabled,size);
    write(handle,&Reserved1,size);
    size=sizeof (int);
    write(handle,&Turn1,size);
    write(handle,&Turn2,size);
    write(handle,&ItemID1,size);
    write(handle,&ItemID2,size);
    write(handle,&Value1,size);
    write(handle,&Value2,size);
    write(handle,&Value3,size);
    write(handle,&CompleteTurn,size);
    return 0;
}
//---------------------------------------------------------------------------
//t@Cݒeǂݏo
__fastcall GamePurpose::Read(int handle)
{
    int size;

    size=sizeof (bool);
    read(handle,&Enabled,size);
    read(handle,&Reserved1,size);
    size=sizeof (int);
    read(handle,&Turn1,size);
    read(handle,&Turn2,size);
    read(handle,&ItemID1,size);
    read(handle,&ItemID2,size);
    read(handle,&Value1,size);
    read(handle,&Value2,size);
    read(handle,&Value3,size);
    read(handle,&CompleteTurn,size);
    return 0;
}
//---------------------------------------------------------------------------
//
__fastcall GamePurposes::Initialize(void)
{
    int i;

    AllAnd=false;
    for(i=0;i<4;i++)
        Reserved[i]=false;
    for(i=0;i<GAMEPURPOSEMAX;i++)
        Data[i].Initialize();
    return 0;
}
//---------------------------------------------------------------------------
//ЂƂłEnabledȂ1AłȂ0
__fastcall GamePurposes::Enabled(void)
{
    bool b=false;
    int i;

    for(i=0;i<GAMEPURPOSEMAX;i++)
        if(Data[i].Enabled)
            b=true;

    return (int)b;
}
//---------------------------------------------------------------------------
//t@Cɐݒeo
__fastcall GamePurposes::Write(int handle)
{
    int i;

    for(i=0;i<GAMEPURPOSEMAX;i++)
        Data[i].Write(handle);
    write(handle,&AllAnd,sizeof AllAnd);
    write(handle,Reserved,sizeof Reserved);

    return 0;
}
//---------------------------------------------------------------------------
//t@Cݒeǂݏo
__fastcall GamePurposes::Read(int handle)
{
    int i;

    for(i=0;i<GAMEPURPOSEMAX;i++)
        Data[i].Read(handle);
    read(handle,&AllAnd,sizeof AllAnd);
    read(handle,Reserved,sizeof Reserved);

    return 0;
}
//---------------------------------------------------------------------------
//ۂɐݒ肳ĂB̗vf̖OԂ
__fastcall GamePurposes::ItemName(int Num,char *Name,BaseData *BaseDatap)
{
    int ItemID;

    ItemID=Data[Num].ItemID1;
    MakeItemName(ItemID,Name,BaseDatap);
    return 0;
}
//---------------------------------------------------------------------------
//B̗vf̖OԂ
__fastcall GamePurposes::MakeItemName(int ItemID,char *Name,BaseData *BaseDatap)
{
    int i;

    i=ItemID-ITEM_BUILDING;
    if(i>=0 && i<BUILDINGMAX){
        strcpy(Name,BaseDatap->MapInfo[i].Name);
        return 0; //̖O
    }
    switch(ItemID){
    case ITEM_ALLBUILDING: //SĂ̌
        strcpy(Name,"@@{");
        break;
    case ITEM_ALLUNIT:     //jbg
        strcpy(Name,"jbg");
        break;
    case ITEM_INCOME:
        strcpy(Name,"@@");
        break;
    case ITEM_MONEY:
        strcpy(Name,"@@");
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//eB̃bZ[W𐶐
__fastcall GamePurposes::PurposeMessage(int Num,char *Message,BaseData *BaseDatap)
{
    char Name[9];
    int Turn,Value;

    switch(Num){
    case 0:
        Turn=Data[Num].Turn1;
        ItemName(Num,Name,BaseDatap);
        Value=Data[Num].Value1;
        sprintf(Message,"%3d^[ȍ~ɎR%8s%5dȏł",Turn,Name,Value);
        break;
    case 1:
        Turn=Data[Num].Turn1;
        ItemName(Num,Name,BaseDatap);
        Value=Data[Num].Value1;
        sprintf(Message,"%3d^[܂łɓG%8s%5dȉɂ",Turn,Name,Value);
        break;
    }
    if(!Data[Num].Enabled)
        Message[0]='\0'; //LłȂȂ\Ȃ

    return 0;
}
//---------------------------------------------------------------------------
//EBڕW̕\쐬
__fastcall ConditionViewer::MakeLabel(TPanel *BasePanel,char *Message[])
{
    TLabel *NewLabel;
    int i;

    GroupBox_Win=new TGroupBox(BasePanel);
    GroupBox_Win->Parent=BasePanel;
    GroupBox_Win->Left=4;
    GroupBox_Win->Top=4;
    GroupBox_Win->Width=BasePanel->Width-8;
    GroupBox_Win->Height=48;
    GroupBox_Win->Caption="";

    GroupBox_Purposes=new TGroupBox(BasePanel);
    GroupBox_Purposes->Parent=BasePanel;
    GroupBox_Purposes->Left=4;
    GroupBox_Purposes->Top=56;
    GroupBox_Purposes->Width=BasePanel->Width-8;
    GroupBox_Purposes->Height=BasePanel->Height - GroupBox_Purposes->Top - 4;
    GroupBox_Purposes->Caption="BڕW";

    Label_Win=new TLabel(GroupBox_Win);
    Label_Win->Parent=GroupBox_Win;
    Label_Win->Left=4;
    Label_Win->Top=20;
    Label_Win->Width=GroupBox_Win->Width-8;
    Label_Win->Height=GroupBox_Win->Height-24;
    Label_Win->AutoSize=false;
    Label_Win->Caption="GSł܂͓Gs";

    for(i=0;i<2;i++){
        NewLabel=new TLabel(GroupBox_Purposes);
        NewLabel->Parent=GroupBox_Purposes;
        NewLabel->Left=4;
        NewLabel->Top=16+40*i;
        NewLabel->AutoSize=true;
        NewLabel->Caption=Message[i];
        Label_Purpose[i]=NewLabel;

        NewLabel=new TLabel(GroupBox_Purposes);
        NewLabel->Parent=GroupBox_Purposes;
        NewLabel->Left=4;
        NewLabel->Top=32+40*i;
        NewLabel->AutoSize=true;
        NewLabel->Caption="BI";
        NewLabel->Visible=false;
        Label_Complete[i]=NewLabel;
    }

    Label_AllAnd=new TLabel(GroupBox_Purposes);
    Label_AllAnd->Parent=GroupBox_Purposes;
    Label_AllAnd->Left=4;
    Label_AllAnd->Top=GroupBox_Purposes->Height-24;
    Label_AllAnd->AutoSize=true;
    Label_AllAnd->Caption="ȏ̏𓯎ɖ";

    Label_AllComplete=new TLabel(GroupBox_Purposes);
    Label_AllComplete->Parent=GroupBox_Purposes;
    Label_AllComplete->Left=Label_AllAnd->Left+256;
    Label_AllComplete->Top=Label_AllAnd->Top;
    Label_AllComplete->AutoSize=true;
    Label_AllComplete->Visible=false;
    Label_AllComplete->Caption="SBI";

    return 0;
}
//---------------------------------------------------------------------------
//EBڕW̕\폜
__fastcall ConditionViewer::Delete(void)
{
    int i;

    delete Label_Win;

    for(i=0;i<2;i++)
        delete Label_Purpose[i];

    delete Label_AllAnd;
    delete Label_AllComplete;

    delete GroupBox_Win;

    delete GroupBox_Purposes;

    return 0;
}
//---------------------------------------------------------------------------
//ۂ̕\쐬B
__fastcall ConditionViewer::Make(TPanel *BasePanel,
    GamePurposes *Purposesp,BaseData *BaseDatap)
{
    char Message[2][100],str[50],*cp[2];
    bool b=true;
    int i;

    for(i=0;i<2;i++){
        Purposesp->PurposeMessage(i,Message[i],BaseDatap);
        cp[i]=Message[i];
    }
    MakeLabel(BasePanel,cp);
    Label_AllAnd->Visible=Purposesp->AllAnd;
    for(i=0;i<2;i++)
        if(Purposesp->Data[i].CompleteTurn!=-1){  //BbZ[W
            sprintf(str,"%3d^[ŒB",Purposesp->Data[i].CompleteTurn);
            Label_Complete[i]->Caption=str;
            Label_Complete[i]->Visible=true;
        }
    for(i=0;i<GAMEPURPOSEMAX;i++)
        if(Purposesp->Data[i].Enabled && Purposesp->Data[i].CompleteTurn==-1)
            b=false;

    Label_AllComplete->Visible=b;

    return 0;
}
//---------------------------------------------------------------------------
//\x𐶐iQwcj
__fastcall UnionStatusViewer::MakeLabels(TImage *Image1,TImage *Image2)
{
    ViewImage[0]=Image1;
    ViewImage[1]=Image2;

    return 0;
}
//---------------------------------------------------------------------------
//wcf[^\
__fastcall UnionStatusViewer::Show(BaseData *BaseDatap,MapData *Mapp,
                                   GBWImageData *GBWImagep)
{
    ShowBuilding(BaseDatap,Mapp,GBWImagep);
    return 0;
}
//---------------------------------------------------------------------------
//{ݐ\
__fastcall UnionStatusViewer::ShowBuilding(BaseData *BaseDatap,MapData *Mapp,
                                           GBWImageData *GBWImagep)
{
    char str[50];
    int i,j,x,y,n,Count[BUILDINGMAX*3];

    Mapp->SearchBuilding(Count);
    for(i=0;i<2;i++)
        for(j=0;j<BUILDINGMAX;j++){
            x = (j/5)*48;
            y = (j%5)*20;
            n = i*BUILDINGMAX+j;
            GBWImagep->ImageList_MapS->Draw(ViewImage[i]->Canvas,x,y,n);
            sprintf(str,"%3d",Count[n]);
            ViewImage[i]->Canvas->TextOut(x+18,y+2,str);

/*          //SăeLXgŕ\ꍇ̏
            sprintf(str,"%8s@%3d",BaseDatap->MapInfo[j].Name,Count[i*BUILDINGMAX+j]);
            w=ViewImage[i]->Canvas->TextWidth(str);
            ViewImage[i]->Canvas->TextOut(64+88*(j/5)-w,4+16*(j%5),str);
            //w>64̎A\邨ꂪ
*/
        }
    return 0;
}
//---------------------------------------------------------------------------
//OpenDialogJăpXQƂB
__fastcall PathBrowser::Execute(TComponent *Owner,char *filter,char *ext,char *path)
{
    TOpenDialog *dialog = new TOpenDialog(Owner);
    int result;

    dialog->Filter = filter;
    dialog->FileName = path;
    dialog->DefaultExt = ext;
    result = dialog->Execute();
    if(result)
        strcpy(path,dialog->FileName.c_str());
    delete dialog;
    return result;
}
//---------------------------------------------------------------------------

__fastcall GameSituation::Initialize(void)
{
    Turn=0;
    Phase=0;
    UnitMax=UNITMAX_OLD; //Type 1.06ȑÕZ[ut@Cǂ񂾎̈
    CPUModeDefault();
    return 0;
}
//---------------------------------------------------------------------------
//CPŨftHgݒ
__fastcall GameSituation::CPUModeDefault(void)
{
    CPUMode[0]=false;
    CPUMode[1]=true;
    return 0;
}
//---------------------------------------------------------------------------
/*
__fastcall GameSituation::Write(int handle)
{
    int Ver=2,size;

    size=sizeof (int);
    write(handle,&Ver,size);
    write(handle,&Phase,size);
    write(handle,&Turn,size);
    write(handle,&UnitMax,size);

    return 0;
}*/
//---------------------------------------------------------------------------
//
__fastcall GameSituation::Read(int handle)
{
    int Ver,size;

    size=sizeof (int);
    read(handle,&Ver,size);
    read(handle,&Phase,size);
    read(handle,&Turn,size);
    if(Ver>=2)
        read(handle,&UnitMax,size);

    return 0;
}
//---------------------------------------------------------------------------
//Save1.04ȑÕt@CKvȃf[^ǂݏo
__fastcall GameSituation::ReadVer104(int handle)
{
    int size;

    size=sizeof (bool);
    lseek(handle,(long)size*8,SEEK_CUR);

    lseek(handle,256l,SEEK_CUR);

    size=sizeof (int);
    read(handle,&Phase,size);
    read(handle,&Turn,size);
    lseek(handle,(long)size*6,SEEK_CUR);

    return 0;
}
//---------------------------------------------------------------------------
//Q[̏󋵂^ꂽe[uɏ
__fastcall GameSituation::WriteText(TDataTable *table)
{
    char key[50];
    int i;

    table->Put(KEY_PHASE, Phase);
    table->Put(KEY_TURN, Turn);
    table->Put(KEY_UNITMAX, UnitMax);
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",KEY_CPUMODE,i);
        table->Put(key, (int)CPUMode[i]);
    }
    return 0;
}
//---------------------------------------------------------------------------
//Q[̏󋵂^ꂽe[uǂݍ
__fastcall GameSituation::ReadText(TDataTable *table)
{
    char key[50];
    int i;

    table->Get(KEY_PHASE, &Phase);
    table->Get(KEY_TURN, &Turn);
    table->Get(KEY_UNITMAX, &UnitMax);
    for(i=0;i<2;i++){
        sprintf(key,"%s%d",KEY_CPUMODE,i);
        table->Get(key, &CPUMode[i]);
    }
    return 0;
}
//---------------------------------------------------------------------------
//rbg}bvOtBbN荞
__fastcall GBWImageData::Load(int PixelFormat)
{
    Graphics::TBitmap *BaseBitmap = new Graphics::TBitmap(),
                      *BitmapN = new Graphics::TBitmap(),
                      *BitmapS = new Graphics::TBitmap();
    TColor MaskColor=(TColor)0x00808000;
    int nw,nh,sw,sh,i,j,n,nx,sx,ny,sy,SmallY=320;

    if(PixelFormat!=8)
        BaseBitmap->LoadFromFile(GRAPHFILE8BIT);
    else
        BaseBitmap->LoadFromFile(GRAPHFILE4BIT);
        //ʃ[hQTUFȂpt@Cǂ

    //palette = BaseBitmap->Palette;
    BitmapN->Palette=BaseBitmap->Palette;
    BitmapN->Width=nw=GRAPHDEGREE_N;
    BitmapN->Height=nh=GRAPHDEGREE_N;
    BitmapS->Palette=BaseBitmap->Palette;
    BitmapS->Width=sw=GRAPHDEGREE_S;
    BitmapS->Height=sh=GRAPHDEGREE_S;

    ny=0;
    sy=SmallY;
    for(i=0;i<4;i++)  /* n`摜̓ǂݍ */
        for(j=0;j<20;j++){
            BitmapN->Canvas->CopyRect(Rect(0,0,nw,nh),BaseBitmap->Canvas,Rect(j*nw,ny+i*nh,j*nw+nw,ny+i*nh+nh));
            ImageList_MapN->Add(BitmapN,NULL);
            BitmapS->Canvas->CopyRect(Rect(0,0,sw,sh),BaseBitmap->Canvas,Rect(j*sw,sy+i*sh,j*sw+sw,sy+i*sh+sh));
            ImageList_MapS->Add(BitmapS,NULL);
        }

    ny=GRAPHDEGREE_N*4;
    sy=SmallY+GRAPHDEGREE_S*4;
    for(i=0;i<CURSOR_MAX;i++){ /* J[\摜̓ǂݍ */
        BitmapN->Canvas->CopyRect(Rect(0,0,nw,nh),BaseBitmap->Canvas,Rect(i*nw,ny,i*nw+nw,ny+nh));
        ImageList_CursorN->AddMasked(BitmapN,MaskColor);
        BitmapS->Canvas->CopyRect(Rect(0,0,sw,sh),BaseBitmap->Canvas,Rect(i*sw,sy,i*sw+sw,sy+sh));
        ImageList_CursorS->AddMasked(BitmapS,MaskColor);
    }

    MakeNoGrp();
    ny=GRAPHDEGREE_N*5;
    sy=SmallY+GRAPHDEGREE_S*5;
    for(i=0;i<4;i++)  /* jbg摜̓ǂݍ */
        for(j=0;j<20;j++){
            n=(i/2)*UNITTYPEMAX+(i%2)*20+j;
            BitmapN->Canvas->CopyRect(Rect(0,0,nw,nh),BaseBitmap->Canvas,Rect(j*nw,ny+i*nh,j*nw+nw,ny+i*nh+nh));
            ImageList_UnitN->ReplaceMasked(n,BitmapN,MaskColor);
            BitmapS->Canvas->CopyRect(Rect(0,0,sw,sh),BaseBitmap->Canvas,Rect(j*sw,sy+i*sh,j*sw+sw,sy+i*sh+sh));
            ImageList_UnitS->ReplaceMasked(n,BitmapS,MaskColor);
        }

    nx = sx = 0;
    ny=GRAPHDEGREE_N*9;
    sy=SmallY+GRAPHDEGREE_S*9;
    BitmapN->Width=nw=GRAPHDEGREE_N/2;
    BitmapS->Width=sw=GRAPHDEGREE_S/2;
    for(i=0;i<FIGURECOLORMAX;i++) /* 摜̓ǂݍ */
        for(j=0;j<FIGURECOUNT;j++){
            BitmapN->Canvas->CopyRect(Rect(0,0,nw,nh),BaseBitmap->Canvas,Rect(nx,ny,nx+nw,ny+nh));
            ImageList_FigureN->AddMasked(BitmapN,MaskColor);
            BitmapS->Canvas->CopyRect(Rect(0,0,sw,sh),BaseBitmap->Canvas,Rect(sx,sy,sx+sw,sy+sh));
            ImageList_FigureS->AddMasked(BitmapS,MaskColor);
            nx += GRAPHDEGREE_N/2;
            sx += GRAPHDEGREE_S/2;
        }

    delete BaseBitmap;
    delete BitmapN;
    delete BitmapS;
    return 0;
}
//---------------------------------------------------------------------------
//rbg}bv烆[U[`̃OtBbNǂݍ
//Count͓ǂݍސ
__fastcall GBWImageData::LoadUserExtend(char *file,int Sides,int Count)
{
    Graphics::TBitmap *BaseBitmap = new Graphics::TBitmap(),
                      *BitmapN = new Graphics::TBitmap(),
                      *BitmapS = new Graphics::TBitmap();
    TColor MaskColor=(TColor)0x00808000;
    int nw,nh,sw,sh,i,j,n,nx,ny,sx,sy,loaded=0;

    if(access(file,0))
        return -1;
    BaseBitmap->LoadFromFile(file);

    BitmapN->Palette = BaseBitmap->Palette;
    BitmapN->Width   = nw = GRAPHDEGREE_N;
    BitmapN->Height  = nh = GRAPHDEGREE_N;
    BitmapS->Palette = BaseBitmap->Palette;
    BitmapS->Width   = sw = GRAPHDEGREE_S;
    BitmapS->Height  = sh = GRAPHDEGREE_S;

    for(i=0;i<UNITTYPEMAX-UNITSTANDARD;i++){
        nx=(i%10)*nw;
        sx=nw*10+(i%5)*sw;
        for(j=0;j<Sides;j++){
            ny=((i/10)*Sides+j)*nh;
            n=TypeToGrp(j,UNITSTANDARD+i);
            if(i<Count && nx+nw<=BaseBitmap->Width && ny+nh<=BaseBitmap->Height){
                BitmapN->Canvas->CopyRect(Rect(0,0,nw,nh),BaseBitmap->Canvas,Rect(nx,ny,nx+nw,ny+nh));
                ImageList_UnitN->ReplaceMasked(n,BitmapN,MaskColor);
                loaded++;
            }//rbg}bvȂA荞ݐ𒴂Ă牽Ȃ

            sy=(i/10)*Sides*nh + j*sh*2 + (i%10)/5*sh;
            if(i<Count && sx+sw<=BaseBitmap->Width && sy+sh<=BaseBitmap->Height){
                BitmapS->Canvas->CopyRect(Rect(0,0,sw,sh),BaseBitmap->Canvas,Rect(sx,sy,sx+sw,sy+sh));
                ImageList_UnitS->ReplaceMasked(n,BitmapS,MaskColor);
            }
        }
    }

    delete BaseBitmap;
    delete BitmapN;
    delete BitmapS;
    return loaded;
}
//---------------------------------------------------------------------------
//jbgC[WXg󔒂Ŗ߂
__fastcall GBWImageData::MakeNoGrp(void)
{
    Graphics::TBitmap *BitmapN = new Graphics::TBitmap(),
                      *BitmapS = new Graphics::TBitmap();
    int i;

    ImageList_CursorN->GetBitmap(CURSOR_NULL,BitmapN);
    ImageList_CursorS->GetBitmap(CURSOR_NULL,BitmapS);
    for(i=0;i<UNITTYPEMAX*2;i++){
        ImageList_UnitN->Add(BitmapN,NULL);
        ImageList_UnitS->Add(BitmapS,NULL);
    }

    delete BitmapN;
    delete BitmapS;
    return 0;
}
//---------------------------------------------------------------------------
//jbgԍɑΉOtBbNԍZo
__fastcall GBWImageData::TypeToGrp(int Side,int Type)
{
    int Grp;

    Grp=Side*UNITTYPEMAX+Type;
    return Grp;
}
//---------------------------------------------------------------------------
//jbg̃OtBbNw肳ꂽLoXɕ`
__fastcall GBWImageData::DrawUnitCanvas(TCanvas *Canv,int Graph)
{
    ImageList_CursorN->Draw(Canv,0,0,CURSOR_NULL);
    if(Graph != -1)
        ImageList_UnitN->Draw(Canv,0,0,Graph);
    return 0;
}
//---------------------------------------------------------------------------
//t@CȂׂ̈ɏݒ
__fastcall TGBWOption::Initialize(void)
{
    CPUScroll = false;
    CPUSound  = false;
    UnitListNoModal = false;
    CPUSound = false;
    ShowRange = false;
    ZOCMode = false;
    EconomyMode = false;
    CPUNoGrp = false;
    IgnoreLife = false;
    DamageWaitFix = 100;
    LookUpWaitFix = 100;
    CPUWaitFix = 100;
    memset(&MailUser,0,sizeof MailUser);
    WindowState_gbw.Valid = false;
    WindowState_gbwedit.Valid = false;
    WindowState_gbwunit.Valid = false;
    return 0;
}
//---------------------------------------------------------------------------
#define INI_CTG_WINDOW_GBW     "Window_gbw"
#define INI_CTG_WINDOW_GBWEDIT "Window_gbwedit"
#define INI_CTG_WINDOW_GBWUNIT "Window_gbwunit"
#define INI_KEY_VALID     "Valid"
#define INI_KEY_LASTX     "LastX"
#define INI_KEY_LASTY     "LastY"
#define INI_KEY_LASTW     "LastWidth"
#define INI_KEY_LASTH     "LastHeight"
#define INI_KEY_STATE     "State"
#define INI_BS_CPUSCROLL  "CPUScroll"
#define INI_BS_UNITLISTNM "UnitListNoModal"
#define INI_BS_DAMAGEFIX  "DamageFix"
#define INI_BS_ZOCMODE    "ZOCMode"
#define INI_BS_CPUSOUND   "CPUSound"
#define INI_BS_DAMAGEWAIT "DamageWait"
#define INI_BS_LOOKUPWAIT "LookUpWait"
#define INI_BS_CPUWAIT    "CPUWait"
#define INI_BS_ECONOMY    "EconomyMode"
#define INI_BS_CPUNOGRP   "CPUNoGrp"
#define INI_BS_SAKUTEKI   "Sakuteki"
#define INI_BS_IGNORELIFE "IgnoreLife"
#define INI_BS_MAILUSER   "MailUser"
#define INI_BS_ADDRESS    "MailAddress"
#define INI_BS_REPLY      "ReplyAddress"
#define INI_BS_POPSERVER  "POP3Server"
#define INI_BS_POPUSER    "POP3User"
#define INI_BS_POPPASS    "POP3Pass"
#define INI_BS_SMTPSERVER "SMTPServer"
#define INI_BS_SMTPUSER   "SMTPUser"
#define INI_BS_SAVEMES    "SaveMessage"
// et@CɕۑB
__fastcall TGBWOption::Save(void)
{
    TDataTable *table = new TDataTable();

    table->SetCategory("Option");
    table->Put(INI_BS_CPUSCROLL, (int)CPUScroll);
    table->Put(INI_BS_UNITLISTNM, (int)UnitListNoModal);
    table->Put(INI_BS_DAMAGEFIX, (int)DamageFix);
    table->Put(INI_BS_ZOCMODE, (int)ZOCMode);
    table->Put(INI_BS_CPUSOUND, (int)CPUSound);
    table->Put(INI_BS_ECONOMY, (int)EconomyMode);
    table->Put(INI_BS_CPUNOGRP, (int)CPUNoGrp);
    table->Put(INI_BS_DAMAGEWAIT, DamageWaitFix);
    table->Put(INI_BS_LOOKUPWAIT, LookUpWaitFix);
    table->Put(INI_BS_CPUWAIT, CPUWaitFix);
    table->Put(INI_BS_IGNORELIFE, IgnoreLife);
    //[֌W
    table->Put(INI_BS_MAILUSER, MailUser.Name);
    table->Put(INI_BS_ADDRESS, MailUser.Address);
    table->Put(INI_BS_REPLY, MailUser.ReplyAddress);
    table->Put(INI_BS_POPSERVER, MailUser.POPServer);
    table->Put(INI_BS_POPUSER, MailUser.POPUser);
    table->Put(INI_BS_POPPASS, MailUser.POPPass);
    table->Put(INI_BS_SMTPSERVER, MailUser.SMTPServer);
    table->Put(INI_BS_SMTPUSER, MailUser.SMTPUser);
    table->Put(INI_BS_SAVEMES, (int)MailUser.SaveMessage);

    table->SetCategory(INI_CTG_WINDOW_GBW);
    SaveWindowState(table,&WindowState_gbw);
    table->SetCategory(INI_CTG_WINDOW_GBWEDIT);
    SaveWindowState(table,&WindowState_gbwedit);
    table->SetCategory(INI_CTG_WINDOW_GBWUNIT);
    SaveWindowState(table,&WindowState_gbwunit);

    table->SaveToFile(OptionPath);
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
// ǂݏoBt@CȂΉȂB
__fastcall TGBWOption::Load(void)
{
    TDataTable *table = new TDataTable();

    table->LoadFromFile(OptionPath);

    table->GetCategory("Option");
    table->Get(INI_BS_CPUSCROLL, &CPUScroll);
    table->Get(INI_BS_UNITLISTNM, &UnitListNoModal);
    table->Get(INI_BS_DAMAGEFIX, &DamageFix);
    table->Get(INI_BS_ZOCMODE, &ZOCMode);
    table->Get(INI_BS_CPUSOUND, &CPUSound);
    table->Get(INI_BS_ECONOMY, &EconomyMode);
    table->Get(INI_BS_CPUNOGRP, &CPUNoGrp);
    table->Get(INI_BS_DAMAGEWAIT, &DamageWaitFix);
    table->Get(INI_BS_LOOKUPWAIT, &LookUpWaitFix);
    table->Get(INI_BS_CPUWAIT, &CPUWaitFix);
    table->Get(INI_BS_IGNORELIFE, &IgnoreLife);
    //[֌W
    table->Get(INI_BS_MAILUSER, MailUser.Name);
    table->Get(INI_BS_ADDRESS, MailUser.Address);
    table->Get(INI_BS_REPLY, MailUser.ReplyAddress);
    table->Get(INI_BS_POPSERVER, MailUser.POPServer);
    table->Get(INI_BS_POPUSER, MailUser.POPUser);
    table->Get(INI_BS_POPPASS, MailUser.POPPass);
    table->Get(INI_BS_SMTPSERVER, MailUser.SMTPServer);
    table->Get(INI_BS_SMTPUSER, MailUser.SMTPUser);
    table->Get(INI_BS_SAVEMES, &MailUser.SaveMessage);

    table->GetCategory(INI_CTG_WINDOW_GBW);
    LoadWindowState(table,&WindowState_gbw);
    table->GetCategory(INI_CTG_WINDOW_GBWEDIT);
    LoadWindowState(table,&WindowState_gbwedit);
    table->GetCategory(INI_CTG_WINDOW_GBWUNIT);
    LoadWindowState(table,&WindowState_gbwunit);
    delete table;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TGBWOption::SaveWindowState(TDataTable *table,TGBWWindowState *ws)
{
    table->Put(INI_KEY_VALID, ws->Valid);
    table->Put(INI_KEY_LASTX, ws->X);
    table->Put(INI_KEY_LASTY, ws->Y);
    table->Put(INI_KEY_LASTW, ws->Width);
    table->Put(INI_KEY_LASTH, ws->Height);
    table->Put(INI_KEY_STATE, ws->State);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TGBWOption::LoadWindowState(TDataTable *table,TGBWWindowState *ws)
{
    table->Get(INI_KEY_VALID, &ws->Valid);
    table->Get(INI_KEY_LASTX, &ws->X);
    table->Get(INI_KEY_LASTY, &ws->Y);
    table->Get(INI_KEY_LASTW, &ws->Width);
    table->Get(INI_KEY_LASTH, &ws->Height);
    table->Get(INI_KEY_STATE, &ws->State);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TGBWOption::SetWindowState(TGBWWindowState *ws,TForm *form)
{
    ws->Valid = true;
    ws->X = form->Left;
    ws->Y = form->Top;
    ws->Width  = form->Width;
    ws->Height = form->Height;
    ws->State  = form->WindowState;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TGBWOption::GetWindowState(TGBWWindowState *ws,TForm *form)
{
    if(!ws->Valid)
        return -1;
    form->Left   = ws->X;
    form->Top    = ws->Y;
    form->Width  = ws->Width;
    form->Height = ws->Height;
    form->WindowState = (TWindowState)ws->State;
    return 0;
}
//---------------------------------------------------------------------------
//wNXg[Xp萔Bオn_Ŏv
const int FieldScreen::NextDX[2][6]={{0,1,1,1,0,-1},{-1,0,1,0,-1,-1}},
          FieldScreen::NextDY[6]={-1,-1,0,1,1,0};
//---------------------------------------------------------------------------
//rbg}bv̑傫߁AœhԂ
__fastcall FieldScreen::Initialize(int w,int h)
{
    Width=w;
    Height=h;
    BitmapWidth = w*GraphDegree+GraphDegree/2;
    BitmapHeight = h*GraphDegree;
    if(Bitmap != NULL){
        Bitmap->Width = BitmapWidth;
        Bitmap->Height = BitmapHeight;
    }
    Canvasp->Brush->Color=clBlack;
    Canvasp->FillRect(Rect(0,0,BitmapWidth,BitmapHeight));
    RangeLimit=false;
    MakeNeighborList();
    GetNeighborRect();
    return 0;
}
//---------------------------------------------------------------------------
//ߖT̓_̑΍WXgB
__fastcall FieldScreen::MakeNeighborList(void)
{
    int i,mode,radius,index_from,index_current;

    for(mode=0;mode<2;mode++){
        NeighborX[mode][0] = 0;
        NeighborY[mode][0] = mode;
        NeighborIndex[0] = 0;
        NeighborIndex[1] = 1;
        index_from = 0;
        index_current = 1;
        for(radius=1;radius<NEIGHBOR_MAX;radius++){
            for(i=NeighborIndex[radius-1];i<NeighborIndex[radius];i++){
                index_current = GenerateNeighborList(mode,index_from,index_current,NeighborX[mode][i],NeighborY[mode][i]);
            }
            NeighborIndex[radius+1] = index_current;
            index_from = NeighborIndex[radius-1];
        }
    }
    //SW͕̎֋X(0,1)̋ߖT̍W߁A
    //yW1ďCB
    for(i=0;i<index_current;i++){
        NeighborY[1][i]--;
    }
    /*
    for(i=0;i<index_current;i++){
        char str[32];
        sprintf(str,"%d,%d",NeighborX[0][i],NeighborY[0][i]);
        ShowMessage(str);

    } */
    /*
    //dWĂȂׂB
    int index;
    mode = 0;
    for(i=0;i<index_current;i++){
        //܂ڂ̍WTB
        index = GetNeighborIndex(mode,NeighborX[mode][i],NeighborY[mode][i],
                                 0,index_current);
        //͌͂B
        if(index == -1){
            ShowMessage("foolish!");
            break;
        }
        //ڂTČꍇAdW݂B
        index = GetNeighborIndex(mode,NeighborX[mode][i],NeighborY[mode][i],
                                 index+1,index_current);
        if(index != -1){
            char str[32];
            sprintf(str,"ERROR:multiple location(%d,%d)%d",NeighborX[mode][i],NeighborY[mode][i],index);
            ShowMessage(str);
        }
    }
    */
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::GenerateNeighborList(int mode,int index_from,int index_current,int center_x,int center_y)
{
    int i,x,y,odd;

    odd = (center_y >= 0 ? center_y : -center_y)%2;
    for(i=0;i<6;i++){
        //w肳ꂽW̎͂̍WɂāA
        x = center_x + NextDX[odd][i];
        y = center_y + NextDY[i];
        //܂XgɓĂȂWȂ烊XgɉB
        if(GetNeighborIndex(mode,x,y,index_from,index_current) == -1){
            NeighborX[mode][index_current] = x;
            NeighborY[mode][index_current] = y;
            index_current++;
            if(index_current >= 2048){
                ShowMessage("over flow");
                return 0;
            }
        }
    }
    return index_current;
}
//---------------------------------------------------------------------------
//index_from index_to-1 ͈̔͂Ŏw肳ꂽWXgTB
//߂l͌΂̃CfbNXAȂ-1
//mode ͍ŏ̒ŜxW̎1,̎0
__fastcall FieldScreen::GetNeighborIndex(int mode,int x,int y,int index_from,int index_to)
{
    for(int i=index_from;i<index_to;i++){
        if(x==NeighborX[mode][i] && y==NeighborY[mode][i])
            return i;
    }
    return -1;
}
//---------------------------------------------------------------------------
//ߖTWɑ΂ĕ`sA̕`̈܂ދ`̃XgB
__fastcall FieldScreen::GetNeighborRect(void)
{
    int radius,x1,y1,x2,y2;

    for(radius=0;radius<NEIGHBOR_MAX;radius++){
        x1 = y1 = -radius*GRAPHDEGREE_S;
        x2 = y2 = (radius+1)*GRAPHDEGREE_S;
        NeighborRect[radius] = Rect(x1,y1,x2,y2);
    }
#if 0
    int i,radius,px,py;

    for(radius=0;radius<NEIGHBOR_MAX;radius++){
        TRect *r = &NeighborRect[radius];
        *r = Rect(0,0,0,0);
        for(i=NeighborIndex[radius];i<NeighborIndex[radius+1];i++){
            XY_MapToPhy(NeighborX[0][i],NeighborY[0][i],&px,&py);
            px -= GRAPHDEGREE_N/2;
            GetOrRect(r,px,py,GRAPHDEGREE_N,GRAPHDEGREE_N);
        }
        /*
        char str[64];
        sprintf(str,"%d:%d(%d,%d,%d,%d)",radius,NeighborIndex[radius],r->Left,r->Top,r->Right,r->Bottom);
        ShowMessage(str);
        */
    }
#endif
    return 0;
}
//---------------------------------------------------------------------------
//(x,y)𒆐SƂ锼ar1`r2͈̔͂̋ߖTW̃Xg𓾂B
//length ̓Xg̍ő咷A߂l̓Xg̒B
__fastcall FieldScreen::GetNeighborList(int cx,int cy,int r1,int r2,int w,int h,POINT *list,int length)
{
    int i,x,y,count=0,mode=cy%2;
    int *dX = NeighborX[mode];
    int *dY = NeighborY[mode];

    if(r2 > NEIGHBOR_MAX)
        r2 = NEIGHBOR_MAX;
    for(i=NeighborIndex[r1]; i<NeighborIndex[r2]; i++){
        x = cx + dX[i];
        y = cy + dY[i];
        if(x<0 || x>=w || y<0 || y>=h)
            continue;
        list[count].x = x;
        list[count].y = y;
        count++;
        if(count >= length)
            break;
    }
    return count;
}
//---------------------------------------------------------------------------
//(x,y)(cx,cy)甼aradiusȓɂ邩BႦradius=1ȂׁB
__fastcall FieldScreen::IsNeighbor(int x,int y,int cx,int cy,int radius)
{
    int i,mode=cy%2;
    int *listX = NeighborX[mode];
    int *listY = NeighborY[mode];

    for(i=NeighborIndex[0]; i<NeighborIndex[radius+1]; i++){
        if(cx+listX[i]==x && cy+listY[i]==y)
            return 1;
    }
    return 0;
}
//---------------------------------------------------------------------------
//gpImageList߂
__fastcall FieldScreen::DefineImageList(GBWImageData *GBWImagep,int Mode)
{
    switch(Mode){
    case 0:   //WTCY
        ImageList_Map   =GBWImagep->ImageList_MapN;
        ImageList_Unit  =GBWImagep->ImageList_UnitN;
        ImageList_Cursor=GBWImagep->ImageList_CursorN;
        ImageList_Figure=GBWImagep->ImageList_FigureN;
        GraphDegree=GRAPHDEGREE_N;
        break;
    case 1:   //kTCY
        ImageList_Map   =GBWImagep->ImageList_MapS;
        ImageList_Unit  =GBWImagep->ImageList_UnitS;
        ImageList_Cursor=GBWImagep->ImageList_CursorS;
        ImageList_Figure=GBWImagep->ImageList_FigureS;
        GraphDegree=GRAPHDEGREE_S;
        break;
    }
    ImageList_UnitN = GBWImagep->ImageList_UnitN;
    ImageList_MapN = GBWImagep->ImageList_MapN;
    return 0;
}
//---------------------------------------------------------------------------
//ȉꍇForm1->Image1́jOLoXɕ`悷邩
//kw肷Γrbg}bvɕ`
__fastcall FieldScreen::FastDrawMode(TCanvas *Cp)
{
    if(Cp!=NULL)
        Canvasp=Cp;
    else
        Canvasp=Bitmap->Canvas;
    return 0;
}
//---------------------------------------------------------------------------
//}bv̒n`ւĂɕ`悷
__fastcall FieldScreen::MapChipSet(MapData *Mapp,int zx,int zy,int Index)
{
    int x,y;

    Mapp->Data[zx][zy].Graph=(char)Index;
    XY_MapToPhy(zx,zy,&x,&y);
    MapChipPut(x,y,Mapp->Data[zx][zy].Graph);
    return 0;
}
//---------------------------------------------------------------------------

__fastcall FieldScreen::MapChipGet(MapData *Mapp,int zx,int zy)
{
    return Mapp->Data[zx][zy].Graph;
}
//---------------------------------------------------------------------------
//}bvŜ`B
__fastcall FieldScreen::DrawMap(MapData *Mapp,bool Sakuteki)
{
    int x,y,px,py;

    //e
    memset(Mapp->Shade[0],0,MAPWIDTHMAX*MAPHEIGHTMAX*sizeof(bool));
    for(y=0;y<Height;y++)
        for(x=0;x<Width;x++){
            XY_MapToPhy(x,y,&px,&py);
            if(Sakuteki && !Mapp->Visible[x][y]){
                DrawMapChipShade(px,py,Mapp->Data[x][y].Graph);
                Mapp->Shade[x][y] = true;
            }
            else
                MapChipPut(px,py,Mapp->Data[x][y].Graph);
        }
    return 0;
}
//---------------------------------------------------------------------------
//n`PP`iW̎wj
__fastcall FieldScreen::MapChipPut(int x,int y,int Index)
{
    ImageList_Map->Draw(Canvasp,x,y,Index);
    return 0;
}
//---------------------------------------------------------------------------
//n`PP`i_W̎wj
__fastcall FieldScreen::MapChipPutZ(MapData *Mapp,int zx,int zy)
{
    int x,y,Index;

    Index = Mapp->Data[zx][zy].Graph;
    XY_MapToPhy(zx,zy,&x,&y);
    MapChipPut(x,y,Index);
    return 0;
}
//---------------------------------------------------------------------------
//etĒn`PP`iW̎wj
__fastcall FieldScreen::DrawMapChipShade(int x,int y,int Index)
{
    ImageList_Map->Draw(Canvasp,x,y,Index);
    ImageList_Cursor->Draw(Canvasp,x,y,CURSOR_DARK);
    return 0;
}
//---------------------------------------------------------------------------
//n`PP`i_W̎wj
//Shade=trueȂetB
__fastcall FieldScreen::DrawMapChipShadeZ(MapData *Mapp,int zx,int zy)
{
    int x,y,Index;

    Index = Mapp->Data[zx][zy].Graph;
    XY_MapToPhy(zx,zy,&x,&y);
    if(Mapp->Shade[zx][zy])
        DrawMapChipShade(x,y,Index);
    else
        MapChipPut(x,y,Index);
    return 0;
}
//---------------------------------------------------------------------------
//̐wĉ݂̑Sjbg`Bi[h͂QĂяoKvLj
__fastcall FieldScreen::DrawAllUnit(MapData *Mapp,SideStatus *SideStatusp,bool Tekisaku)
{
    int i,zx,zy,x,y;

    for(i=0;i<SideStatusp->UnitCount;i++){
        zx = SideStatusp->Unit[i].X;
        zy = SideStatusp->Unit[i].Y;
        if(zx == -1)
            continue;
        if(Tekisaku && Mapp->Shade[zx][zy]){
            XY_MapToPhy(zx,zy,&x,&y);
            DrawMapChipShade(x,y,Mapp->Data[zx][zy].Graph);
            continue;
        }
        XY_MapToPhy(zx,zy,&x,&y);
        MapChipPut(x,y,Mapp->Data[zx][zy].Graph);
        UnitPut(x,y,SideStatusp->Unit[i].Graph);
        if(SideStatusp->Unit[i].Load)
            CursorPut(x,y,CURSOR_LOAD);
        if(SideStatusp->Unit[i].Actioned)
            CursorPut(x,y,CURSOR_END);
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbgP`iW̎wj
__fastcall FieldScreen::UnitPut(int x,int y,int Index)
{
    ImageList_Unit->Draw(Canvasp,x,y,Index);
    return 0;
}
//---------------------------------------------------------------------------
//jbgP`i_W̎wj
__fastcall FieldScreen::UnitPutZ(int zx,int zy,int Index)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    UnitPut(x,y,Index);
    return 0;
}
//---------------------------------------------------------------------------
//jbg`iʂɕ`Bڃ}[Ntj
__fastcall FieldScreen::UnitPutAuto(MapData *Mapp,SideStatus *Sidep,int zx,int zy,bool ActionPut)
{
    int x,y,Num,gnd;

    Num=Mapp->Data[zx][zy].Unit;
    gnd=Mapp->Data[zx][zy].Graph;
    XY_MapToPhy(zx,zy,&x,&y);
    MapChipPut(x,y,gnd);
    UnitPut(x,y,Sidep->Unit[Num].Graph);
    if(Sidep->Unit[Num].Load)
        CursorPut(x,y,CURSOR_LOAD);
    if(ActionPut && Sidep->Unit[Num].Actioned)
        CursorPut(x,y,CURSOR_END);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::DrawUnitWithStatus(int zx,int zy,int graph,bool load,bool actioned)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    UnitPut(x,y,graph);
    if(load)
        CursorPut(x,y,CURSOR_LOAD);
    if(actioned)
        CursorPut(x,y,CURSOR_END);
    return 0;
}
//---------------------------------------------------------------------------
//J[\P`iW̎wj
__fastcall FieldScreen::CursorPut(int x,int y,int index)
{
    ImageList_Cursor->Draw(Canvasp,x,y,index);
    return 0;
}
//---------------------------------------------------------------------------
//J[\P`i_W̎wj
__fastcall FieldScreen::CursorPutZ(int zx,int zy,int index)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    CursorPut(x,y,index);
    return 0;
}
//---------------------------------------------------------------------------
//J[\KwNX`i_W̎wj
__fastcall FieldScreen::DrawCursorMegaHex(int zx,int zy,int cursor,int r1,int r2)
{
    TRect rect;
    int x,y,i,index1,index2,mode;

    XY_MapToPhy(zx,zy,&x,&y);
    rect = NeighborRect[r2];
    int size = GraphDegree/GRAPHDEGREE_S;
    rect.Left *= size;
    rect.Right *= size;
    rect.Top *= size;
    rect.Bottom *= size;
    rect.Left += x;
    rect.Right += x;
    rect.Top += y;
    rect.Bottom += y;
    BackupBitmap(rect,BKUP_MEGAHEX);
    index1 = NeighborIndex[r1];
    index2 = NeighborIndex[r2];
    mode = zy%2;
    for(i=index1;i<index2;i++){
        XY_MapToPhy(zx+NeighborX[mode][i],zy+NeighborY[mode][i],&x,&y);
        CursorPut(x,y,cursor);
    }
    return 0;
}
//---------------------------------------------------------------------------
//P`iW̎wj
__fastcall FieldScreen::FigurePut(int x,int y,int Index,int Color)
{
    ImageList_Figure->Draw(Canvasp,x,y,Index+Color*FIGURECOUNT);
    return 0;
}
//---------------------------------------------------------------------------
//l`iW̎wj100ȏ͑S100\
__fastcall FieldScreen::ValuePut(int x,int y,int Value,int Color)
{
    int Index[2]={10,11};

    if(Value<100){
        Index[0]=(Value%100)/10;
        Index[1]=Value%10;
    }
    if(Index[0])
        FigurePut(x,y,Index[0],Color);
    FigurePut(x+GraphDegree/2,y,Index[1],Color);
    return 0;
}
//---------------------------------------------------------------------------
//l`i_W̎wj
__fastcall FieldScreen::ValuePutZ(int zx,int zy,int Value,int Color)
{
    int x,y;

    XY_MapToPhy(zx,zy,&x,&y);
    ValuePut(x,y,Value,Color);
    return 0;
}
//---------------------------------------------------------------------------
// w肵 TCanvas ɒn`Xe[^X`悷B
__fastcall FieldScreen::DrawGroundStatusToTCanvas(TCanvas *canvas,
    TColor backcolor,int x,int y,MapStatus *gndp,MapChip *gndInfop)
{
    char str[64];
    TColor front,back;

    canvas->Font->Pitch = fpFixed;
    canvas->Brush->Color = backcolor;
    canvas->FillRect(canvas->ClipRect);

    ImageList_MapN->Draw(canvas,x,y,gndp->Graph);

    canvas->TextOut(x+40,y+4, gndInfop->Name); // 
    sprintf(str,"n` %2d%%",gndInfop->Shield);
    canvas->TextOut(x+40,y+20,str);

    if(gndp->IsBuilding()){
        if(gndp->Life < gndp->LifeMax/3){
            canvas->Font->Color = clRed;
            back = clPurple;
            front = clRed;
        }else{
            canvas->Font->Color = clWindowText;
            back = clOlive;
            front = clBlue;
        }
        sprintf(str, "Life %3d/%3d", gndp->Life, gndp->LifeMax);
        canvas->TextOut(x+4,y+36,str);
        DrawGage(canvas,x+72,y+36,48,12,
                 gndp->Life, gndp->LifeMax, front,back);
    }
    return 0;
}
//---------------------------------------------------------------------------
// w肵 TCanvas ɃjbgXe[^X`悷B
__fastcall FieldScreen::DrawUnitStatusToTCanvas(TCanvas *canvas,
    TColor backcolor,int x,int y,UnitStatus *unitp,UnitChip *unitInfop)
{
    char str[64];
    TColor front,back;

    canvas->Font->Pitch = fpFixed;
    canvas->Brush->Color = backcolor;
    canvas->FillRect(canvas->ClipRect);

    ImageList_UnitN->Draw(canvas,x,y,unitp->Graph);

    canvas->TextOut(x+40,y+4, unitInfop->Name); // 

    sprintf(str,"ړ %1d",unitInfop->MoveMax);
    canvas->TextOut(x+40,y+20,str);      // ړ

    // Ct
    // `F߂镔璷B
    // ɃQ[W悤Ȃ狤ʉlB
    const int lifemax = 100;
    if(unitp->Life < lifemax/3){
        canvas->Font->Color = clRed;
        back = clPurple;
        front = clRed;
    }else{
        canvas->Font->Color = clWindowText;
        back = clOlive;
        front = clBlue;
    }
    sprintf(str,"Life %3d/%3d",unitp->Life,lifemax);
    canvas->TextOut(x+4,y+40,str);
    DrawGage(canvas,x+72,y+40,48,12,unitp->Life,lifemax,front,back);

    // R
    if(unitp->Fuel < unitInfop->FuelMax/3){
        canvas->Font->Color = clRed;
        back = clPurple;
        front = clRed;
    }else{
        canvas->Font->Color = clWindowText;
        back = clGreen;
        front = clBlue;
    }
    sprintf(str,"R %3d/%3d",unitp->Fuel,unitInfop->FuelMax);
    canvas->TextOut(x+4,y+56,str);
    DrawGage(canvas,x+72,y+56,48,12,unitp->Fuel,unitInfop->FuelMax,front,back);

    // ΊEe
    y += 72;
    // \ȃXy[XΏȗB
    // ܂ȗȂcB
    if(canvas->ClipRect.Bottom < y+64)
        return 0;

    char s[32];
    for(int i=0;i<2;i++){
        if(!unitInfop->GunMax[i])
            continue;
        canvas->TextOut(x+4,y,unitInfop->GunName[i]);
        sprintf(str,"%d/%d", unitp->GunRest[i], unitInfop->GunMax[i]);
        canvas->TextOut(x+4+88,y,str);

        RangeToText(s,unitInfop->MinRange[i],unitInfop->MaxRange[i],
                    unitInfop->Radius[i]);
        sprintf(str,"˒ %s", s);
        canvas->TextOut(x+4,y+15,str);
        y += 32;
    }

    return 0;
}
//---------------------------------------------------------------------------
__fastcall FieldScreen::RangeToText(char *str,int minr,int maxr,int radius)
{
    char s[16];

    if(minr != maxr){
        sprintf(str,"%d-%d ",minr,maxr);
    }else{
        sprintf(str,"%d    ",minr);
    }

    if(radius > 1){
        sprintf(s,"[%d]",radius);
        strcat(str,s);
    }
    return 0;
}
//---------------------------------------------------------------------------
// Q[WBLife̎o\ɗpB
// TCanvas::Brush̒l͕ێB
__fastcall FieldScreen::DrawGage(TCanvas *canvas,int x,int y,int w,int h,
    int level,int maxlevel,TColor frontcolor,TColor backcolor)
{
    if(!maxlevel)
        return -1;
    TColor color = canvas->Brush->Color;
    // w
    canvas->Brush->Color = backcolor;
    canvas->FillRect(Rect(x,y,x+w,y+h));
    // o[
    w = level*w/maxlevel;
    canvas->Brush->Color = frontcolor;
    canvas->FillRect(Rect(x+1,y+1,x+w-1,y+h-1));
    canvas->Brush->Color = color;
    return 0;
}
//---------------------------------------------------------------------------
// w肳ꂽ̈obNAbvB
// obNAbvrbg}bṽCfbNXw肷B
__fastcall FieldScreen::BackupBitmap(TRect r,int index)
{
    int w,h;
    Graphics::TBitmap *back = BitmapBackup[index];

    back->Width  = w = r.Right-r.Left;
    back->Height = h = r.Bottom-r.Top;
    BackupRect[index] = r;
    back->Canvas->CopyRect(Rect(0,0,w,h),Canvasp,BackupRect[index]);
    Backuped[index] = true;
    return 0;
}
//---------------------------------------------------------------------------
// obNAbve߂B
__fastcall FieldScreen::RestoreBitmap(int index)
{
    Graphics::TBitmap *back = BitmapBackup[index];
    if(Backuped[index])
        Canvasp->CopyRect(BackupRect[index],back->Canvas,Rect(0,0,back->Width,back->Height));
    return 0;
}
//---------------------------------------------------------------------------
// ߂ɃobNAbvtONAB
__fastcall FieldScreen::RestoreBitmapOnce(int index)
{
    RestoreBitmap(index);
    Backuped[index] = false;
    return 0;
}
//---------------------------------------------------------------------------
// _W->W
__fastcall FieldScreen::XY_MapToPhy(int MapX,int MapY,int *PhyX,int *PhyY)
{
    /*if(MapX<0){
        ShowMessage("Error:Map-XY mismatch");
        return -1;
    }*/
    *PhyX=MapX*GraphDegree;
    if(!(MapY%2))
        *PhyX+=GraphDegree/2;
    *PhyY=MapY*GraphDegree;
    return 0;
}
//---------------------------------------------------------------------------
//i}EXJ[\́jW->_W
__fastcall FieldScreen::XY_PhyToMap(MapData *Mapp,int PhyX,int PhyY,int *MapX,int *MapY)
{
    *MapY=PhyY/GraphDegree;
    if(!(*MapY%2))
        PhyX-=GraphDegree/2;
    *MapX=PhyX/GraphDegree;
    if(*MapX<0)
        *MapX=0;
    if(Mapp->Width<=*MapX)
        *MapX=Mapp->Width-1;
    if(*MapY<0)
        *MapY=0;
    if(Mapp->Height<=*MapY)
        *MapY=Mapp->Height-1;
    return 0;
}
//---------------------------------------------------------------------------
// ړ͈͂̒iʏj
__fastcall FieldScreen::MoveRangeSearch(MapData *Mapp,BaseData *BaseDatap,UnitStatus *Unitp,int Side,int zx,int zy)
{
    Mapp->InitRange();
    RangeSearch(Mapp,BaseDatap,Unitp,Side,zx,zy,false);
    return 0;
}
//---------------------------------------------------------------------------
// ړ͈͂̒i~ԁjRangePoint̏͂Ȃ
//͓ڂẴjbg
__fastcall FieldScreen::LoadRangeSearch(MapData *Mapp,BaseData *BaseDatap,UnitStatus *Unitp,int Side,int zx,int zy)
{
    int i;

    for(i=0;i<Unitp->Load;i++)
        RangeSearch(Mapp,BaseDatap,&SideStatusp[Side]->Unit[Unitp->LoadingUnit[i]],Side,zx,zy,true);
    Mapp->RangePoint[zx][zy]=0; //gɓځEU͂łȂ̂
    return 0;
}
//---------------------------------------------------------------------------
// ړ͈͂̒iڂ͌ĂяoȂj
// Mode=false:ʏ true:~Ԏiړ͂Pj
__fastcall FieldScreen::RangeSearch(MapData *Mapp,BaseData *BaseDatap,
                                    UnitStatus *Unitp,int Side,int zx,int zy,bool Mode)
{
    UnitStatus *TmpUnitp;
    UnitChip *UnitInfop;
    MapStatus *ground;
    int x,y,p,*range;

    if(zx<0){
        ShowMessage("Error:Wrong Range");
        return -1;
    }
    if(!Mode)
        p=min(Unitp->Fuel+1,BaseDatap->UnitInfo[Unitp->Type].MoveMax+1);
    else
        p=2;
    Mapp->RangePoint[zx][zy]=p;
    RangeTrace(Mapp,BaseDatap,SideStatusp[!Side],Side,zx,zy,Unitp->Type,1);
        //ړɑ̃jbgꍇ̎𒲂ׂB
        //AE̊OȂ疳B
    for(y=0;y<Mapp->Height;y++)
        for(x=0;x<Mapp->Width;x++){
            range = &Mapp->RangePoint[x][y];
            if(!(*range) || !Mapp->Visible[x][y])
                continue;
            ground = &Mapp->Data[x][y];
            if(ground->Side == -1)
                continue;
            if(ground->Side==Side){
                //~Ԃ鎞͍ڂłȂB
                if(Mode){
                    *range = 0;
                    continue;
                }
                TmpUnitp = &SideStatusp[Side]->Unit[ground->Unit];
                UnitInfop = &BaseDatap->UnitInfo[TmpUnitp->Type];
                //ނ̃jbg͓ڂłȂB
                if(Unitp->Type != TmpUnitp->Type){
                    //ڏ̔B
                    if(!UnitInfop->CanLoadOn[ground->Graph] ||
                       !UnitInfop->LoadUnit[Unitp->Type] ||
                       TmpUnitp->Load>=UnitInfop->Loadable)
                        *range = 0;
                }
                else{
                    if(Unitp->Load || TmpUnitp->Load || Unitp->Life+TmpUnitp->Life>100)
                        *range = 0;
                    //̏F~Ԃł͂ȂBǂƂڂĂȂB
                    //Ct̍vPOOȉB
                }
            }
            else{
                //Gjbg鏊ɂ͈ړłȂB
                //A~Ԏ͍Uׂ͈͂׃NAȂB
                if(!Mode)
                    *range = 0;
            }
        }
    Mapp->RangePoint[zx][zy]=p;

    return 0;
}
//---------------------------------------------------------------------------
//UE⋋͈͂̒B⋋͈͂̒Sidew̒lɂB
//SideStatusp͍UłȂB
//ĂȂ NoMove=trueƂ
//̒Ȃ Counter=trueƂ
__fastcall FieldScreen::AttackRangeSearch(MapData *Mapp,BaseData *BaseDatap,UnitStatus *Unitp,SideStatus *SideStatusp,int zx,int zy,bool NoMove,bool Counter)
{
    int maxr,sp;
    UnitChip *UnitInfop;

    UnitInfop = &BaseDatap->UnitInfo[Unitp->Type];
    Mapp->InitRange();
    if(zx==-1)   //ԏԂł͍UłȂׁB
        return 0;
    if(!UnitInfop->GunMax[0] && !UnitInfop->GunMax[1])
        return 0;
    maxr = max(UnitInfop->MaxRange[0],UnitInfop->MaxRange[1]);
    //ԐڍUł͓̂ȂBX[p[~TC͗O
    if(NoMove || UnitInfop->SuperMissile)
        sp=maxr+1;
    else
        sp=2;
    Mapp->RangePoint[zx][zy]=sp;
    RangeTrace(Mapp,BaseDatap,NULL,-1,zx,zy,UT_MIGHTYSEARCH,1);
    Mapp->RangePoint[zx][zy]=0;
    //X[p[~TCȊOȂU\ΏۂIB
    if(!UnitInfop->SuperMissile)
        AttackRangeSelect(Mapp,BaseDatap,Unitp,SideStatusp,sp,Counter);
    return 0;
}
//---------------------------------------------------------------------------
//˒͈͂̒BAttackRangeSearch̊ȈՔŁB
//e͂̂ƂBɍŒ`ő˒𒲂ׂB
//˒͈͕\̂߂ɂ֐Ap~B
//p~ȐڍׂFixAttackRange()̃RgQƁB
__fastcall FieldScreen::FindAttackRange(MapData *Mapp,BaseData *BaseDatap,UnitStatus *Unitp)
{
    int maxr;
    UnitChip *UnitInfop;

    UnitInfop = &BaseDatap->UnitInfo[Unitp->Type];
    maxr = max(UnitInfop->MaxRange[0],UnitInfop->MaxRange[1]);
    Mapp->InitRange();
    Mapp->RangePoint[Unitp->X][Unitp->Y]=maxr+1;
    RangeTrace(Mapp,BaseDatap,NULL,-1,Unitp->X,Unitp->Y,UT_MIGHTYSEARCH,1);
    Mapp->RangePoint[Unitp->X][Unitp->Y]=0;
    FixAttackRange(Mapp,BaseDatap,Unitp,maxr+1);
    return 0;
}
//---------------------------------------------------------------------------
//KwNXUΊ̎˒͈͂𒲂ׂBFindAttackRange()̒PΊŁB
//side != -1 ȂAU\Gjbgn_݂̂Ɏ˒i\B
__fastcall FieldScreen::FindSingleAttackRange(MapData *Mapp,BaseData *BaseDatap,
    UnitStatus *unitp,int cx,int cy,int gunIndex,int side)
{
    int maxr,minr;
    UnitChip *unitInfop;

    unitInfop = &BaseDatap->UnitInfo[unitp->Type];
    maxr = unitInfop->MaxRange[gunIndex];
    minr = unitInfop->MinRange[gunIndex];
    Mapp->InitRange();
#if 1
    Mapp->RangePoint[cx][cy] = maxr+1;
    RangeTrace(Mapp,BaseDatap,NULL,-1,cx,cy,UT_MIGHTYSEARCH,1);
    Mapp->RangePoint[cx][cy] = 0;
    FixSingleAttackRange(Mapp,maxr+1,maxr,minr);
#else
    MapStatus *gnd;
    POINT list[1024];
    int x,y,count;
    count = GetNeighborList(cx,cy,minr,maxr,list,1024);
    for(i=0;i<count;i++){
        x = list[i].X;
        y = list[i].Y;
        gnd = &Mapp->Data[x][y];
        if(gnd->Side != side){

        }
        Mapp->RangePoint[x][y] = 1;
    }
#endif
    return 0;
}
//---------------------------------------------------------------------------
//⋋͈͂̒B
//e⋋jbg̎͂ŁA⋋\ȃjbg鏊͑Să`FbNB
//RangePoint̒l= 0:⋋Ȃ  1:⋋  2:R̂ݕ⋋
__fastcall FieldScreen::FindSupplyRange(MapData *Mapp,BaseData *BaseDatap,SideStatus *Sidep)
{
    UnitChip *UnitInfop;
    UnitStatus *Unitp;
    int x,y,num,i,u,t;

    Mapp->InitRange();
    for(num=0;num<Sidep->UnitCount;num++){ //⋋jbgׂ̗𒲂ׂ
        Unitp = &Sidep->Unit[num];
        UnitInfop = &BaseDatap->UnitInfo[Unitp->Type];
        if(!UnitInfop->SupplySurround) //͕⋋\͂H
            continue;
        for(i=0;i<6;i++){
            x = Unitp->X + NextDX[Unitp->Y%2][i];
            y = Unitp->Y + NextDY[i];
            if(Mapp->Data[x][y].Side == Sidep->Side){
                u = Mapp->Data[x][y].Unit;
                t = Sidep->Unit[u].Type;
                //⋋\ȃjbgH
                if(UnitInfop->SupplyUnit[t]){
                    if(UnitInfop->OnlyFuel)
                        Mapp->RangePoint[x][y]=2;
                    else
                        Mapp->RangePoint[x][y]=1;
                }
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//vl[`E⋋͈͒pBRangePoint̏͂ȂB
//^ꂽ^Cṽg[XŔCӂ͈̔͂𒲍B
//StepȂRangePointB
//Mode=trueȂψStep̃|CgZBȉꍇRangeTraceStep1j
__fastcall FieldScreen::ExtraRangeSearch(MapData *Mapp,BaseData *BaseDatap,
    int zx,int zy,int Length,int TraceType,int Step,bool Mode)
{
    MapData *TmpMap=new MapData();
    int x,y,a=1;

    if(Step<0){
        a=-1;
        Step=-Step;
    }
    *TmpMap=*Mapp;
    TmpMap->InitRange();
    TmpMap->RangePoint[zx][zy]=Length;
    if(Mode)
        RangeTrace(TmpMap,BaseDatap,NULL,-1,zx,zy,TraceType,1);
    else
        RangeTrace(TmpMap,BaseDatap,NULL,-1,zx,zy,TraceType,Step);
    if(Mode){
        Step*=a;
        for(y=0;y<Mapp->Height;y++)
            for(x=0;x<Mapp->Width;x++)
                Mapp->RangePoint[x][y] += Step*(TmpMap->RangePoint[x][y]!=0);
    }
    else{
        for(y=0;y<Mapp->Height;y++)
            for(x=0;x<Mapp->Width;x++)
                Mapp->RangePoint[x][y] += a*TmpMap->RangePoint[x][y];
    }
    delete TmpMap;
    return 0;
}
//---------------------------------------------------------------------------
//Side=-1ȊOł͈ړ͈͂̒s
//StepRangePoinťWBbot[`p
//EnemySidepZOCpBSide=-1͎̎gȂ
__fastcall FieldScreen::RangeTrace(MapData *Mapp,BaseData *BaseDatap,
    SideStatus *EnemySidep,int Side,int zx,int zy,int UnitType,int Step)
{
    int x,y,i,power,consume;
    int groundType;
    bool currentCE;
    UnitChip *UnitInfop;

    UnitInfop = &BaseDatap->UnitInfo[UnitType];
    power = Mapp->RangePoint[zx][zy];
    if(ZOCMode && Side!=-1) //ZOCL
        currentCE = CirculationEnemy(Mapp,BaseDatap,EnemySidep,zx,zy,Side,UnitType,false);
        //ݒn_œGאڂĂ邩
    for(i=0;i<6;i++){
        x = zx + NextDX[zy%2][i];
        y = zy + NextDY[i];
        if(x<0 || y<0 || x>=Mapp->Width || y>=Mapp->Height)
            continue;
            //-1łȂSidew莞AGjbg͒ʂȂ
            //AE̊OɂȂ疳
        if(Side!=-1 && Mapp->Visible[x][y])
            if(Mapp->Data[x][y].Side!=-1 && Side!=(int)Mapp->Data[x][y].Side)
                continue;
        groundType = Mapp->Data[x][y].Graph;
        if(!UnitInfop->MoveLost[groundType])
            continue; //lOȂg[XȂ

        consume = UnitInfop->MoveLost[groundType]*Step;
        if(ZOCMode && Side!=-1) //ZOCLȂړlς
            if(currentCE && (CirculationEnemy(Mapp,BaseDatap,EnemySidep,x,y,Side,UnitType,false) || power<UnitInfop->MoveMax+1))
                consume = max(consume,UnitInfop->MoveMax);

        if(power-consume > Mapp->RangePoint[x][y]){
            Mapp->RangePoint[x][y] = power-consume;
            Mapp->Back[x][y].x = zx;
            Mapp->Back[x][y].y = zy;
            RangeTrace(Mapp,BaseDatap,EnemySidep,Side,x,y,UnitType,Step);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//liThresholdj荂lNAiŒ˒jB
//܂AUi⋋j\ȓGijjbg݂ꍇȊO̓NAB
//StartPoint͎n_ɗ^liő˒{PAQjB
__fastcall FieldScreen::AttackRangeSelect(MapData *Mapp,BaseData *BaseDatap,
    UnitStatus *Unitp,SideStatus *SideStatusp,int StartPoint,bool Counter)
{
    int x,y,i,j,rp,*rpp,Threshold1[2],Threshold2[2],Type,Side;
    MapStatus *ground;
    UnitChip *UnitInfop;

    UnitInfop = &BaseDatap->UnitInfo[Unitp->Type];
    Side=!SideStatusp->Side;
//    Threshold=BaseDatap->UnitInfo[Unitp->Type].MaxRange+1-BaseDatap->UnitInfo[Unitp->Type].MinRange;
    //ꂼ̉Ί̂l
    Threshold1[0] = StartPoint-UnitInfop->MinRange[0];
    Threshold1[1] = StartPoint-UnitInfop->MinRange[1];
    Threshold2[0] = StartPoint-UnitInfop->MaxRange[0];
    Threshold2[1] = StartPoint-UnitInfop->MaxRange[1];
    for(y=0;y<Mapp->Height;y++)
        for(x=0;x<Mapp->Width;x++){
            rpp = &Mapp->RangePoint[x][y];
            if(!*rpp)
                continue;
            ground = &Mapp->Data[x][y];
            //GjbgȂȂ΂Ƃ΂
            if(!Mapp->Visible[x][y] ||
               ground->Side==-1 ||
               ground->Side==Side){
                *rpp = 0;
                continue;
            }
            //Ă镐ł̍U̗͂L
            //ꂼ̉ΊɂĎ˒𒲍
            rp = *rpp;
            *rpp = 0;
            for(i=0;i<2;i++){
                //̏ꍇAŒ˒1łȂ΂ȂȂiFԂyjB
                if(Counter && UnitInfop->MinRange[i]>1)
                    continue;
                //KwNXU̎˒͂ł͈ȂB
                if(UnitInfop->Radius[i] > 1)
                    continue;
                if(rp<=Threshold1[i] && rp>=Threshold2[i]){
                    if(Unitp->GunRest[i]){ //e̎c
                        Type = SideStatusp->Unit[ground->Unit].Type;
                        j = BaseDatap->UnitInfo[Unitp->Type].Attack[i][Type];
                        //RangePointɂǂ̉Ί킪g邩L^B
                        //Ԃɍ킹IȏȂ̂ŁAł̒lgꍇCKvB
                        if(j)
                            *rpp |= (1<<i);
                    }
                }
            }
        }
    return 0;
}
//---------------------------------------------------------------------------
//AttackRangeSelect̊ȈՔŁB˒\pB
//liThresholdj荂lNAiŒ˒jB
//StartPoint͎n_ɗ^liő˒{PjB
//SΊ̎˒̘a邽߂ɂ̌`ɂȂĂ邪AFixSingleAttackRange()݂̂
//ڍsi˒͈͕\UIύXjƂׂłB
__fastcall FieldScreen::FixAttackRange(MapData *Mapp,BaseData *BaseDatap,UnitStatus *Unitp,int StartPoint)
{
    UnitChip *UnitInfop;
    int x,y,i,rp,Threshold1[2],Threshold2[2];

    UnitInfop = &BaseDatap->UnitInfo[Unitp->Type];
    Threshold1[0] = StartPoint-UnitInfop->MinRange[0];
    Threshold1[1] = StartPoint-UnitInfop->MinRange[1];
    Threshold2[0] = StartPoint-UnitInfop->MaxRange[0];
    Threshold2[1] = StartPoint-UnitInfop->MaxRange[1];
    for(y=0;y<Mapp->Height;y++)
        for(x=0;x<Mapp->Width;x++){ //AttackRangeSelectƓ
            rp = Mapp->RangePoint[x][y];
            if(!rp)
                continue;
            Mapp->RangePoint[x][y]=0;
            for(i=0;i<2;i++)
                if(rp<=Threshold1[i] && rp>=Threshold2[i]){
                    Mapp->RangePoint[x][y]=1;
                    break;
                }
        }
    return 0;
}
//---------------------------------------------------------------------------
//PΊ̎˒ɂĎ˒͈͂CB
__fastcall FieldScreen::FixSingleAttackRange(MapData *Mapp,int startPoint,
    int maxr,int minr)
{
    int x,y,*rp,threshold1,threshold2;

    threshold1 = startPoint-minr;
    threshold2 = startPoint-maxr;
    for(y=0;y<Mapp->Height;y++)
        for(x=0;x<Mapp->Width;x++){ //AttackRangeSelectƓ
            rp = &Mapp->RangePoint[x][y];
            if(!*rp)
                continue;
            *rp = (*rp<=threshold1 && *rp>=threshold2);
        }
    return 0;
}
//---------------------------------------------------------------------------
//SẴjbg̎EBR̃jbg̎E_aB
// MapData::Visible ɂ̌ʂB
__fastcall FieldScreen::FindVisibleAll(MapData *Mapp,BaseData *BaseDatap,SideStatus *Sidep)
{
    UnitStatus *Unitp;
    UnitChip *UnitInfop;
    int i;

    //E
    Mapp->InitVisible(0);

    //R̃jbg̎Eg[X
    for(i=0;i<Sidep->UnitCount;i++){
        Unitp = &Sidep->Unit[i];
        if(Unitp->X != -1){
            UnitInfop = &BaseDatap->UnitInfo[Unitp->Type];
            FindVisible(Mapp,Unitp->X,Unitp->Y,UnitInfop->Visibility+1,1);
        }
    }

    return 0;
}
//---------------------------------------------------------------------------
//x,yɋ郆jbg̎E𒲍B
//E MapData::Visible  point ZB
__fastcall FieldScreen::FindVisible(MapData *Mapp,int x,int y,int range,int point)
{
    memset(Cost[0],0,MAPWIDTHMAX*MAPHEIGHTMAX*sizeof(int));
    TraceView(Mapp,x,y,range,point);
    return 0;
}
//---------------------------------------------------------------------------
//Ẽg[XB
//RangeTraceƓAg[XVisibleXV̂ŕʊ֐B
//E Visible  point B
//ĩjbg̎Edˍ킹āAa⍷邽߁j
__fastcall FieldScreen::TraceView(MapData *Mapp,int zx,int zy,int range,int point)
{
    int x,y,i;

    if(!Cost[zx][zy])
        Mapp->Visible[zx][zy] += point;
    Cost[zx][zy] = range;
    for(i=0;i<6;i++){
        x = zx+NextDX[zy%2][i];
        y = zy+NextDY[i];
        if(x<0 || y<0 || x>=Mapp->Width || y>=Mapp->Height)
            continue;

        if(range-1 > Cost[x][y])
            TraceView(Mapp,x,y,range-1,point);
    }
    return 0;
}
//---------------------------------------------------------------------------
//̎͂ɍU\ȓGjbg邩B 1,Ȃ 0
//͎̍WƏwcAjbg̎
//Vision=true:EO𖳎Ȃ false:
__fastcall FieldScreen::CirculationEnemy(MapData *Mapp,BaseData *BaseDatap,SideStatus *EnemySidep,int zx,int zy,int Side,int UnitType,bool Vision)
{
    int x,y,i;
    UnitStatus *EnemyUnitp;

    for(i=0;i<6;i++){
        x=zx+NextDX[zy%2][i];
        y=zy+NextDY[i];
        if(x<0 || y<0 || x>=Mapp->Width || y>=Mapp->Height)
            continue;
        if(Vision){
            //ۂ̈ړpBE̒̃jbg͉߂ă`FbNȂB
            if(Mapp->Visible[x][y])
                continue;
        }
        else{
            //ړ͈͎擾pBEOȂ狏Ȃ̂ƓB
            if(!Mapp->Visible[x][y])
                continue;
        }

        //ɍU\ȓGjbg邩`FbN
        if(Mapp->Data[x][y].Side!=-1 && Side!=(int)Mapp->Data[x][y].Side){
            EnemyUnitp = &EnemySidep->Unit[Mapp->Data[x][y].Unit];
            if(EnemyUnitp->SelectGun(BaseDatap,UnitType,-1) != -1)
                return 1;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//ړ͈͂̕`
__fastcall FieldScreen::MoveRangePut(MapData *Mapp,SideStatus *SideStatusp,int UnitNum)
{
    RangePut(Mapp,CURSOR_MOVE,SideStatusp,UnitNum,true,false);
    return 0;
}
//---------------------------------------------------------------------------
//ʏU͈͂̕`Bjbgɂ͍~ԃJ[\`B
__fastcall FieldScreen::DrawAttackRange(MapData *Mapp)
{
    RangePut(Mapp,CURSOR_RANGE,NULL,-1,false,true);
    return 0;
}
//---------------------------------------------------------------------------
//KwNXU͈͂̕`Bjbg̗L͍lȂB
__fastcall FieldScreen::DrawMegaAttackRange(MapData *Mapp)
{
    RangePut(Mapp,CURSOR_RANGE,NULL,-1,false,false);
    return 0;
}
//---------------------------------------------------------------------------
//Ԋ|̈`
__fastcall FieldScreen::HalfRangePut(MapData *Mapp)
{
    RangePut(Mapp,CURSOR_HALF,NULL,-1,false,false);
    return 0;
}
//---------------------------------------------------------------------------
//`̈gŕ`
//Backup=trueȂ瓯ɕ`̈obNAbv
__fastcall FieldScreen::DrawBoxRange(MapData *Mapp,TRect BoxRect,bool Backup)
{
    int x,y;
    TRect DrawRect;

    if(Backup){
        Backuped[0]=false;
        if(!GetDrawRect(Mapp,&DrawRect))
            return 0;
        BackupBitmap(DrawRect,0);
    }
        //RangePoint݂̂ŕ`n_𔻒f
    for(y=BoxRect.Top;y<=BoxRect.Bottom;y++)
        for(x=0;x<Mapp->Width;x++)
            if(y>=0 && y<Mapp->Height && Mapp->RangePoint[x][y]>1)
                CursorPutZ(x,y,CURSOR_SELECT);
    SelectDraw = true;
    return 0;
}
//---------------------------------------------------------------------------
//g
__fastcall FieldScreen::EraseBoxRange(MapData *Mapp)
{
    if(!SelectDraw)
        return -1;
    RestoreBitmap(0);
    return 0;
}
//---------------------------------------------------------------------------
//ړ/˒͈͂`悵A`̈BackUpBitmapɃRs[
//DrawMove=true:ړ̕`  DrawLoad=true:~Ԕ͈͕`
//ڂ͌ĂяoȂB˒\͗O
__fastcall FieldScreen::RangePut(MapData *Mapp,int index,SideStatus *SideStatusp,int UnitNum,bool DrawMove,bool DrawDown)
{
    int x,y,p,q,i,ux,uy,Type1,Type2;
    TRect DrawRect;

    Backuped[0]=false;
    if(!GetDrawRect(Mapp,&DrawRect))
        return 0;
    BackupBitmap(DrawRect,BKUP_NORMAL);

    if(SideStatusp!=NULL){
        ux=SideStatusp->Unit[UnitNum].X;
        uy=SideStatusp->Unit[UnitNum].Y;
        Type1=SideStatusp->Unit[UnitNum].Type;
    }
    for(y=0;y<Mapp->Height;y++)
        for(x=0;x<Mapp->Width;x++){
            if(!Mapp->RangePoint[x][y])
                continue;
            //CPU쎞p̃IvVBȂ͕̑`悵Ȃ
            if(RangeLimit && Mapp->Shade[x][y])
                continue;
            XY_MapToPhy(x,y,&p,&q);
            if(Mapp->Data[x][y].Side==-1 || Mapp->Shade[x][y]){
                //jbgs݁A͌Ȃꍇ
                if(DrawDown)
                    CursorPut(p,q,CURSOR_DOWN);
                else
                    CursorPut(p,q,index);
            }
            else{
                //jbgꍇAKvɉč܂
                //ڃJ[\`B
                //AVisible=false͎̎͂Rjbgł
                //肦Ȃ̂ŁAPɎw̃J[\`B
                if(DrawMove && (x!=ux || y!=uy) && Mapp->Visible[x][y]){
                    i=Mapp->Data[x][y].Unit;
                    Type2=SideStatusp->Unit[i].Type;
                    if(Type1==Type2)
                        CursorPut(p,q,CURSOR_PLUS);
                    else
                        CursorPut(p,q,CURSOR_UP);
                }
                else
                    CursorPut(p,q,index);
            }
        }
    return 0;
}
//---------------------------------------------------------------------------
//RangePoint>0̕ɕ`悷ƂƂA܂ދ`̈߂
//߂l͕`ӏ̐
__fastcall FieldScreen::GetDrawRect(MapData *Mapp,TRect *r)
{
    int x,y,p,q,count=0;

    *r = Rect(10000,10000,0,0);
    for(y=0;y<Mapp->Height;y++)
        for(x=0;x<Mapp->Width;x++)
            if(Mapp->RangePoint[x][y]){
                XY_MapToPhy(x,y,&p,&q);
                GetOrRect(r,p,q,GraphDegree,GraphDegree);
                count++;
            }
    return count;
}
//---------------------------------------------------------------------------
//`ɋ`aB
__fastcall FieldScreen::GetOrRect(TRect *r,int x,int y,int w,int h)
{
    if(r->Left > x)
        r->Left = x;
    if(r->Top > y)
        r->Top = y;
    if(r->Right < x+w)
        r->Right = x+w;
    if(r->Bottom < y+h)
        r->Bottom = y+h;
    return 0;
}
//---------------------------------------------------------------------------
// TCanvasŜw肵FœhԂBBrushς̂ŒӁB
__fastcall FillCanvas(TCanvas *canvas,TColor color)
{
    canvas->Brush->Color = color;
    canvas->FillRect(canvas->ClipRect);
    return 0;
}
//---------------------------------------------------------------------------

