//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#include "gbwunit1.h"

#define VERSIONSTRING "ǒn헪jbgGfB^ for Ver.1.46"

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    Form_Ground1=new TForm_Ground(this);

    Form_Property=new TForm_UnitProperty(this);

    Form_ViewUnit1=new TForm_ViewUnit(this);

    GBWImage1=new GBWImageData();
    Form_Ground1->GBWImagep=GBWImage1;
    ImageLoad();

    BaseData1=new BaseData();
    Form_Ground1->BaseDatap=BaseData1;
    BaseData1->SetDefault();
    Form_ViewUnit1->SetDataPointer(BaseData1,GBWImage1);

    System1=new SystemStatus();
//    BaseData1->OldDataLoad(OLDDATAFILE);
    BaseData1->ReadStandard();
    int i;
    for(i=0;i<BUILDINGMAX;i++){
        CheckListBox_Building->Items->Add(BaseData1->MapInfo[i].Name);
    }
    for(i=0;i<UNITTYPEMAX;i++){
        CheckListBox_Unit->Items->Add(BaseData1->UnitInfo[i].Name);
    }
    DrawUnitData(System1->UnitNumber);
    DrawGroundName();
    DrawMoveGround(System1->UnitNumber);
    DrawTargetName();
    DrawAttackData(System1->UnitNumber);
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1(void)
{
    delete Form_Ground1;
    delete Form_Property;
    delete GBWImage1;
    delete BaseData1;
    delete System1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Show(TObject *Sender)
{
    Option.Load();
    Option.GetWindowState(&Option.WindowState_gbwunit, this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Close(TObject *Sender, TCloseAction &Action)
{
    Option.SetWindowState(&Option.WindowState_gbwunit, this);
    Option.Save();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{
    OpenDialog1->FileName=System1->EditFile;
    if(OpenDialog1->Execute()){
        strcpy(System1->EditFile,OpenDialog1->FileName.c_str());
        BaseData1->ReadUser(System1->EditFile);
        GBWImage1->LoadUserExtend(BaseData1->UserBitmapFile,BaseData1->Sides,BaseData1->UnitGrpGet);
        DrawCurrentAll();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{
    GetCurrentAll();
    BaseData1->WriteUser(System1->EditFile);
    DrawUnitData(System1->UnitNumber);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveAs1Click(TObject *Sender)
{
    SaveDialog1->FileName=System1->EditFile;
    if(SaveDialog1->Execute()){
        strcpy(System1->EditFile,SaveDialog1->FileName.c_str());
        GetCurrentAll();
        BaseData1->WriteUser(System1->EditFile);
        DrawUnitData(System1->UnitNumber);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Property1Click(TObject *Sender)
{
    GetCurrentAll();
    Form_Property->Edit_Bitmap->Text = BaseData1->UserBitmapFile;
    Form_Property->Edit_Get->Text = BaseData1->UnitGrpGet;
    Form_Property->Edit_Side1->Text = BaseData1->SideName[0];
    Form_Property->Edit_Side2->Text = BaseData1->SideName[1];
    Form_Property->CheckBox_NoStandard->Checked = BaseData1->NoStandard;

    Form_Property->Result=false;
    Form_Property->ShowModal();
    if(Form_Property->Result){
        strcpy(BaseData1->UserBitmapFile,Form_Property->Edit_Bitmap->Text.c_str());
        BaseData1->UnitGrpGet = Form_Property->Edit_Get->Text.ToIntDef(0);
        strcpy(BaseData1->SideName[0],Form_Property->Edit_Side1->Text.c_str());
        strcpy(BaseData1->SideName[1],Form_Property->Edit_Side2->Text.c_str());
        BaseData1->NoStandard = Form_Property->CheckBox_NoStandard->Checked;
        GBWImage1->LoadUserExtend(BaseData1->UserBitmapFile,BaseData1->Sides,BaseData1->UnitGrpGet);
        DrawUnitData(System1->UnitNumber);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::File_CSV_ImportClick(TObject *Sender)
{
    TOpenDialog *dialog = new TOpenDialog(this);
    char path[256];
    int result;

    dialog->Filter = "CSV file(*.csv)|*.csv";
    dialog->DefaultExt = "csv";
    result = dialog->Execute();
    if(result)
        strcpy(path,dialog->FileName.c_str());
    delete dialog;
    if(result)
        BaseData1->LoadFromCSV(path);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::File_CSV_ExportClick(TObject *Sender)
{
    TOpenDialog *dialog = new TSaveDialog(this);
    char path[256];
    int result;

    dialog->Filter = "CSV file(*.csv)|*.csv";
    dialog->DefaultExt = "csv";
    result = dialog->Execute();
    if(result)
        strcpy(path,dialog->FileName.c_str());
    delete dialog;
    if(result)
        BaseData1->SaveToCSV(path);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StandardClick(TObject *Sender)
{
    BaseData1->WriteStandard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpDown_UnitClick(TObject *Sender,
      TUDBtnType Button)
{
    int i;

    i=System1->UnitNumber;
    i+=(Button==Comctrls::btNext)-(Button==Comctrls::btPrev);
    ChangeUnitNum(i);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit_UnitNumChange(TObject *Sender)
{
    int i;

    i=Edit_UnitNum->Text.ToIntDef(-1);
    if(ChangeUnitNum(i)==-1){
        if(i>UNITTYPEMAX)
            Edit_UnitNum->Text=UNITTYPEMAX-1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::WarningClick(TObject *Sender)
{
    char str[]="EŏɃvpeBݒs܂B\nEuo^v`FbNĂȂjbg̓Z[u܂B\nE0-39̃jbǵAGŒȂ̂Œǉɂ͌܂B\nEjbg̉i1000ȏɂĉB\nEQ[Ŏgp̃f[^ύXƕsN\܂B";

    ShowMessage(str);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Form1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Shift * (TShiftState()<<ssShift) != TShiftState())
        switch(Key){
        case 122: //vf.1
            ShowMessage("ґ샂[hɓ܂B");
            SpeedButton_Standard->Visible=true;
            Button_Ground->Visible=true;
            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_GroundClick(TObject *Sender)
{
    Form_Ground1->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_SetBuildingDefaultClick(TObject *Sender)
{
    UnitChip *UnitInfop;
    bool Create[3][BUILDINGMAX]={{true,true,true,true,false,false,false,false,false,false},
                                 {false,false,false,false,false,false,true,true,false,false},
                                 {false,false,false,false,true,true,false,false,false,false}};
    bool Supply[3][BUILDINGMAX]={{true,true,true,true,false,false,false,false,true,true},
                                 {false,false,false,false,false,false,true,true,false,false},
                                 {false,false,false,false,true,true,false,false,false,false}};
    int i;

    if(!Rewritable(System1->UnitNumber))
        return;
    UnitInfop=&BaseData1->UnitInfo[System1->UnitNumber];
    for(i=0;i<BUILDINGMAX;i++){
        UnitInfop->Creatable[i] = Create[UnitInfop->Type][i];
        UnitInfop->Supply[i]    = Supply[UnitInfop->Type][i];
    }
    DrawBuildingCheck(System1->UnitNumber);
}
//---------------------------------------------------------------------------
//̃jbg̃f[^Rs[
void __fastcall TForm1::CopyFromClick(TObject *Sender)
{
    int to;

    Form_ViewUnit1->Caption = "Rs[郆jbg̑I";
    Form_ViewUnit1->ReadFromOtherFile();
    Form_ViewUnit1->ShowModal();
    if(Form_ViewUnit1->ModalResult == mrOk){
        //from = Form_ViewUnit1->Selected;
        to = System1->UnitNumber;
        //BaseData1->UnitInfo[to] = Form_ViewUnit1->BaseDataTmp->UnitInfo[from];
        Form_ViewUnit1->GetSelectedUnitChip(&BaseData1->UnitInfo[to]);
        DrawCurrentAll();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VersionClick(TObject *Sender)
{
    ShowMessage(VERSIONSTRING);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit_UnitNameChange(TObject *Sender)
{
    if(!strcmp(BaseData1->UnitInfo[System1->UnitNumber].Name,Edit_UnitName->Text.c_str()))
        return; //Of[^ƓȂ牽Ȃ
    GetUnitData(System1->UnitNumber); //WI̖Oς
    DrawAttackData(System1->UnitNumber);
    DrawUnitCheck(System1->UnitNumber);
}
//---------------------------------------------------------------------------
//EBhETCYꂽ̃CxgB
//Rg[EBhEɍ킹ăTCYB
//fUCύX̍ۂɂ̓`FbNKvB
void __fastcall TForm1::Form1Resize(TObject *Sender)
{
    //Ƃ܂̂ŉ݂B
    if(Width<768)
        Width=768;
    if(Height<464)
        Height=464;
    //n`Ƃ̊֌WAejbgւ̍U
    GroupBox_Ground->Height = Panel_Unit->Height-48;
    GroupBox_Attack->Height = GroupBox_Ground->Height;
    StringGrid_Target->Height = GroupBox_Attack->Height-88;
    Label_AttackWarning->Top = GroupBox_Attack->Height-65;

    //IuWFNgCXyN^Ŏw肷@Ȃ̂łŎw肷B
    StringGrid_Target->ColWidths[0] = 96;
    StringGrid_Target->ColWidths[1] = 48;
    StringGrid_Target->ColWidths[2] = 48;

    //jbgƂ̊֌WA{݂Ƃ̊֌W
    int margin = Panel_Unit->Height - GroupBox_Supply->Top - 8;
    GroupBox_Supply->Height = margin/2;
    GroupBox_Building->Top = GroupBox_Supply->Top + GroupBox_Supply->Height + 4;
    GroupBox_Building->Height = margin/2;
    TabControl_Unit->Height = GroupBox_Supply->Height - 24;
    TabControl_Building->Height = GroupBox_Building->Height - 48;

    //n`Ƃ̊֌W
    margin = GroupBox_Ground->Height - 32;
    StringGrid_Ground->Height = margin/2;
    Label_LoadOn->Top = StringGrid_Ground->Top + StringGrid_Ground->Height + 4;
    CheckListBox_LoadOn->Top = Label_LoadOn->Top + 16;
    CheckListBox_LoadOn->Height = GroupBox_Ground->Height - CheckListBox_LoadOn->Top - 8;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AttackTableClick(TObject *Sender)
{
    AttackTableForm *Form_AT = new AttackTableForm(PopupMenu_AttackTable);

    Form_AT->Make(this,BaseData1,0,0);
    DrawCurrentAll();

    delete Form_AT;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TabControl_GunChange(TObject *Sender)
{
    DrawGunProperty(System1->UnitNumber);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TabControl_GunChanging(TObject *Sender,
      bool &AllowChange)
{
    GetGunProperty(System1->UnitNumber);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TabControl_BuildingChange(TObject *Sender)
{
    DrawBuildingCheck(System1->UnitNumber);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TabControl_BuildingChanging(TObject *Sender,
      bool &AllowChange)
{
    GetBuildingCheck(System1->UnitNumber);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TabControl_UnitChange(TObject *Sender)
{
    DrawUnitCheck(System1->UnitNumber);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TabControl_UnitChanging(TObject *Sender,
      bool &AllowChange)
{
    GetUnitCheck(System1->UnitNumber);
}
//---------------------------------------------------------------------------
__fastcall TForm1::ImageLoad(void)
{
    int pixelFormat = GetDeviceCaps(Canvas->Handle,BITSPIXEL);
    GBWImage1->Load(pixelFormat);
    Form_ViewUnit1->LoadDefaultImage(pixelFormat);
    return 0;
}
//---------------------------------------------------------------------------
//n`̕`
__fastcall TForm1::DrawGroundName(void)
{
    char *name;
    int i;

    for(i=0;i<40;i++){ //40-79̒n`gBƂĂ蔲B
        name = BaseData1->MapInfo[40+i].Name;
        StringGrid_Ground->Cells[0][i] = name;
        CheckListBox_LoadOn->Items->Add(name);
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbg̕`
__fastcall TForm1::DrawTargetName(void)
{
    StringGrid_Target->Cells[0][0] = "Ώہ_U";
    StringGrid_Target->Cells[1][0] = "ΊP";
    StringGrid_Target->Cells[2][0] = "ΊQ";
    return 0;
}
//---------------------------------------------------------------------------
//ҏWjbg̕ύX
__fastcall TForm1::ChangeUnitNum(int UnitNum)
{
    if(System1->UnitNumber==UnitNum)
        return -1;
    if(UnitNum<0 || UnitNum>=UNITTYPEMAX)
        return -1;
    GetCurrentAll();
    System1->UnitNumber=UnitNum;
    UpDown_Unit->Position=(short)UnitNum;
    DrawCurrentAll();
    return 0;
}
//---------------------------------------------------------------------------
//葁Sĕ\
__fastcall TForm1::DrawCurrentAll(void)
{
    DrawUnitData(System1->UnitNumber);
    DrawMoveGround(System1->UnitNumber);
    DrawAttackData(System1->UnitNumber);
    return 0;
}
//---------------------------------------------------------------------------
//葁S荞
__fastcall TForm1::GetCurrentAll(void)
{
    if(Rewritable(System1->UnitNumber)){
        GetUnitData(System1->UnitNumber); //ҏWꂽf[^擾
        GetMoveGround(System1->UnitNumber);
        GetAttackData(System1->UnitNumber);
    }
    return 0;
}
//---------------------------------------------------------------------------
//GroupBoxɓĂȂ\
__fastcall TForm1::DrawUnitData(int UnitNum)
{
    UnitChip *UnitInfop;

    UnitInfop=&BaseData1->UnitInfo[UnitNum];
    GBWImage1->ImageList_CursorN->Draw(Image_Unit->Canvas,0,0,CURSOR_NULL);
    GBWImage1->ImageList_UnitN->Draw(Image_Unit->Canvas,0,0,UnitNum);
    Image_Unit->Refresh();
    CheckBox_Defined->Checked = UnitInfop->Defined;
    CheckBox_OnlyTekisaku->Checked = UnitInfop->OnlyTekisaku;
    Edit_UnitNum->Text=UnitNum;
    Edit_UnitName->Text=UnitInfop->Name;
    Edit_Value->Text=UnitInfop->Value;
    UpDown_Move->Position     =(short)UnitInfop->MoveMax;
    UpDown_Fuel->Position     =(short)UnitInfop->FuelMax;
    Edit_Move->Text = UnitInfop->MoveMax;
    Edit_Fuel->Text = UnitInfop->FuelMax;
    Edit_Visibility->Text = UnitInfop->Visibility;

/*
    Edit_GunName1->Text = UnitInfop->GunName[0];
    Edit_GunName2->Text = UnitInfop->GunName[1];
    UpDown_GunMax1->Position = (short)UnitInfop->GunMax[0];
    Edit_GunMax1->Text = UnitInfop->GunMax[0];
    UpDown_GunMax2->Position = (short)UnitInfop->GunMax[1];
    Edit_GunMax2->Text = UnitInfop->GunMax[1];
    UpDown_MinRange1->Position =(short)UnitInfop->MinRange[0];
    UpDown_MaxRange1->Position =(short)UnitInfop->MaxRange[0];
    UpDown_MinRange2->Position =(short)UnitInfop->MinRange[1];
    UpDown_MaxRange2->Position =(short)UnitInfop->MaxRange[1];
    Edit_MinRange1->Text = UnitInfop->MinRange[0];
    Edit_MaxRange1->Text = UnitInfop->MaxRange[0];
    Edit_MinRange2->Text = UnitInfop->MinRange[1];
    Edit_MaxRange2->Text = UnitInfop->MaxRange[1];
*/
    CheckBox_SuperMissile->Checked = UnitInfop->SuperMissile;
    ComboBox_Type->ItemIndex = UnitInfop->Type;

    Edit_Load->Text = UnitInfop->Loadable;

    CheckBox_CanOccupy->Checked = UnitInfop->CanOccupy;
    CheckBox_SupplyLoading->Checked = UnitInfop->SupplyLoading;
    CheckBox_SupplySurround->Checked = UnitInfop->SupplySurround;
    CheckBox_OnlyFuel->Checked = UnitInfop->OnlyFuel;
    CheckBox_SupplyLife->Checked = UnitInfop->SupplyLife;
    DrawGunProperty(UnitNum);
    DrawBuildingCheck(UnitNum);
//  UpdateCheckListBox_Unit();
    DrawUnitCheck(UnitNum);
    return 0;
}
//---------------------------------------------------------------------------
//ړ̓O[v̕`B
__fastcall TForm1::DrawMoveGround(int UnitNum)
{
    int i,j;
    UnitChip *UnitInfop = &BaseData1->UnitInfo[UnitNum];

    for(i=0;i<40;i++){ //Ƃɂꎞ̂B
        if(i<20)
            j=i;       //0-19
        else
            j=BUILDINGMAX*2+i; //60-79
        StringGrid_Ground->Cells[1][i] = UnitInfop->MoveLost[j];
        CheckListBox_LoadOn->Checked[i] = UnitInfop->CanLoadOn[j];
    }
    return 0;
}
//---------------------------------------------------------------------------
//U̓O[v
__fastcall TForm1::DrawAttackData(int UnitNum)
{
    int i;

    for(i=0;i<UNITTYPEMAX;i++){
        StringGrid_Target->Cells[0][1+i] = BaseData1->UnitInfo[i].Name;
        StringGrid_Target->Cells[1][1+i] = BaseData1->UnitInfo[UnitNum].Attack[0][i];
        StringGrid_Target->Cells[2][1+i] = BaseData1->UnitInfo[UnitNum].Attack[1][i];
    }
    return 0;
}
//---------------------------------------------------------------------------
/*__fastcall TForm1::UpdateCheckListBox_Unit(void)
{
    for(int i=0;i<UNITTYPEMAX;i++){
        CheckListBox_Unit->Items->Strings[i] = BaseData1->UnitInfo[i].Name;
    }
    return 0;
}*/
//---------------------------------------------------------------------------
//uΊvݒe\B
__fastcall TForm1::DrawGunProperty(int UnitNum)
{
    int index = TabControl_Gun->TabIndex;
    UnitChip *UnitInfop = &BaseData1->UnitInfo[UnitNum];

    Edit_GunName->Text = UnitInfop->GunName[index];
    UpDown_GunMax->Position = (short)UnitInfop->GunMax[index];
    Edit_GunMax->Text = UnitInfop->GunMax[index];
    UpDown_MinRange->Position = (short)UnitInfop->MinRange[index];
    UpDown_MaxRange->Position = (short)UnitInfop->MaxRange[index];
    Edit_MinRange->Text = UnitInfop->MinRange[index];
    Edit_MaxRange->Text = UnitInfop->MaxRange[index];
    Edit_GunRadius->Text = UnitInfop->Radius[index];
    return 0;
}
//---------------------------------------------------------------------------
//u{݂Ƃ̊֌Wvݒe\B
__fastcall TForm1::DrawBuildingCheck(int UnitNum)
{
    int i;
    bool *flags;
    UnitChip *UnitInfop = &BaseData1->UnitInfo[UnitNum];

    if(TabControl_Building->TabIndex == 0){
        flags = UnitInfop->Creatable;
    }else{
        flags = UnitInfop->Supply;
    }

    for(i=0;i<BUILDINGMAX;i++){
        CheckListBox_Building->Checked[i] = flags[i];
    }
    return 0;
}
//---------------------------------------------------------------------------
//ujbgƂ̊֌Wvݒe\B
__fastcall TForm1::DrawUnitCheck(int UnitNum)
{
    int i;
    bool *flags;
    UnitChip *UnitInfop = &BaseData1->UnitInfo[UnitNum];

    if(TabControl_Unit->TabIndex == 0){
        flags = UnitInfop->LoadUnit;
    }else{
        flags = UnitInfop->SupplyUnit;
    }

    for(i=0;i<UNITTYPEMAX;i++){
        CheckListBox_Unit->Items->Strings[i] = BaseData1->UnitInfo[i].Name;
        CheckListBox_Unit->Checked[i] = flags[i];
    }
    return 0;
}
//---------------------------------------------------------------------------
//[U[ݒ肵e荞ށB
__fastcall TForm1::GetUnitData(int UnitNum)
{
    UnitChip *UnitInfop;

    UnitInfop=&BaseData1->UnitInfo[UnitNum];
    strcpy(UnitInfop->Name,Edit_UnitName->Text.c_str());
    UnitInfop->Defined  = CheckBox_Defined->Checked;
    UnitInfop->OnlyTekisaku = CheckBox_OnlyTekisaku->Checked;
    UnitInfop->Value    = Edit_Value->Text.ToIntDef(0);
    UnitInfop->MoveMax  = Edit_Move->Text.ToIntDef(0);
    UnitInfop->FuelMax  = Edit_Fuel->Text.ToIntDef(0);
    UnitInfop->Visibility = Edit_Visibility->Text.ToIntDef(0);
/*
    UnitInfop->MinRange[0] = Edit_MinRange1->Text.ToIntDef(0);
    UnitInfop->MaxRange[0] = Edit_MaxRange1->Text.ToIntDef(0);
    UnitInfop->MinRange[1] = Edit_MinRange2->Text.ToIntDef(0);
    UnitInfop->MaxRange[1] = Edit_MaxRange2->Text.ToIntDef(0);
    strcpy(UnitInfop->GunName[0],Edit_GunName1->Text.c_str());
    UnitInfop->GunMax[0] = Edit_GunMax1->Text.ToIntDef(0);
    strcpy(UnitInfop->GunName[1],Edit_GunName2->Text.c_str());
    UnitInfop->GunMax[1] = Edit_GunMax2->Text.ToIntDef(0);
*/
    UnitInfop->SuperMissile = CheckBox_SuperMissile->Checked;
    UnitInfop->Type = (UnitChip::UnitType)ComboBox_Type->ItemIndex;

    UnitInfop->Loadable = Edit_Load->Text.ToIntDef(0);
    if(UnitInfop->Loadable > 2)
        UnitInfop->Loadable = 2;

    UnitInfop->CanOccupy = CheckBox_CanOccupy->Checked;
    UnitInfop->SupplyLoading = CheckBox_SupplyLoading->Checked;
    UnitInfop->SupplySurround = CheckBox_SupplySurround->Checked;
    UnitInfop->OnlyFuel = CheckBox_OnlyFuel->Checked;
    UnitInfop->SupplyLife = CheckBox_SupplyLife->Checked;

    GetGunProperty(UnitNum);
    GetBuildingCheck(UnitNum);
    GetUnitCheck(UnitNum);
    return 0;
}
//---------------------------------------------------------------------------
//ړ͂̐ݒB
__fastcall TForm1::GetMoveGround(int UnitNum)
{
    int i,j,n;
    UnitChip *UnitInfop = &BaseData1->UnitInfo[UnitNum];

    for(i=0;i<3;i++){  //ԁEÊRނ̌Bꎞ̂B
        for(j=0;j<BUILDINGMAX;j++){
            n = i*BUILDINGMAX+j;
            UnitInfop->MoveLost[n] = StringGrid_Ground->Cells[1][j].ToIntDef(0);
            UnitInfop->CanLoadOn[n] = CheckListBox_LoadOn->Checked[j];
        }
    }
    for(i=0;i<20;i++){ //ȊO̒n`Bꎞ̂B
        n = BUILDINGMAX*3 + i;
        UnitInfop->MoveLost[n] = StringGrid_Ground->Cells[1][BUILDINGMAX+i].ToIntDef(0);
        UnitInfop->CanLoadOn[n] = CheckListBox_LoadOn->Checked[BUILDINGMAX+i];
    }
    return 0;
}
//---------------------------------------------------------------------------
//U͂̐ݒ荞ށB
__fastcall TForm1::GetAttackData(int UnitNum)
{
    int i;

    for(i=0;i<UNITTYPEMAX;i++){
        BaseData1->UnitInfo[UnitNum].Attack[0][i] = StringGrid_Target->Cells[1][1+i].ToIntDef(0);
        BaseData1->UnitInfo[UnitNum].Attack[1][i] = StringGrid_Target->Cells[2][1+i].ToIntDef(0);
    }
    return 0;
}
//---------------------------------------------------------------------------
//uΊv̐ݒ荞ށB
__fastcall TForm1::GetGunProperty(int UnitNum)
{
    int index = TabControl_Gun->TabIndex;
    UnitChip *UnitInfop = &BaseData1->UnitInfo[UnitNum];

    strcpy(UnitInfop->GunName[index], Edit_GunName->Text.c_str());
    UnitInfop->GunMax[index] = Edit_GunMax->Text.ToIntDef(0);
    UnitInfop->MinRange[index] = Edit_MinRange->Text.ToIntDef(0);
    UnitInfop->MaxRange[index] = Edit_MaxRange->Text.ToIntDef(0);
    UnitInfop->Radius[index] = Edit_GunRadius->Text.ToIntDef(1);
    return 0;
}
//---------------------------------------------------------------------------
//u{݂Ƃ̊֌Wv̐ݒ荞ށB
__fastcall TForm1::GetBuildingCheck(int UnitNum)
{
    int i;
    UnitChip *UnitInfop = &BaseData1->UnitInfo[UnitNum];

    if(TabControl_Building->TabIndex == 0){
        for(i=0;i<BUILDINGMAX;i++)
            UnitInfop->Creatable[i] = CheckListBox_Building->Checked[i];
    }
    else{
        for(i=0;i<BUILDINGMAX;i++)
            UnitInfop->Supply[i] = CheckListBox_Building->Checked[i];
    }
    return 0;
}
//---------------------------------------------------------------------------
//ujbgƂ̊֌Wv̐ݒ荞ށB
__fastcall TForm1::GetUnitCheck(int UnitNum)
{
    int i;
    bool *flags;
    UnitChip *UnitInfop = &BaseData1->UnitInfo[UnitNum];

    if(TabControl_Unit->TabIndex == 0){
        flags = UnitInfop->LoadUnit;
    }else{
        flags = UnitInfop->SupplyUnit;
    }
    for(i=0;i<UNITTYPEMAX;i++)
        flags[i] = CheckListBox_Unit->Checked[i];
    //g̓ځEgւ̕⋋͏ɂłȂB
    flags[UnitNum] = false;
    return 0;
}
//---------------------------------------------------------------------------
//݂̃f[^邩
__fastcall TForm1::Rewritable(int UnitNum)
{
//    if(Button_Ground->Visible || UnitNum>=UNITSTANDARD)
//        return 1;
    return 1;
}
//---------------------------------------------------------------------------
//U͕\\A͂߁ABaseDataɓ͓e
__fastcall AttackTableForm::Make(TForm *OwnerForm,BaseData *BaseDatap,int X,int Y)
{
    UnitChip *UnitInfop;
    int i,n,x,y,value,error=0;
    char str[50];

    VisibleCount = 0;
    for(i=0;i<UNITTYPEMAX;i++) //o^Ă郆jbg𒊏o
        if(BaseDatap->UnitInfo[i].Defined){
            VisibleUnits[VisibleCount] = i;
            VisibleCount++;
        }

    Formp = new TForm(OwnerForm);
    Formp->Caption = "U͕\iENbNōsPʕҏWj";
    Formp->Width=400;
    Formp->Height=320;
    Formp->Left=X;
    Formp->Top=Y;

    StringGrid_Attack = new TStringGrid(Formp);
    StringGrid_Attack->Parent = Formp;
    StringGrid_Attack->Align = alClient;
    StringGrid_Attack->DefaultColWidth = 80;
    StringGrid_Attack->DefaultRowHeight = 16;
    StringGrid_Attack->ColCount = VisibleCount+1;
    StringGrid_Attack->RowCount = VisibleCount*2+1;
    StringGrid_Attack->Options << goEditing;
    StringGrid_Attack->PopupMenu = PopupMenu_AttackTable;
    StringGrid_Attack->OnMouseDown = StringGrid_AttackMouseDown;
    PopupMenu_AttackTable->OnPopup = PopupMenu_AttackTablePopup;
    PopupMenu_AttackTable->Items->Items[0]->OnClick = MenuItem_CopyRowClicked;
    PopupMenu_AttackTable->Items->Items[1]->OnClick = MenuItem_PasteRowClicked;
    PopupMenu_AttackTable->Items->Items[2]->OnClick = MenuItem_PasteRowMultipleClicked;
    PopupMenu_AttackTable->Items->Items[3]->OnClick = MenuItem_FillRowClicked;

    StringGrid_Attack->ColWidths[0] = 160;
    StringGrid_Attack->Cells[0][0] = "U_";
    for(i=0;i<VisibleCount;i++){
        UnitInfop = &BaseDatap->UnitInfo[VisibleUnits[i]];
        sprintf(str,"%-16s %-16s",UnitInfop->Name,UnitInfop->GunName[0]);
        StringGrid_Attack->Cells[0][i*2+1] = str;
        sprintf(str,"%-16s %-16s",UnitInfop->Name,UnitInfop->GunName[1]);
        StringGrid_Attack->Cells[0][i*2+2] = str;
        StringGrid_Attack->Cells[i+1][0] = UnitInfop->Name;
    }

    for(y=0;y<VisibleCount;y++){
        UnitInfop = &BaseDatap->UnitInfo[VisibleUnits[y]];
        for(x=0;x<VisibleCount;x++){
            n = VisibleUnits[x];
            sprintf(str,"%3d",UnitInfop->Attack[0][n]);
            StringGrid_Attack->Cells[x+1][y*2+1] = str;
            sprintf(str,"%3d",UnitInfop->Attack[1][n]);
            StringGrid_Attack->Cells[x+1][y*2+2] = str;
        }
    }

    Formp->ShowModal();

    for(y=0;y<VisibleCount;y++){
        UnitInfop = &BaseDatap->UnitInfo[VisibleUnits[y]];
        for(x=0;x<VisibleCount;x++){
            n = VisibleUnits[x];
            value = StringGrid_Attack->Cells[x+1][y*2+1].ToIntDef(-1);
            if(value != -1)
                UnitInfop->Attack[0][n] = value;
            else
                error++;
            value = StringGrid_Attack->Cells[x+1][y*2+2].ToIntDef(-1);
            if(value != -1)
                UnitInfop->Attack[1][n] = value;
            else
                error++;
        }
    }
    if(error){
        sprintf(str,"lǂݍ߂ȂZ%d܂B\n",error);
        ShowMessage(str);
    }

    delete StringGrid_Attack;
    delete Formp;
    return 0;
}
//---------------------------------------------------------------------------
void __fastcall AttackTableForm::StringGrid_AttackMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    int cellx,celly;

    StringGrid_Attack->MouseToCell(X,Y,cellx,celly);
    ButtonDownedRow = celly - 1;
    //Formp->Caption = ButtonDownedRow;
}
//---------------------------------------------------------------------------
void __fastcall AttackTableForm::PopupMenu_AttackTablePopup(TObject *Sender)
{
    int i;
    if(ButtonDownedRow<0 || ButtonDownedRow>=VisibleCount*2){
        for(i=0;i<4;i++)
            PopupMenu_AttackTable->Items->Items[i]->Enabled = false;
        return;
    }
    for(i=0;i<4;i++)
        PopupMenu_AttackTable->Items->Items[i]->Enabled = true;
    PopupMenu_AttackTable->Items->Items[1]->Enabled = RowCopied;
    PopupMenu_AttackTable->Items->Items[2]->Enabled = RowCopied;
}
//---------------------------------------------------------------------------
void __fastcall AttackTableForm::MenuItem_CopyRowClicked(TObject *Sender)
{
    int x;
    for(x=0;x<VisibleCount;x++)
        RowCopy[x] = StringGrid_Attack->Cells[x+1][ButtonDownedRow+1].ToIntDef(0);
    RowCopied = true;
}
//---------------------------------------------------------------------------
void __fastcall AttackTableForm::MenuItem_PasteRowClicked(TObject *Sender)
{
    PasteRowMultiple(ButtonDownedRow,100);
}
//---------------------------------------------------------------------------
void __fastcall AttackTableForm::MenuItem_PasteRowMultipleClicked(TObject *Sender)
{
    int per=100;
    GetValueForm *valueFormp = new GetValueForm(Formp);

    valueFormp->SetMessage("|lPʂœ͂ĉ");
    valueFormp->SetValue(100);
    valueFormp->ShowModal();
    if(!valueFormp->Result){
        delete valueFormp;
        return;
    }
    sscanf(valueFormp->Value, "%d", &per);
    PasteRowMultiple(ButtonDownedRow,per);
    delete valueFormp;
}
//---------------------------------------------------------------------------
void __fastcall AttackTableForm::MenuItem_FillRowClicked(TObject *Sender)
{
    GetValueForm *valueFormp = new GetValueForm(Formp);
    char str[32];
    int x,value;

    valueFormp->SetMessage("߂l͂ĉ");
    valueFormp->SetValue(0);
    valueFormp->ShowModal();
    if(!valueFormp->Result){
        delete valueFormp;
        return;
    }
    sscanf(valueFormp->Value, "%d", &value);
    sprintf(str,"%3d",value);
    for(x=0;x<VisibleCount;x++){
        StringGrid_Attack->Cells[x+1][ButtonDownedRow+1] = value;
    }
    delete valueFormp;
}
//---------------------------------------------------------------------------
__fastcall AttackTableForm::PasteRowMultiple(int rowIndex,int per)
{
    char str[32];
    int x;
    for(x=0;x<VisibleCount;x++){
        sprintf(str,"%3d", RowCopy[x]*per/100);
        StringGrid_Attack->Cells[x+1][rowIndex+1] = str;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall GetValueForm::GetValueForm(TComponent* Owner)
{
    Formp = new TForm(Owner);
    Formp->Width = 256;
    Formp->Height = 160;
    Formp->BorderIcons = (TBorderIcons() << biSystemMenu);

    Label_Message = new TLabel(Formp);
    Label_Message->Parent = Formp;
    Label_Message->Caption = "message";
    Label_Message->Width = 200;
    Label_Message->Height = 16;
    Label_Message->Left = 16;
    Label_Message->Top = 8;

    Edit_Value = new TEdit(Formp);
    Edit_Value->Parent = Formp;
    Edit_Value->Text = "";
    Edit_Value->Width = 128;
    Edit_Value->Height = 16;
    Edit_Value->Left = 16;
    Edit_Value->Top = 32;

    Button_OK = new TButton(Formp);
    Button_OK->Parent = Formp;
    Button_OK->Caption = "OK";
    Button_OK->Width = 64;
    Button_OK->Height = 24;
    Button_OK->Left = 96;
    Button_OK->Top = 96;
    Button_OK->OnClick = Button_OKClick;

    Button_Cancel = new TButton(Formp);
    Button_Cancel->Parent = Formp;
    Button_Cancel->Caption = "Cancel";
    Button_Cancel->Width = 64;
    Button_Cancel->Height = 24;
    Button_Cancel->Left = 168;
    Button_Cancel->Top = 96;
    Button_Cancel->OnClick = Button_CancelClick;

    Result = false;
}
//---------------------------------------------------------------------------
__fastcall GetValueForm::~GetValueForm(void)
{
    delete Button_OK;
    delete Button_Cancel;
    delete Label_Message;
    delete Edit_Value;
    delete Formp;
}
//---------------------------------------------------------------------------
void __fastcall GetValueForm::Button_OKClick(TObject *Sender)
{
    strcpy(Value, Edit_Value->Text.c_str());
    Result = true;
    Formp->Close();
}
//---------------------------------------------------------------------------
void __fastcall GetValueForm::Button_CancelClick(TObject *Sender)
{
    Formp->Close();
}
//---------------------------------------------------------------------------
__fastcall GetValueForm::ShowModal(void)
{
    Formp->ShowModal();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall GetValueForm::SetMessage(char *msg)
{
    Label_Message->Caption = msg;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall GetValueForm::SetValue(int value)
{
    sprintf(Value,"%d",value);
    Edit_Value->Text = Value;
    return 0;
}
//---------------------------------------------------------------------------

