//---------------------------------------------------------------------------
#ifndef gbwunit1H
#define gbwunit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "gbwfield.h"
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include <Grids.hpp>
//---------------------------------------------------------------------------
#include "editgnd.h"
#include "unitprp.h"
#include "unitview.h"
#include <checklst.hpp>

#define OLDDATAFILE "gbwunit.dat"
#define NEWFILENAME "newfile.uni"

class SystemStatus;
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Open1;
    TMenuItem *Save1;
    TMenuItem *File_N3;
    TMenuItem *Exit1;
    TOpenDialog *OpenDialog1;
    TPanel *Panel_Unit;
    TImage *Image_Unit;
    TEdit *Edit_UnitNum;
    TEdit *Edit_UnitName;
    TUpDown *UpDown_Unit;
    TComboBox *ComboBox_Type;
    TPanel *Panel_Tool;
    TSpeedButton *SpeedButton_Open;
    TLabel *Label_Fuel;
    TEdit *Edit_Fuel;
    TMenuItem *Help1;
    TMenuItem *Warning;
    TMenuItem *Version;
    TSpeedButton *SpeedButton_Save;
    TSpeedButton *SpeedButton_SaveAs;
    TSpeedButton *SpeedButton_Standard;
    TCheckBox *CheckBox_Defined;
    TGroupBox *GroupBox_Ground;
    TLabel *Label_ConsumeWarning;
    TGroupBox *GroupBox_Attack;
    TLabel *Label_AttackWarning;
    TGroupBox *GroupBox_Building;
    TButton *Button_SetBuildingDefault;
    TEdit *Edit_Value;
    TLabel *Label_Value;
    TMenuItem *Edit1;
    TMenuItem *CopyFrom;
    TMenuItem *SaveAs1;
    TSpeedButton *SpeedButton_Warning;
    TSpeedButton *SpeedButton_CopyFrom;
    TSpeedButton *SpeedButton_Property;
    TMenuItem *Property1;
    TSaveDialog *SaveDialog1;
    TCheckBox *CheckBox_CanOccupy;
    TUpDown *UpDown_Fuel;
    TStringGrid *StringGrid_Ground;
    TStringGrid *StringGrid_Target;
    TButton *Button_Ground;
    TGroupBox *GroupBox_Gun;
    TLabel *Label_Move;
    TEdit *Edit_Move;
    TUpDown *UpDown_Move;
    TMenuItem *AttackTable;
    TSpeedButton *SpeedButton_AttackTable;
    TEdit *Edit_Visibility;
    TLabel *Label_Visibility;
    TTabControl *TabControl_Building;
    TCheckListBox *CheckListBox_Building;
    TGroupBox *GroupBox_Supply;
    TCheckBox *CheckBox_SupplySurround;
    TCheckBox *CheckBox_SupplyLoading;
    TCheckBox *CheckBox_OnlyFuel;
    TCheckBox *CheckBox_SupplyLife;
    TLabel *Label_Load;
    TEdit *Edit_Load;
    TTabControl *TabControl_Unit;
    TCheckListBox *CheckListBox_Unit;
    TCheckListBox *CheckListBox_LoadOn;
    TLabel *Label_LoadOn;
    TCheckBox *CheckBox_OnlyTekisaku;
    TTabControl *TabControl_Gun;
    TLabel *Label_MinRange;
    TEdit *Edit_MinRange;
    TUpDown *UpDown_MinRange;
    TLabel *Label_MaxRange;
    TEdit *Edit_MaxRange;
    TUpDown *UpDown_MaxRange;
    TLabel *Label_Gun;
    TEdit *Edit_GunName;
    TLabel *Label_GunMax;
    TEdit *Edit_GunMax;
    TUpDown *UpDown_GunMax;
    TCheckBox *CheckBox_SuperMissile;
    TLabel *Label_GunRadius;
    TEdit *Edit_GunRadius;
    TPopupMenu *PopupMenu_AttackTable;
    TMenuItem *MI_CopyRow;
    TMenuItem *MI_PasteRow;
    TMenuItem *MI_PasteRowMultiple;
    TMenuItem *MI_FillRow;
    TMenuItem *File_N1;
    TMenuItem *File_N2;
    TMenuItem *File_CSV;
    TMenuItem *File_CSV_Import;
    TMenuItem *File_CSV_Export;
    void __fastcall Open1Click(TObject *Sender);
    void __fastcall UpDown_UnitClick(TObject *Sender, TUDBtnType Button);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall Edit_UnitNumChange(TObject *Sender);
    void __fastcall WarningClick(TObject *Sender);
    void __fastcall Form1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall Button_GroundClick(TObject *Sender);
    void __fastcall Button_SetBuildingDefaultClick(TObject *Sender);
    void __fastcall Property1Click(TObject *Sender);
    void __fastcall SaveAs1Click(TObject *Sender);
    void __fastcall Save1Click(TObject *Sender);
    void __fastcall StandardClick(TObject *Sender);
    void __fastcall CopyFromClick(TObject *Sender);
    void __fastcall VersionClick(TObject *Sender);
    void __fastcall Edit_UnitNameChange(TObject *Sender);
    void __fastcall Form1Resize(TObject *Sender);
    void __fastcall AttackTableClick(TObject *Sender);
    void __fastcall TabControl_BuildingChanging(TObject *Sender,
          bool &AllowChange);
    void __fastcall TabControl_BuildingChange(TObject *Sender);

    void __fastcall TabControl_UnitChange(TObject *Sender);
    void __fastcall TabControl_UnitChanging(TObject *Sender,
          bool &AllowChange);
    void __fastcall TabControl_GunChange(TObject *Sender);
    void __fastcall TabControl_GunChanging(TObject *Sender,
          bool &AllowChange);
    
    void __fastcall OnForm1Close(TObject *Sender, TCloseAction &Action);
    void __fastcall OnForm1Show(TObject *Sender);
    void __fastcall File_CSV_ExportClick(TObject *Sender);
    void __fastcall File_CSV_ImportClick(TObject *Sender);
private:	// [U[錾
    TForm_Ground *Form_Ground1;
    TForm_UnitProperty *Form_Property;
    TForm_ViewUnit *Form_ViewUnit1;
    GBWImageData *GBWImage1;
    BaseData *BaseData1;
    SystemStatus *System1;
    TGBWOption Option;
    __fastcall ImageLoad(void);
    __fastcall DrawGroundName(void);
    __fastcall DrawTargetName(void);
    __fastcall ChangeUnitNum(int);
    __fastcall DrawCurrentAll(void);
    __fastcall GetCurrentAll(void);
    __fastcall DrawUnitData(int);
    __fastcall DrawMoveGround(int);
    __fastcall DrawAttackData(int);
//    __fastcall UpdateCheckListBox_Unit(void);
    __fastcall DrawGunProperty(int);
    __fastcall DrawBuildingCheck(int);
    __fastcall DrawUnitCheck(int);
    __fastcall GetUnitData(int);
    __fastcall GetMoveGround(int);
    __fastcall GetAttackData(int);
    __fastcall GetGunProperty(int);
    __fastcall GetBuildingCheck(int);
    __fastcall GetUnitCheck(int);
    __fastcall Rewritable(int);
public:		// [U[錾
    __fastcall TForm1(TComponent* Owner);
    __fastcall ~TForm1(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
class SystemStatus
{
private:
public:
    bool LeftButton;
    bool RightButton;
    bool Modified;
    char EditFile[256];
    int UnitNumber;
    SystemStatus(void){
        LeftButton=RightButton=false;
        Modified=false;
        strcpy(EditFile,NEWFILENAME);
        UnitNumber=0;
    }
};
//---------------------------------------------------------------------------
class AttackTableForm  //U͕\̃tH[
{
private:
    TForm *Formp;
    TPopupMenu *PopupMenu_AttackTable;
    TStringGrid *StringGrid_Attack;
    int VisibleUnits[UNITTYPEMAX];  //\Ă郆jbg̔ԍ
    int VisibleCount;       //\Ă郆jbg̐
    int ButtonDownedRow;
    int RowCopy[256];       //sf[^Rs[̈B
    bool RowCopied;         //Rs[e邩H
    void __fastcall StringGrid_AttackMouseDown(TObject *,TMouseButton,TShiftState,int,int);
    void __fastcall PopupMenu_AttackTablePopup(TObject *Sender);
    void __fastcall MenuItem_CopyRowClicked(TObject *Sender);
    void __fastcall MenuItem_PasteRowClicked(TObject *Sender);
    void __fastcall MenuItem_PasteRowMultipleClicked(TObject *Sender);
    void __fastcall MenuItem_FillRowClicked(TObject *Sender);
    __fastcall PasteRowMultiple(int,int);
public:
    AttackTableForm(TPopupMenu *pmp){
        PopupMenu_AttackTable = pmp;
        RowCopied = false;
    }
    __fastcall Make(TForm *,BaseData *,int,int);
};
//---------------------------------------------------------------------------
class GetValueForm
{
private:
    TForm *Formp;
    TLabel *Label_Message;
    TEdit *Edit_Value;
    TButton *Button_OK,*Button_Cancel;
    void __fastcall Button_OKClick(TObject *Sender);
    void __fastcall Button_CancelClick(TObject *Sender);
public:
    bool Result;
    char Value[256];
    __fastcall GetValueForm(TComponent* Owner);
    __fastcall ~GetValueForm(void);
    __fastcall ShowModal(void);
    __fastcall SetMessage(char *);
    __fastcall SetValue(int);
};
//---------------------------------------------------------------------------
#endif
