//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "status.h"
#include "purpose.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_Status *Form_Status;
//---------------------------------------------------------------------------
__fastcall TForm_Status::TForm_Status(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm_Status::ButtonCloseClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm_Status::Button_Purpose1Click(TObject *Sender)
{
    ShowPurposes(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm_Status::Button_Purpose2Click(TObject *Sender)
{
    ShowPurposes(1);
}
//---------------------------------------------------------------------------

__fastcall TForm_Status::PutStatus(GBWImageData *GBWImagep,bool CPUMode[])
{
    UnionStatusViewer *UnionSV=new UnionStatusViewer();
    char str[100],ContName[2][11]={"vC[","bot"};

    UnionSV->MakeLabels(Image_Blue,Image_Red);
    UnionSV->Show(BaseDatap,Mapp,GBWImagep);

    Label_BlueName->Caption=BaseDatap->SideName[0];
    sprintf(str,"%8d",SideStatusp[0]->Income);
    Label_BlueIncome->Caption=str;
    sprintf(str,"%8d",SideStatusp[0]->Money);
    Label_BlueMoney->Caption=str;
    sprintf(str,"%6d",SideStatusp[0]->UnitCount);
    Label_BlueUnitCount->Caption=str;
    Label_BlueControler->Caption=ContName[(int)CPUMode[0]];
    Button_Purpose1->Enabled=(bool)Purposesp[0]->Enabled();

    Label_RedName->Caption=BaseDatap->SideName[1];
    sprintf(str,"%8d",SideStatusp[1]->Income);
    Label_RedIncome->Caption=str;
    sprintf(str,"%8d",SideStatusp[1]->Money);
    Label_RedMoney->Caption=str;
    sprintf(str,"%6d",SideStatusp[1]->UnitCount);
    Label_RedUnitCount->Caption=str;
    Label_RedControler->Caption=ContName[(int)CPUMode[1]];
    Button_Purpose2->Enabled=(bool)Purposesp[1]->Enabled();

    delete UnionSV;
    return 0;
}
//---------------------------------------------------------------------------

__fastcall TForm_Status::ShowPurposes(int Side)
{
    TForm_Purpose *Dialogp=new TForm_Purpose(this);

    Dialogp->Purposesp=Purposesp[Side];
    Dialogp->BaseDatap=BaseDatap;
    Dialogp->MakeMessage("");
    Dialogp->ShowModal();
    Dialogp->DeleteMessage();
    delete Dialogp;

    return 0;
}
//---------------------------------------------------------------------------

