//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "unitlist.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_UnitList *Form_UnitList;
//---------------------------------------------------------------------------
__fastcall TForm_UnitList::TForm_UnitList(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//IWiseisan.cppB
void __fastcall TForm_UnitList::OnListBox1DrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
    TRect Rect1;

    ListBox1->Canvas->Brush->Color=clWindow;
    ListBox1->Canvas->Font->Color=clBlack;
    if(ListBox1->Selected[Index]){
        if(OldIndex!=-1){   //OIĂACeĕ`
            if(OldIndex==Index && OldIndex<ListBox1->Items->Count-1)
                OldIndex++;   //̏ɂďXN[̕`sBs
            Rect1=Rect;
            Rect1.Top+=(OldIndex-Index)*ListBox1->ItemHeight;
            Rect1.Bottom=Rect1.Top+ListBox1->ItemHeight;
            ListBox1->Canvas->FillRect(Rect1);
            ListUnitPut(ListBox1->Canvas,&Rect1,OldIndex);
        }
        OldIndex=Index;
        ListBox1->Canvas->Brush->Color=clActiveCaption;
        ListBox1->Canvas->Font->Color=clWhite;
        UnitChipPut(Index);
    }
    ListBox1->Canvas->FillRect(Rect);
    ListUnitPut(ListBox1->Canvas,&Rect,Index);
}
//---------------------------------------------------------------------------
//Xg{bNX̃jbgĕ`
__fastcall TForm_UnitList::ListUnitRevise(int Index)
{
    TRect Rect1;

    ListBox1->Canvas->Brush->Color=clWindow;
    ListBox1->Canvas->Font->Color=clBlack;
    if(Index==UnitIndex){
        ListBox1->Canvas->Brush->Color=clActiveCaption;
        ListBox1->Canvas->Font->Color=clWhite;
        UnitChipPut(Index); //IĂ΍ĕ`
    }
    if(Index<ListBox1->TopIndex || Index>ListBox1->TopIndex+ListBox1->Height/ListBox1->ItemHeight)
        return 0;  //\̈̊OȂ牽Ȃ
    Rect1.Top=(Index-ListBox1->TopIndex)*ListBox1->ItemHeight;
    Rect1.Bottom=Rect1.Top+ListBox1->ItemHeight;
    Rect1.Left=0;
    Rect1.Right=ListBox1->Width;
    ListBox1->Canvas->FillRect(Rect1);
    ListUnitPut(ListBox1->Canvas,&Rect1,Index);

    return 0;
}
//---------------------------------------------------------------------------
//Xg{bNX̃jbg`
__fastcall TForm_UnitList::ListUnitPut(TCanvas *Canvasp,TRect *Rectp,int Index)
{
    char str[20];
    int Type,Graph;

    Type=SideStatusp->Unit[Index].Type;
    Graph=Type+Side*UNITTYPEMAX;
    GBWImageDatap->ImageList_UnitN->Draw(Canvasp,Rectp->Left,Rectp->Top,Graph);
    if(SideStatusp->Unit[Index].Actioned)
        GBWImageDatap->ImageList_CursorN->Draw(Canvasp,Rectp->Left,Rectp->Top,CURSOR_END);
    Canvasp->TextOut(Rectp->Left+40,Rectp->Top+6,BaseDatap->UnitInfo[Type].Name);
    sprintf(str,"Life %3d",SideStatusp->Unit[Index].Life);
    Canvasp->TextOut(Rectp->Left+40,Rectp->Top+18,str);

    return 0;
}
//---------------------------------------------------------------------------
//Iꂽjbg\
__fastcall TForm_UnitList::UnitChipPut(int Index)
{
    int Type,Graph;
    char str[100];

    UnitIndex=Index;
    Type=SideStatusp->Unit[Index].Type;
    Graph=Type+Side*UNITTYPEMAX;
    GBWImageDatap->ImageList_UnitN->Draw(Image_Unit->Canvas,0,0,Graph);
    if(SideStatusp->Unit[Index].Actioned)
        GBWImageDatap->ImageList_CursorN->Draw(Image_Unit->Canvas,0,0,CURSOR_END);
    Image_Unit->Refresh();
    Label_UnitName->Caption=BaseDatap->UnitInfo[Type].Name;
    sprintf(str,"Life %2d",SideStatusp->Unit[Index].Life);
    Label_UnitLife->Caption=str;
    sprintf(str,"R %2d",SideStatusp->Unit[Index].Fuel);
    Label_UnitFuel->Caption=str;
    if(BaseDatap->UnitInfo[Type].GunMax[0]){
        sprintf(str,"%-16s %2d",BaseDatap->UnitInfo[Type].GunName[0],SideStatusp->Unit[Index].GunRest[0]);
        Label_UnitGun1->Caption=str;
    }
    else
        Label_UnitGun1->Caption="";
    if(BaseDatap->UnitInfo[Type].GunMax[1]){
        sprintf(str,"%-16s %2d",BaseDatap->UnitInfo[Type].GunName[1],SideStatusp->Unit[Index].GunRest[1]);
        Label_UnitGun2->Caption=str;
    }
    else
        Label_UnitGun2->Caption="";
    ButtonOK->Enabled=true;
    return 0;
}
//---------------------------------------------------------------------------
//Xg{bNXւ̃ACe̓o^
__fastcall TForm_UnitList::MakeList(void)
{
    int i;
    char str[10];

    Image_Unit->Canvas->Brush->Color=clWindow;
    Image_Unit->Canvas->FillRect(Image_Unit->ClientRect);
    Label_UnitName->Caption="";
    Label_UnitLife->Caption="";
    Label_UnitFuel->Caption="";
    Label_UnitGun1->Caption="";
    Label_UnitGun2->Caption="";
    ButtonOK->Enabled=false;
    ListBox1->Clear();
    for(i=0;i<SideStatusp->UnitCount;i++){
        itoa(i,str,10);
        ListBox1->Items->Add(AnsiString(str));
    }
    UnitIndex=-1;
    OldIndex=-1;
    Result=false;
    return 0;
}
//---------------------------------------------------------------------------
//샆jbgiォ牺ցj
void __fastcall TForm_UnitList::ButtonNextClick(TObject *Sender)
{
/*  
    int i,j=-1;

    for(i=UnitIndex+1;i<SideStatusp->UnitCount;i++)
        if(!SideStatusp->Unit[i].Actioned){
            j=i;
            break;
        }
    if(j==-1)
        for(i=0;i<=UnitIndex;i++)
            if(!SideStatusp->Unit[i].Actioned){
                j=i;
                break;
            }
    if(j!=-1)
        ListBox1->ItemIndex=j;
*/
    int i;

    i=SideStatusp->SearchNoActioned(UnitIndex+1);
    if(i!=-1)
        ListBox1->ItemIndex=i;
}
//---------------------------------------------------------------------------

void __fastcall TForm_UnitList::ButtonOKClick(TObject *Sender)
{
    if(NoModal)
        Form1p->ShowLookup(UnitIndex);
    else{
        Result=true;
        Close();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm_UnitList::ButtonCancelClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm_UnitList::OnFormResize(TObject *Sender)
{
    Width=360;
    Panel1->Height=Height-59;
    ButtonNext->Top=Height-52;
    ButtonOK->Top=Height-52;
    ButtonCancel->Top=Height-52;
}
//---------------------------------------------------------------------------

