//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <string.h>

#include "unitview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_ViewUnit *Form_ViewUnit;
//---------------------------------------------------------------------------
__fastcall TForm_ViewUnit::TForm_ViewUnit(TComponent* Owner)
    : TForm(Owner)
{
    BaseDataTmp = new BaseData();
    GBWImageTmp = new GBWImageData();
    OtherFile = false;
}
//---------------------------------------------------------------------------
__fastcall TForm_ViewUnit::~TForm_ViewUnit(void)
{
    delete BaseDataTmp;
    delete GBWImageTmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm_ViewUnit::Edit_UnitChange(TObject *Sender)
{
    Selected = UpDown_Unit->Position;
    if(OtherFile){
        GBWImagep->ImageList_CursorN->Draw(Image_Unit->Canvas,0,0,CURSOR_NULL);
        GBWImageTmp->ImageList_UnitN->Draw(Image_Unit->Canvas,0,0,Selected);
    }
    else{
//        ImageList_Unitp->Draw(Image_Unit->Canvas,0,0,Selected);
        GBWImagep->DrawUnitCanvas(Image_Unit->Canvas,Selected);
    }
    Image_Unit->Refresh();
    Label_UnitName->Caption = BaseDataTmp->UnitInfo[Selected].Name;
}
//---------------------------------------------------------------------------
//pXQƏ
void __fastcall TForm_ViewUnit::Button_BrowseClick(TObject *Sender)
{
    PathBrowser browser;
    char str[256];

    strcpy(str,Edit_Path->Text.c_str());
    if(browser.Execute(this,"GBWgƯ̧ (*.uni)|*.uni","uni",str)){
        Edit_Path->Text = str;
        ReadFromOtherFile();
    }
}
//---------------------------------------------------------------------------
__fastcall TForm_ViewUnit::SetDataPointer(BaseData *base,GBWImageData *img)
{
    BaseDatap = base;
    GBWImagep = img;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_ViewUnit::LoadDefaultImage(int pixelFormat)
{
    GBWImageTmp->Load(pixelFormat);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_ViewUnit::GetSelectedUnitChip(UnitChip *chip)
{
    *chip = BaseDataTmp->UnitInfo[Selected];
    return 0;
}
//---------------------------------------------------------------------------
// ̃t@CꎞIɓǂށB
__fastcall TForm_ViewUnit::ReadFromOtherFile(void)
{
    char file[256],grpfile[256];
    int i;

    strcpy(file, Edit_Path->Text.c_str());
    // ǂݍ݂ɎsҏW̃f[^Rs[B
    if(file[0]=='\0' || BaseDataTmp->ReadUser(file) == -1){
        *BaseDataTmp = *BaseDatap;
        return 0;
    }
    //jbgt@C̓ǂݍ݂ɐ
    //OtBbNt@Cw肳ĂΓǂݍ
    if(BaseDataTmp->UserBitmapFile[0] != '\0'){
        strcpy(grpfile,Edit_Path->Text.c_str());
        i = strlen(grpfile);
        while(i>=0 && grpfile[i]!= '\\')
            i--;
        grpfile[i+1] = '\0';
        strcat(grpfile,BaseDataTmp->UserBitmapFile);
        //摜t@Cǂݍ߂΂g
        if(!GBWImageTmp->LoadUserExtend(grpfile,BaseDataTmp->Sides,BaseDataTmp->UnitGrpGet));
            OtherFile = true;
    }
    else
        OtherFile = true;
    return 0;
}
//---------------------------------------------------------------------------

